#lang reader (submod "classes-prep.rkt" reader)

# LineBreak-7.0.0.txt
# Date: 2014-02-28, 23:15:00 GMT [KW, LI]
#
# Line_Break Property
#
# This file is a normative contributory data file in the
# Unicode Character Database.
# It contains both normative and informative data.
#
# Copyright (c) 1991-2014 Unicode, Inc.
# For terms of use, see http://www.unicode.org/terms_of_use.html
#
# The format is two fields separated by a semicolon.
# Field 0: Unicode code point value or range of code point values
# Field 1: Line_Break property, consisting of one of the following values:
#   Normative:
#         "BK", "CR", "LF", "CM", "SG", "GL", "CB", "SP", "ZW",
#         "NL", "WJ", "JL", "JV", "JT", "H2", "H3"
#   Informative:
#         "XX", "OP", "CL", "CP", "QU", "NS", "EX", "SY",
#         "IS", "PR", "PO", "NU", "AL", "ID", "IN", "HY",
#         "BB", "BA", "SA", "AI", "B2", "HL", "CJ", "RI"
#  - All code points, assigned and unassigned, that are not listed
#         explicitly are given the value "XX".
# The unassigned code points that default to "ID" include ranges in the
# following blocks:
#     CJK Unified Ideographs Extension A:       U+3400..U+4DBF
#     CJK Unified Ideographs:                   U+4E00..U+9FFF
#     CJK Compatibility Ideographs:             U+F900..U+FAFF
#     CJK Unified Ideographs Extension B:      U+20000..U+2A6DF
#     CJK Unified Ideographs Extension C:      U+2A700..U+2B73F
#     CJK Unified Ideographs Extension D:      U+2B740..U+2B81F
#     CJK Compatibility Ideographs Supplement: U+2F800..U+2FA1F
#     and any other reserved code points on
#         Planes 2 and 3:                      U+20000..U+2FFFD
#                                              U+30000..U+3FFFD
# The unassigned code points that default to "PR" comprise a range in the
# following block:
#     Currency Symbols:                         U+20A0..U+20CF
#  - Character ranges are specified as for other property files in
#         the Unicode Character Database.
#
# For legacy reasons, there are no spaces before or after the semicolon
# which separates the two fields. The comments following the number sign
# "#" list the General_Category property value or the L& alias of the
# derived value LC, the Unicode character name or names, and, in lines
# with ranges of code points, the code point count in square brackets.
#
# For more information, see UAX #14: Unicode Line Breaking Algorithm,
# at http://www.unicode.org/reports/tr14/
#
# @missing: 0000..10FFFF; XX
0000..0008;CM     # Cc     [9] <control-0000>..<control-0008>
0009;BA           # Cc         <control-0009>
000A;LF           # Cc         <control-000A>
000B..000C;BK     # Cc     [2] <control-000B>..<control-000C>
000D;CR           # Cc         <control-000D>
000E..001F;CM     # Cc    [18] <control-000E>..<control-001F>
0020;SP           # Zs         SPACE
0021;EX           # Po         EXCLAMATION MARK
0022;QU           # Po         QUOTATION MARK
0023;AL           # Po         NUMBER SIGN
0024;PR           # Sc         DOLLAR SIGN
0025;PO           # Po         PERCENT SIGN
0026;AL           # Po         AMPERSAND
0027;QU           # Po         APOSTROPHE
0028;OP           # Ps         LEFT PARENTHESIS
0029;CP           # Pe         RIGHT PARENTHESIS
002A;AL           # Po         ASTERISK
002B;PR           # Sm         PLUS SIGN
002C;IS           # Po         COMMA
002D;HY           # Pd         HYPHEN-MINUS
002E;IS           # Po         FULL STOP
002F;SY           # Po         SOLIDUS
0030..0039;NU     # Nd    [10] DIGIT ZERO..DIGIT NINE
003A..003B;IS     # Po     [2] COLON..SEMICOLON
003C..003E;AL     # Sm     [3] LESS-THAN SIGN..GREATER-THAN SIGN
003F;EX           # Po         QUESTION MARK
0040;AL           # Po         COMMERCIAL AT
0041..005A;AL     # Lu    [26] LATIN CAPITAL LETTER A..LATIN CAPITAL LETTER Z
005B;OP           # Ps         LEFT SQUARE BRACKET
005C;PR           # Po         REVERSE SOLIDUS
005D;CP           # Pe         RIGHT SQUARE BRACKET
005E;AL           # Sk         CIRCUMFLEX ACCENT
005F;AL           # Pc         LOW LINE
0060;AL           # Sk         GRAVE ACCENT
0061..007A;AL     # Ll    [26] LATIN SMALL LETTER A..LATIN SMALL LETTER Z
007B;OP           # Ps         LEFT CURLY BRACKET
007C;BA           # Sm         VERTICAL LINE
007D;CL           # Pe         RIGHT CURLY BRACKET
007E;AL           # Sm         TILDE
007F;CM           # Cc         <control-007F>
0080..0084;CM     # Cc     [5] <control-0080>..<control-0084>
0085;NL           # Cc         <control-0085>
0086..009F;CM     # Cc    [26] <control-0086>..<control-009F>
00A0;GL           # Zs         NO-BREAK SPACE
00A1;OP           # Po         INVERTED EXCLAMATION MARK
00A2;PO           # Sc         CENT SIGN
00A3..00A5;PR     # Sc     [3] POUND SIGN..YEN SIGN
00A6;AL           # So         BROKEN BAR
00A7;AI           # Po         SECTION SIGN
00A8;AI           # Sk         DIAERESIS
00A9;AL           # So         COPYRIGHT SIGN
00AA;AI           # Lo         FEMININE ORDINAL INDICATOR
00AB;QU           # Pi         LEFT-POINTING DOUBLE ANGLE QUOTATION MARK
00AC;AL           # Sm         NOT SIGN
00AD;BA           # Cf         SOFT HYPHEN
00AE;AL           # So         REGISTERED SIGN
00AF;AL           # Sk         MACRON
00B0;PO           # So         DEGREE SIGN
00B1;PR           # Sm         PLUS-MINUS SIGN
00B2..00B3;AI     # No     [2] SUPERSCRIPT TWO..SUPERSCRIPT THREE
00B4;BB           # Sk         ACUTE ACCENT
00B5;AL           # Ll         MICRO SIGN
00B6..00B7;AI     # Po     [2] PILCROW SIGN..MIDDLE DOT
00B8;AI           # Sk         CEDILLA
00B9;AI           # No         SUPERSCRIPT ONE
00BA;AI           # Lo         MASCULINE ORDINAL INDICATOR
00BB;QU           # Pf         RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK
00BC..00BE;AI     # No     [3] VULGAR FRACTION ONE QUARTER..VULGAR FRACTION THREE QUARTERS
00BF;OP           # Po         INVERTED QUESTION MARK
00C0..00D6;AL     # Lu    [23] LATIN CAPITAL LETTER A WITH GRAVE..LATIN CAPITAL LETTER O WITH DIAERESIS
00D7;AI           # Sm         MULTIPLICATION SIGN
00D8..00F6;AL     # L&    [31] LATIN CAPITAL LETTER O WITH STROKE..LATIN SMALL LETTER O WITH DIAERESIS
00F7;AI           # Sm         DIVISION SIGN
00F8..00FF;AL     # L&     [8] LATIN SMALL LETTER O WITH STROKE..LATIN SMALL LETTER Y WITH DIAERESIS
0100..017F;AL     # L&   [128] LATIN CAPITAL LETTER A WITH MACRON..LATIN SMALL LETTER LONG S
0180..01BA;AL     # L&    [59] LATIN SMALL LETTER B WITH STROKE..LATIN SMALL LETTER EZH WITH TAIL
01BB;AL           # Lo         LATIN LETTER TWO WITH STROKE
01BC..01BF;AL     # L&     [4] LATIN CAPITAL LETTER TONE FIVE..LATIN LETTER WYNN
01C0..01C3;AL     # Lo     [4] LATIN LETTER DENTAL CLICK..LATIN LETTER RETROFLEX CLICK
01C4..024F;AL     # L&   [140] LATIN CAPITAL LETTER DZ WITH CARON..LATIN SMALL LETTER Y WITH STROKE
0250..0293;AL     # Ll    [68] LATIN SMALL LETTER TURNED A..LATIN SMALL LETTER EZH WITH CURL
0294;AL           # Lo         LATIN LETTER GLOTTAL STOP
0295..02AF;AL     # Ll    [27] LATIN LETTER PHARYNGEAL VOICED FRICATIVE..LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL
02B0..02C1;AL     # Lm    [18] MODIFIER LETTER SMALL H..MODIFIER LETTER REVERSED GLOTTAL STOP
02C2..02C5;AL     # Sk     [4] MODIFIER LETTER LEFT ARROWHEAD..MODIFIER LETTER DOWN ARROWHEAD
02C6;AL           # Lm         MODIFIER LETTER CIRCUMFLEX ACCENT
02C7;AI           # Lm         CARON
02C8;BB           # Lm         MODIFIER LETTER VERTICAL LINE
02C9..02CB;AI     # Lm     [3] MODIFIER LETTER MACRON..MODIFIER LETTER GRAVE ACCENT
02CC;BB           # Lm         MODIFIER LETTER LOW VERTICAL LINE
02CD;AI           # Lm         MODIFIER LETTER LOW MACRON
02CE..02CF;AL     # Lm     [2] MODIFIER LETTER LOW GRAVE ACCENT..MODIFIER LETTER LOW ACUTE ACCENT
02D0;AI           # Lm         MODIFIER LETTER TRIANGULAR COLON
02D1;AL           # Lm         MODIFIER LETTER HALF TRIANGULAR COLON
02D2..02D7;AL     # Sk     [6] MODIFIER LETTER CENTRED RIGHT HALF RING..MODIFIER LETTER MINUS SIGN
02D8..02DB;AI     # Sk     [4] BREVE..OGONEK
02DC;AL           # Sk         SMALL TILDE
02DD;AI           # Sk         DOUBLE ACUTE ACCENT
02DE;AL           # Sk         MODIFIER LETTER RHOTIC HOOK
02DF;BB           # Sk         MODIFIER LETTER CROSS ACCENT
02E0..02E4;AL     # Lm     [5] MODIFIER LETTER SMALL GAMMA..MODIFIER LETTER SMALL REVERSED GLOTTAL STOP
02E5..02EB;AL     # Sk     [7] MODIFIER LETTER EXTRA-HIGH TONE BAR..MODIFIER LETTER YANG DEPARTING TONE MARK
02EC;AL           # Lm         MODIFIER LETTER VOICING
02ED;AL           # Sk         MODIFIER LETTER UNASPIRATED
02EE;AL           # Lm         MODIFIER LETTER DOUBLE APOSTROPHE
02EF..02FF;AL     # Sk    [17] MODIFIER LETTER LOW DOWN ARROWHEAD..MODIFIER LETTER LOW LEFT ARROW
0300..034E;CM     # Mn    [79] COMBINING GRAVE ACCENT..COMBINING UPWARDS ARROW BELOW
034F;GL           # Mn         COMBINING GRAPHEME JOINER
0350..035B;CM     # Mn    [12] COMBINING RIGHT ARROWHEAD ABOVE..COMBINING ZIGZAG ABOVE
035C..0362;GL     # Mn     [7] COMBINING DOUBLE BREVE BELOW..COMBINING DOUBLE RIGHTWARDS ARROW BELOW
0363..036F;CM     # Mn    [13] COMBINING LATIN SMALL LETTER A..COMBINING LATIN SMALL LETTER X
0370..0373;AL     # L&     [4] GREEK CAPITAL LETTER HETA..GREEK SMALL LETTER ARCHAIC SAMPI
0374;AL           # Lm         GREEK NUMERAL SIGN
0375;AL           # Sk         GREEK LOWER NUMERAL SIGN
0376..0377;AL     # L&     [2] GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA..GREEK SMALL LETTER PAMPHYLIAN DIGAMMA
037A;AL           # Lm         GREEK YPOGEGRAMMENI
037B..037D;AL     # Ll     [3] GREEK SMALL REVERSED LUNATE SIGMA SYMBOL..GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL
037E;IS           # Po         GREEK QUESTION MARK
037F;AL           # Lu         GREEK CAPITAL LETTER YOT
0384..0385;AL     # Sk     [2] GREEK TONOS..GREEK DIALYTIKA TONOS
0386;AL           # Lu         GREEK CAPITAL LETTER ALPHA WITH TONOS
0387;AL           # Po         GREEK ANO TELEIA
0388..038A;AL     # Lu     [3] GREEK CAPITAL LETTER EPSILON WITH TONOS..GREEK CAPITAL LETTER IOTA WITH TONOS
038C;AL           # Lu         GREEK CAPITAL LETTER OMICRON WITH TONOS
038E..03A1;AL     # L&    [20] GREEK CAPITAL LETTER UPSILON WITH TONOS..GREEK CAPITAL LETTER RHO
03A3..03F5;AL     # L&    [83] GREEK CAPITAL LETTER SIGMA..GREEK LUNATE EPSILON SYMBOL
03F6;AL           # Sm         GREEK REVERSED LUNATE EPSILON SYMBOL
03F7..03FF;AL     # L&     [9] GREEK CAPITAL LETTER SHO..GREEK CAPITAL REVERSED DOTTED LUNATE SIGMA SYMBOL
0400..0481;AL     # L&   [130] CYRILLIC CAPITAL LETTER IE WITH GRAVE..CYRILLIC SMALL LETTER KOPPA
0482;AL           # So         CYRILLIC THOUSANDS SIGN
0483..0487;CM     # Mn     [5] COMBINING CYRILLIC TITLO..COMBINING CYRILLIC POKRYTIE
0488..0489;CM     # Me     [2] COMBINING CYRILLIC HUNDRED THOUSANDS SIGN..COMBINING CYRILLIC MILLIONS SIGN
048A..04FF;AL     # L&   [118] CYRILLIC CAPITAL LETTER SHORT I WITH TAIL..CYRILLIC SMALL LETTER HA WITH STROKE
0500..052F;AL     # L&    [48] CYRILLIC CAPITAL LETTER KOMI DE..CYRILLIC SMALL LETTER EL WITH DESCENDER
0531..0556;AL     # Lu    [38] ARMENIAN CAPITAL LETTER AYB..ARMENIAN CAPITAL LETTER FEH
0559;AL           # Lm         ARMENIAN MODIFIER LETTER LEFT HALF RING
055A..055F;AL     # Po     [6] ARMENIAN APOSTROPHE..ARMENIAN ABBREVIATION MARK
0561..0587;AL     # Ll    [39] ARMENIAN SMALL LETTER AYB..ARMENIAN SMALL LIGATURE ECH YIWN
0589;IS           # Po         ARMENIAN FULL STOP
058A;BA           # Pd         ARMENIAN HYPHEN
058D..058E;AL     # So     [2] RIGHT-FACING ARMENIAN ETERNITY SIGN..LEFT-FACING ARMENIAN ETERNITY SIGN
058F;PR           # Sc         ARMENIAN DRAM SIGN
0591..05BD;CM     # Mn    [45] HEBREW ACCENT ETNAHTA..HEBREW POINT METEG
05BE;BA           # Pd         HEBREW PUNCTUATION MAQAF
05BF;CM           # Mn         HEBREW POINT RAFE
05C0;AL           # Po         HEBREW PUNCTUATION PASEQ
05C1..05C2;CM     # Mn     [2] HEBREW POINT SHIN DOT..HEBREW POINT SIN DOT
05C3;AL           # Po         HEBREW PUNCTUATION SOF PASUQ
05C4..05C5;CM     # Mn     [2] HEBREW MARK UPPER DOT..HEBREW MARK LOWER DOT
05C6;EX           # Po         HEBREW PUNCTUATION NUN HAFUKHA
05C7;CM           # Mn         HEBREW POINT QAMATS QATAN
05D0..05EA;HL     # Lo    [27] HEBREW LETTER ALEF..HEBREW LETTER TAV
05F0..05F2;HL     # Lo     [3] HEBREW LIGATURE YIDDISH DOUBLE VAV..HEBREW LIGATURE YIDDISH DOUBLE YOD
05F3..05F4;AL     # Po     [2] HEBREW PUNCTUATION GERESH..HEBREW PUNCTUATION GERSHAYIM
0600..0605;AL     # Cf     [6] ARABIC NUMBER SIGN..ARABIC NUMBER MARK ABOVE
0606..0608;AL     # Sm     [3] ARABIC-INDIC CUBE ROOT..ARABIC RAY
0609..060A;PO     # Po     [2] ARABIC-INDIC PER MILLE SIGN..ARABIC-INDIC PER TEN THOUSAND SIGN
060B;PO           # Sc         AFGHANI SIGN
060C..060D;IS     # Po     [2] ARABIC COMMA..ARABIC DATE SEPARATOR
060E..060F;AL     # So     [2] ARABIC POETIC VERSE SIGN..ARABIC SIGN MISRA
0610..061A;CM     # Mn    [11] ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM..ARABIC SMALL KASRA
061B;EX           # Po         ARABIC SEMICOLON
061C;CM           # Cf         ARABIC LETTER MARK
061E..061F;EX     # Po     [2] ARABIC TRIPLE DOT PUNCTUATION MARK..ARABIC QUESTION MARK
0620..063F;AL     # Lo    [32] ARABIC LETTER KASHMIRI YEH..ARABIC LETTER FARSI YEH WITH THREE DOTS ABOVE
0640;AL           # Lm         ARABIC TATWEEL
0641..064A;AL     # Lo    [10] ARABIC LETTER FEH..ARABIC LETTER YEH
064B..065F;CM     # Mn    [21] ARABIC FATHATAN..ARABIC WAVY HAMZA BELOW
0660..0669;NU     # Nd    [10] ARABIC-INDIC DIGIT ZERO..ARABIC-INDIC DIGIT NINE
066A;PO           # Po         ARABIC PERCENT SIGN
066B..066C;NU     # Po     [2] ARABIC DECIMAL SEPARATOR..ARABIC THOUSANDS SEPARATOR
066D;AL           # Po         ARABIC FIVE POINTED STAR
066E..066F;AL     # Lo     [2] ARABIC LETTER DOTLESS BEH..ARABIC LETTER DOTLESS QAF
0670;CM           # Mn         ARABIC LETTER SUPERSCRIPT ALEF
0671..06D3;AL     # Lo    [99] ARABIC LETTER ALEF WASLA..ARABIC LETTER YEH BARREE WITH HAMZA ABOVE
06D4;EX           # Po         ARABIC FULL STOP
06D5;AL           # Lo         ARABIC LETTER AE
06D6..06DC;CM     # Mn     [7] ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA..ARABIC SMALL HIGH SEEN
06DD;AL           # Cf         ARABIC END OF AYAH
06DE;AL           # So         ARABIC START OF RUB EL HIZB
06DF..06E4;CM     # Mn     [6] ARABIC SMALL HIGH ROUNDED ZERO..ARABIC SMALL HIGH MADDA
06E5..06E6;AL     # Lm     [2] ARABIC SMALL WAW..ARABIC SMALL YEH
06E7..06E8;CM     # Mn     [2] ARABIC SMALL HIGH YEH..ARABIC SMALL HIGH NOON
06E9;AL           # So         ARABIC PLACE OF SAJDAH
06EA..06ED;CM     # Mn     [4] ARABIC EMPTY CENTRE LOW STOP..ARABIC SMALL LOW MEEM
06EE..06EF;AL     # Lo     [2] ARABIC LETTER DAL WITH INVERTED V..ARABIC LETTER REH WITH INVERTED V
06F0..06F9;NU     # Nd    [10] EXTENDED ARABIC-INDIC DIGIT ZERO..EXTENDED ARABIC-INDIC DIGIT NINE
06FA..06FC;AL     # Lo     [3] ARABIC LETTER SHEEN WITH DOT BELOW..ARABIC LETTER GHAIN WITH DOT BELOW
06FD..06FE;AL     # So     [2] ARABIC SIGN SINDHI AMPERSAND..ARABIC SIGN SINDHI POSTPOSITION MEN
06FF;AL           # Lo         ARABIC LETTER HEH WITH INVERTED V
0700..070D;AL     # Po    [14] SYRIAC END OF PARAGRAPH..SYRIAC HARKLEAN ASTERISCUS
070F;AL           # Cf         SYRIAC ABBREVIATION MARK
0710;AL           # Lo         SYRIAC LETTER ALAPH
0711;CM           # Mn         SYRIAC LETTER SUPERSCRIPT ALAPH
0712..072F;AL     # Lo    [30] SYRIAC LETTER BETH..SYRIAC LETTER PERSIAN DHALATH
0730..074A;CM     # Mn    [27] SYRIAC PTHAHA ABOVE..SYRIAC BARREKH
074D..074F;AL     # Lo     [3] SYRIAC LETTER SOGDIAN ZHAIN..SYRIAC LETTER SOGDIAN FE
0750..077F;AL     # Lo    [48] ARABIC LETTER BEH WITH THREE DOTS HORIZONTALLY BELOW..ARABIC LETTER KAF WITH TWO DOTS ABOVE
0780..07A5;AL     # Lo    [38] THAANA LETTER HAA..THAANA LETTER WAAVU
07A6..07B0;CM     # Mn    [11] THAANA ABAFILI..THAANA SUKUN
07B1;AL           # Lo         THAANA LETTER NAA
07C0..07C9;NU     # Nd    [10] NKO DIGIT ZERO..NKO DIGIT NINE
07CA..07EA;AL     # Lo    [33] NKO LETTER A..NKO LETTER JONA RA
07EB..07F3;CM     # Mn     [9] NKO COMBINING SHORT HIGH TONE..NKO COMBINING DOUBLE DOT ABOVE
07F4..07F5;AL     # Lm     [2] NKO HIGH TONE APOSTROPHE..NKO LOW TONE APOSTROPHE
07F6;AL           # So         NKO SYMBOL OO DENNEN
07F7;AL           # Po         NKO SYMBOL GBAKURUNEN
07F8;IS           # Po         NKO COMMA
07F9;EX           # Po         NKO EXCLAMATION MARK
07FA;AL           # Lm         NKO LAJANYALAN
0800..0815;AL     # Lo    [22] SAMARITAN LETTER ALAF..SAMARITAN LETTER TAAF
0816..0819;CM     # Mn     [4] SAMARITAN MARK IN..SAMARITAN MARK DAGESH
081A;AL           # Lm         SAMARITAN MODIFIER LETTER EPENTHETIC YUT
081B..0823;CM     # Mn     [9] SAMARITAN MARK EPENTHETIC YUT..SAMARITAN VOWEL SIGN A
0824;AL           # Lm         SAMARITAN MODIFIER LETTER SHORT A
0825..0827;CM     # Mn     [3] SAMARITAN VOWEL SIGN SHORT A..SAMARITAN VOWEL SIGN U
0828;AL           # Lm         SAMARITAN MODIFIER LETTER I
0829..082D;CM     # Mn     [5] SAMARITAN VOWEL SIGN LONG I..SAMARITAN MARK NEQUDAA
0830..083E;AL     # Po    [15] SAMARITAN PUNCTUATION NEQUDAA..SAMARITAN PUNCTUATION ANNAAU
0840..0858;AL     # Lo    [25] MANDAIC LETTER HALQA..MANDAIC LETTER AIN
0859..085B;CM     # Mn     [3] MANDAIC AFFRICATION MARK..MANDAIC GEMINATION MARK
085E;AL           # Po         MANDAIC PUNCTUATION
08A0..08B2;AL     # Lo    [19] ARABIC LETTER BEH WITH SMALL V BELOW..ARABIC LETTER ZAIN WITH INVERTED V ABOVE
08E4..08FF;CM     # Mn    [28] ARABIC CURLY FATHA..ARABIC MARK SIDEWAYS NOON GHUNNA
0900..0902;CM     # Mn     [3] DEVANAGARI SIGN INVERTED CANDRABINDU..DEVANAGARI SIGN ANUSVARA
0903;CM           # Mc         DEVANAGARI SIGN VISARGA
0904..0939;AL     # Lo    [54] DEVANAGARI LETTER SHORT A..DEVANAGARI LETTER HA
093A;CM           # Mn         DEVANAGARI VOWEL SIGN OE
093B;CM           # Mc         DEVANAGARI VOWEL SIGN OOE
093C;CM           # Mn         DEVANAGARI SIGN NUKTA
093D;AL           # Lo         DEVANAGARI SIGN AVAGRAHA
093E..0940;CM     # Mc     [3] DEVANAGARI VOWEL SIGN AA..DEVANAGARI VOWEL SIGN II
0941..0948;CM     # Mn     [8] DEVANAGARI VOWEL SIGN U..DEVANAGARI VOWEL SIGN AI
0949..094C;CM     # Mc     [4] DEVANAGARI VOWEL SIGN CANDRA O..DEVANAGARI VOWEL SIGN AU
094D;CM           # Mn         DEVANAGARI SIGN VIRAMA
094E..094F;CM     # Mc     [2] DEVANAGARI VOWEL SIGN PRISHTHAMATRA E..DEVANAGARI VOWEL SIGN AW
0950;AL           # Lo         DEVANAGARI OM
0951..0957;CM     # Mn     [7] DEVANAGARI STRESS SIGN UDATTA..DEVANAGARI VOWEL SIGN UUE
0958..0961;AL     # Lo    [10] DEVANAGARI LETTER QA..DEVANAGARI LETTER VOCALIC LL
0962..0963;CM     # Mn     [2] DEVANAGARI VOWEL SIGN VOCALIC L..DEVANAGARI VOWEL SIGN VOCALIC LL
0964..0965;BA     # Po     [2] DEVANAGARI DANDA..DEVANAGARI DOUBLE DANDA
0966..096F;NU     # Nd    [10] DEVANAGARI DIGIT ZERO..DEVANAGARI DIGIT NINE
0970;AL           # Po         DEVANAGARI ABBREVIATION SIGN
0971;AL           # Lm         DEVANAGARI SIGN HIGH SPACING DOT
0972..097F;AL     # Lo    [14] DEVANAGARI LETTER CANDRA A..DEVANAGARI LETTER BBA
0980;AL           # Lo         BENGALI ANJI
0981;CM           # Mn         BENGALI SIGN CANDRABINDU
0982..0983;CM     # Mc     [2] BENGALI SIGN ANUSVARA..BENGALI SIGN VISARGA
0985..098C;AL     # Lo     [8] BENGALI LETTER A..BENGALI LETTER VOCALIC L
098F..0990;AL     # Lo     [2] BENGALI LETTER E..BENGALI LETTER AI
0993..09A8;AL     # Lo    [22] BENGALI LETTER O..BENGALI LETTER NA
09AA..09B0;AL     # Lo     [7] BENGALI LETTER PA..BENGALI LETTER RA
09B2;AL           # Lo         BENGALI LETTER LA
09B6..09B9;AL     # Lo     [4] BENGALI LETTER SHA..BENGALI LETTER HA
09BC;CM           # Mn         BENGALI SIGN NUKTA
09BD;AL           # Lo         BENGALI SIGN AVAGRAHA
09BE..09C0;CM     # Mc     [3] BENGALI VOWEL SIGN AA..BENGALI VOWEL SIGN II
09C1..09C4;CM     # Mn     [4] BENGALI VOWEL SIGN U..BENGALI VOWEL SIGN VOCALIC RR
09C7..09C8;CM     # Mc     [2] BENGALI VOWEL SIGN E..BENGALI VOWEL SIGN AI
09CB..09CC;CM     # Mc     [2] BENGALI VOWEL SIGN O..BENGALI VOWEL SIGN AU
09CD;CM           # Mn         BENGALI SIGN VIRAMA
09CE;AL           # Lo         BENGALI LETTER KHANDA TA
09D7;CM           # Mc         BENGALI AU LENGTH MARK
09DC..09DD;AL     # Lo     [2] BENGALI LETTER RRA..BENGALI LETTER RHA
09DF..09E1;AL     # Lo     [3] BENGALI LETTER YYA..BENGALI LETTER VOCALIC LL
09E2..09E3;CM     # Mn     [2] BENGALI VOWEL SIGN VOCALIC L..BENGALI VOWEL SIGN VOCALIC LL
09E6..09EF;NU     # Nd    [10] BENGALI DIGIT ZERO..BENGALI DIGIT NINE
09F0..09F1;AL     # Lo     [2] BENGALI LETTER RA WITH MIDDLE DIAGONAL..BENGALI LETTER RA WITH LOWER DIAGONAL
09F2..09F3;PO     # Sc     [2] BENGALI RUPEE MARK..BENGALI RUPEE SIGN
09F4..09F8;AL     # No     [5] BENGALI CURRENCY NUMERATOR ONE..BENGALI CURRENCY NUMERATOR ONE LESS THAN THE DENOMINATOR
09F9;PO           # No         BENGALI CURRENCY DENOMINATOR SIXTEEN
09FA;AL           # So         BENGALI ISSHAR
09FB;PR           # Sc         BENGALI GANDA MARK
0A01..0A02;CM     # Mn     [2] GURMUKHI SIGN ADAK BINDI..GURMUKHI SIGN BINDI
0A03;CM           # Mc         GURMUKHI SIGN VISARGA
0A05..0A0A;AL     # Lo     [6] GURMUKHI LETTER A..GURMUKHI LETTER UU
0A0F..0A10;AL     # Lo     [2] GURMUKHI LETTER EE..GURMUKHI LETTER AI
0A13..0A28;AL     # Lo    [22] GURMUKHI LETTER OO..GURMUKHI LETTER NA
0A2A..0A30;AL     # Lo     [7] GURMUKHI LETTER PA..GURMUKHI LETTER RA
0A32..0A33;AL     # Lo     [2] GURMUKHI LETTER LA..GURMUKHI LETTER LLA
0A35..0A36;AL     # Lo     [2] GURMUKHI LETTER VA..GURMUKHI LETTER SHA
0A38..0A39;AL     # Lo     [2] GURMUKHI LETTER SA..GURMUKHI LETTER HA
0A3C;CM           # Mn         GURMUKHI SIGN NUKTA
0A3E..0A40;CM     # Mc     [3] GURMUKHI VOWEL SIGN AA..GURMUKHI VOWEL SIGN II
0A41..0A42;CM     # Mn     [2] GURMUKHI VOWEL SIGN U..GURMUKHI VOWEL SIGN UU
0A47..0A48;CM     # Mn     [2] GURMUKHI VOWEL SIGN EE..GURMUKHI VOWEL SIGN AI
0A4B..0A4D;CM     # Mn     [3] GURMUKHI VOWEL SIGN OO..GURMUKHI SIGN VIRAMA
0A51;CM           # Mn         GURMUKHI SIGN UDAAT
0A59..0A5C;AL     # Lo     [4] GURMUKHI LETTER KHHA..GURMUKHI LETTER RRA
0A5E;AL           # Lo         GURMUKHI LETTER FA
0A66..0A6F;NU     # Nd    [10] GURMUKHI DIGIT ZERO..GURMUKHI DIGIT NINE
0A70..0A71;CM     # Mn     [2] GURMUKHI TIPPI..GURMUKHI ADDAK
0A72..0A74;AL     # Lo     [3] GURMUKHI IRI..GURMUKHI EK ONKAR
0A75;CM           # Mn         GURMUKHI SIGN YAKASH
0A81..0A82;CM     # Mn     [2] GUJARATI SIGN CANDRABINDU..GUJARATI SIGN ANUSVARA
0A83;CM           # Mc         GUJARATI SIGN VISARGA
0A85..0A8D;AL     # Lo     [9] GUJARATI LETTER A..GUJARATI VOWEL CANDRA E
0A8F..0A91;AL     # Lo     [3] GUJARATI LETTER E..GUJARATI VOWEL CANDRA O
0A93..0AA8;AL     # Lo    [22] GUJARATI LETTER O..GUJARATI LETTER NA
0AAA..0AB0;AL     # Lo     [7] GUJARATI LETTER PA..GUJARATI LETTER RA
0AB2..0AB3;AL     # Lo     [2] GUJARATI LETTER LA..GUJARATI LETTER LLA
0AB5..0AB9;AL     # Lo     [5] GUJARATI LETTER VA..GUJARATI LETTER HA
0ABC;CM           # Mn         GUJARATI SIGN NUKTA
0ABD;AL           # Lo         GUJARATI SIGN AVAGRAHA
0ABE..0AC0;CM     # Mc     [3] GUJARATI VOWEL SIGN AA..GUJARATI VOWEL SIGN II
0AC1..0AC5;CM     # Mn     [5] GUJARATI VOWEL SIGN U..GUJARATI VOWEL SIGN CANDRA E
0AC7..0AC8;CM     # Mn     [2] GUJARATI VOWEL SIGN E..GUJARATI VOWEL SIGN AI
0AC9;CM           # Mc         GUJARATI VOWEL SIGN CANDRA O
0ACB..0ACC;CM     # Mc     [2] GUJARATI VOWEL SIGN O..GUJARATI VOWEL SIGN AU
0ACD;CM           # Mn         GUJARATI SIGN VIRAMA
0AD0;AL           # Lo         GUJARATI OM
0AE0..0AE1;AL     # Lo     [2] GUJARATI LETTER VOCALIC RR..GUJARATI LETTER VOCALIC LL
0AE2..0AE3;CM     # Mn     [2] GUJARATI VOWEL SIGN VOCALIC L..GUJARATI VOWEL SIGN VOCALIC LL
0AE6..0AEF;NU     # Nd    [10] GUJARATI DIGIT ZERO..GUJARATI DIGIT NINE
0AF0;AL           # Po         GUJARATI ABBREVIATION SIGN
0AF1;PR           # Sc         GUJARATI RUPEE SIGN
0B01;CM           # Mn         ORIYA SIGN CANDRABINDU
0B02..0B03;CM     # Mc     [2] ORIYA SIGN ANUSVARA..ORIYA SIGN VISARGA
0B05..0B0C;AL     # Lo     [8] ORIYA LETTER A..ORIYA LETTER VOCALIC L
0B0F..0B10;AL     # Lo     [2] ORIYA LETTER E..ORIYA LETTER AI
0B13..0B28;AL     # Lo    [22] ORIYA LETTER O..ORIYA LETTER NA
0B2A..0B30;AL     # Lo     [7] ORIYA LETTER PA..ORIYA LETTER RA
0B32..0B33;AL     # Lo     [2] ORIYA LETTER LA..ORIYA LETTER LLA
0B35..0B39;AL     # Lo     [5] ORIYA LETTER VA..ORIYA LETTER HA
0B3C;CM           # Mn         ORIYA SIGN NUKTA
0B3D;AL           # Lo         ORIYA SIGN AVAGRAHA
0B3E;CM           # Mc         ORIYA VOWEL SIGN AA
0B3F;CM           # Mn         ORIYA VOWEL SIGN I
0B40;CM           # Mc         ORIYA VOWEL SIGN II
0B41..0B44;CM     # Mn     [4] ORIYA VOWEL SIGN U..ORIYA VOWEL SIGN VOCALIC RR
0B47..0B48;CM     # Mc     [2] ORIYA VOWEL SIGN E..ORIYA VOWEL SIGN AI
0B4B..0B4C;CM     # Mc     [2] ORIYA VOWEL SIGN O..ORIYA VOWEL SIGN AU
0B4D;CM           # Mn         ORIYA SIGN VIRAMA
0B56;CM           # Mn         ORIYA AI LENGTH MARK
0B57;CM           # Mc         ORIYA AU LENGTH MARK
0B5C..0B5D;AL     # Lo     [2] ORIYA LETTER RRA..ORIYA LETTER RHA
0B5F..0B61;AL     # Lo     [3] ORIYA LETTER YYA..ORIYA LETTER VOCALIC LL
0B62..0B63;CM     # Mn     [2] ORIYA VOWEL SIGN VOCALIC L..ORIYA VOWEL SIGN VOCALIC LL
0B66..0B6F;NU     # Nd    [10] ORIYA DIGIT ZERO..ORIYA DIGIT NINE
0B70;AL           # So         ORIYA ISSHAR
0B71;AL           # Lo         ORIYA LETTER WA
0B72..0B77;AL     # No     [6] ORIYA FRACTION ONE QUARTER..ORIYA FRACTION THREE SIXTEENTHS
0B82;CM           # Mn         TAMIL SIGN ANUSVARA
0B83;AL           # Lo         TAMIL SIGN VISARGA
0B85..0B8A;AL     # Lo     [6] TAMIL LETTER A..TAMIL LETTER UU
0B8E..0B90;AL     # Lo     [3] TAMIL LETTER E..TAMIL LETTER AI
0B92..0B95;AL     # Lo     [4] TAMIL LETTER O..TAMIL LETTER KA
0B99..0B9A;AL     # Lo     [2] TAMIL LETTER NGA..TAMIL LETTER CA
0B9C;AL           # Lo         TAMIL LETTER JA
0B9E..0B9F;AL     # Lo     [2] TAMIL LETTER NYA..TAMIL LETTER TTA
0BA3..0BA4;AL     # Lo     [2] TAMIL LETTER NNA..TAMIL LETTER TA
0BA8..0BAA;AL     # Lo     [3] TAMIL LETTER NA..TAMIL LETTER PA
0BAE..0BB9;AL     # Lo    [12] TAMIL LETTER MA..TAMIL LETTER HA
0BBE..0BBF;CM     # Mc     [2] TAMIL VOWEL SIGN AA..TAMIL VOWEL SIGN I
0BC0;CM           # Mn         TAMIL VOWEL SIGN II
0BC1..0BC2;CM     # Mc     [2] TAMIL VOWEL SIGN U..TAMIL VOWEL SIGN UU
0BC6..0BC8;CM     # Mc     [3] TAMIL VOWEL SIGN E..TAMIL VOWEL SIGN AI
0BCA..0BCC;CM     # Mc     [3] TAMIL VOWEL SIGN O..TAMIL VOWEL SIGN AU
0BCD;CM           # Mn         TAMIL SIGN VIRAMA
0BD0;AL           # Lo         TAMIL OM
0BD7;CM           # Mc         TAMIL AU LENGTH MARK
0BE6..0BEF;NU     # Nd    [10] TAMIL DIGIT ZERO..TAMIL DIGIT NINE
0BF0..0BF2;AL     # No     [3] TAMIL NUMBER TEN..TAMIL NUMBER ONE THOUSAND
0BF3..0BF8;AL     # So     [6] TAMIL DAY SIGN..TAMIL AS ABOVE SIGN
0BF9;PR           # Sc         TAMIL RUPEE SIGN
0BFA;AL           # So         TAMIL NUMBER SIGN
0C00;CM           # Mn         TELUGU SIGN COMBINING CANDRABINDU ABOVE
0C01..0C03;CM     # Mc     [3] TELUGU SIGN CANDRABINDU..TELUGU SIGN VISARGA
0C05..0C0C;AL     # Lo     [8] TELUGU LETTER A..TELUGU LETTER VOCALIC L
0C0E..0C10;AL     # Lo     [3] TELUGU LETTER E..TELUGU LETTER AI
0C12..0C28;AL     # Lo    [23] TELUGU LETTER O..TELUGU LETTER NA
0C2A..0C39;AL     # Lo    [16] TELUGU LETTER PA..TELUGU LETTER HA
0C3D;AL           # Lo         TELUGU SIGN AVAGRAHA
0C3E..0C40;CM     # Mn     [3] TELUGU VOWEL SIGN AA..TELUGU VOWEL SIGN II
0C41..0C44;CM     # Mc     [4] TELUGU VOWEL SIGN U..TELUGU VOWEL SIGN VOCALIC RR
0C46..0C48;CM     # Mn     [3] TELUGU VOWEL SIGN E..TELUGU VOWEL SIGN AI
0C4A..0C4D;CM     # Mn     [4] TELUGU VOWEL SIGN O..TELUGU SIGN VIRAMA
0C55..0C56;CM     # Mn     [2] TELUGU LENGTH MARK..TELUGU AI LENGTH MARK
0C58..0C59;AL     # Lo     [2] TELUGU LETTER TSA..TELUGU LETTER DZA
0C60..0C61;AL     # Lo     [2] TELUGU LETTER VOCALIC RR..TELUGU LETTER VOCALIC LL
0C62..0C63;CM     # Mn     [2] TELUGU VOWEL SIGN VOCALIC L..TELUGU VOWEL SIGN VOCALIC LL
0C66..0C6F;NU     # Nd    [10] TELUGU DIGIT ZERO..TELUGU DIGIT NINE
0C78..0C7E;AL     # No     [7] TELUGU FRACTION DIGIT ZERO FOR ODD POWERS OF FOUR..TELUGU FRACTION DIGIT THREE FOR EVEN POWERS OF FOUR
0C7F;AL           # So         TELUGU SIGN TUUMU
0C81;CM           # Mn         KANNADA SIGN CANDRABINDU
0C82..0C83;CM     # Mc     [2] KANNADA SIGN ANUSVARA..KANNADA SIGN VISARGA
0C85..0C8C;AL     # Lo     [8] KANNADA LETTER A..KANNADA LETTER VOCALIC L
0C8E..0C90;AL     # Lo     [3] KANNADA LETTER E..KANNADA LETTER AI
0C92..0CA8;AL     # Lo    [23] KANNADA LETTER O..KANNADA LETTER NA
0CAA..0CB3;AL     # Lo    [10] KANNADA LETTER PA..KANNADA LETTER LLA
0CB5..0CB9;AL     # Lo     [5] KANNADA LETTER VA..KANNADA LETTER HA
0CBC;CM           # Mn         KANNADA SIGN NUKTA
0CBD;AL           # Lo         KANNADA SIGN AVAGRAHA
0CBE;CM           # Mc         KANNADA VOWEL SIGN AA
0CBF;CM           # Mn         KANNADA VOWEL SIGN I
0CC0..0CC4;CM     # Mc     [5] KANNADA VOWEL SIGN II..KANNADA VOWEL SIGN VOCALIC RR
0CC6;CM           # Mn         KANNADA VOWEL SIGN E
0CC7..0CC8;CM     # Mc     [2] KANNADA VOWEL SIGN EE..KANNADA VOWEL SIGN AI
0CCA..0CCB;CM     # Mc     [2] KANNADA VOWEL SIGN O..KANNADA VOWEL SIGN OO
0CCC..0CCD;CM     # Mn     [2] KANNADA VOWEL SIGN AU..KANNADA SIGN VIRAMA
0CD5..0CD6;CM     # Mc     [2] KANNADA LENGTH MARK..KANNADA AI LENGTH MARK
0CDE;AL           # Lo         KANNADA LETTER FA
0CE0..0CE1;AL     # Lo     [2] KANNADA LETTER VOCALIC RR..KANNADA LETTER VOCALIC LL
0CE2..0CE3;CM     # Mn     [2] KANNADA VOWEL SIGN VOCALIC L..KANNADA VOWEL SIGN VOCALIC LL
0CE6..0CEF;NU     # Nd    [10] KANNADA DIGIT ZERO..KANNADA DIGIT NINE
0CF1..0CF2;AL     # Lo     [2] KANNADA SIGN JIHVAMULIYA..KANNADA SIGN UPADHMANIYA
0D01;CM           # Mn         MALAYALAM SIGN CANDRABINDU
0D02..0D03;CM     # Mc     [2] MALAYALAM SIGN ANUSVARA..MALAYALAM SIGN VISARGA
0D05..0D0C;AL     # Lo     [8] MALAYALAM LETTER A..MALAYALAM LETTER VOCALIC L
0D0E..0D10;AL     # Lo     [3] MALAYALAM LETTER E..MALAYALAM LETTER AI
0D12..0D3A;AL     # Lo    [41] MALAYALAM LETTER O..MALAYALAM LETTER TTTA
0D3D;AL           # Lo         MALAYALAM SIGN AVAGRAHA
0D3E..0D40;CM     # Mc     [3] MALAYALAM VOWEL SIGN AA..MALAYALAM VOWEL SIGN II
0D41..0D44;CM     # Mn     [4] MALAYALAM VOWEL SIGN U..MALAYALAM VOWEL SIGN VOCALIC RR
0D46..0D48;CM     # Mc     [3] MALAYALAM VOWEL SIGN E..MALAYALAM VOWEL SIGN AI
0D4A..0D4C;CM     # Mc     [3] MALAYALAM VOWEL SIGN O..MALAYALAM VOWEL SIGN AU
0D4D;CM           # Mn         MALAYALAM SIGN VIRAMA
0D4E;AL           # Lo         MALAYALAM LETTER DOT REPH
0D57;CM           # Mc         MALAYALAM AU LENGTH MARK
0D60..0D61;AL     # Lo     [2] MALAYALAM LETTER VOCALIC RR..MALAYALAM LETTER VOCALIC LL
0D62..0D63;CM     # Mn     [2] MALAYALAM VOWEL SIGN VOCALIC L..MALAYALAM VOWEL SIGN VOCALIC LL
0D66..0D6F;NU     # Nd    [10] MALAYALAM DIGIT ZERO..MALAYALAM DIGIT NINE
0D70..0D75;AL     # No     [6] MALAYALAM NUMBER TEN..MALAYALAM FRACTION THREE QUARTERS
0D79;PO           # So         MALAYALAM DATE MARK
0D7A..0D7F;AL     # Lo     [6] MALAYALAM LETTER CHILLU NN..MALAYALAM LETTER CHILLU K
0D82..0D83;CM     # Mc     [2] SINHALA SIGN ANUSVARAYA..SINHALA SIGN VISARGAYA
0D85..0D96;AL     # Lo    [18] SINHALA LETTER AYANNA..SINHALA LETTER AUYANNA
0D9A..0DB1;AL     # Lo    [24] SINHALA LETTER ALPAPRAANA KAYANNA..SINHALA LETTER DANTAJA NAYANNA
0DB3..0DBB;AL     # Lo     [9] SINHALA LETTER SANYAKA DAYANNA..SINHALA LETTER RAYANNA
0DBD;AL           # Lo         SINHALA LETTER DANTAJA LAYANNA
0DC0..0DC6;AL     # Lo     [7] SINHALA LETTER VAYANNA..SINHALA LETTER FAYANNA
0DCA;CM           # Mn         SINHALA SIGN AL-LAKUNA
0DCF..0DD1;CM     # Mc     [3] SINHALA VOWEL SIGN AELA-PILLA..SINHALA VOWEL SIGN DIGA AEDA-PILLA
0DD2..0DD4;CM     # Mn     [3] SINHALA VOWEL SIGN KETTI IS-PILLA..SINHALA VOWEL SIGN KETTI PAA-PILLA
0DD6;CM           # Mn         SINHALA VOWEL SIGN DIGA PAA-PILLA
0DD8..0DDF;CM     # Mc     [8] SINHALA VOWEL SIGN GAETTA-PILLA..SINHALA VOWEL SIGN GAYANUKITTA
0DE6..0DEF;NU     # Nd    [10] SINHALA LITH DIGIT ZERO..SINHALA LITH DIGIT NINE
0DF2..0DF3;CM     # Mc     [2] SINHALA VOWEL SIGN DIGA GAETTA-PILLA..SINHALA VOWEL SIGN DIGA GAYANUKITTA
0DF4;AL           # Po         SINHALA PUNCTUATION KUNDDALIYA
0E01..0E30;SA     # Lo    [48] THAI CHARACTER KO KAI..THAI CHARACTER SARA A
0E31;SA           # Mn         THAI CHARACTER MAI HAN-AKAT
0E32..0E33;SA     # Lo     [2] THAI CHARACTER SARA AA..THAI CHARACTER SARA AM
0E34..0E3A;SA     # Mn     [7] THAI CHARACTER SARA I..THAI CHARACTER PHINTHU
0E3F;PR           # Sc         THAI CURRENCY SYMBOL BAHT
0E40..0E45;SA     # Lo     [6] THAI CHARACTER SARA E..THAI CHARACTER LAKKHANGYAO
0E46;SA           # Lm         THAI CHARACTER MAIYAMOK
0E47..0E4E;SA     # Mn     [8] THAI CHARACTER MAITAIKHU..THAI CHARACTER YAMAKKAN
0E4F;AL           # Po         THAI CHARACTER FONGMAN
0E50..0E59;NU     # Nd    [10] THAI DIGIT ZERO..THAI DIGIT NINE
0E5A..0E5B;BA     # Po     [2] THAI CHARACTER ANGKHANKHU..THAI CHARACTER KHOMUT
0E81..0E82;SA     # Lo     [2] LAO LETTER KO..LAO LETTER KHO SUNG
0E84;SA           # Lo         LAO LETTER KHO TAM
0E87..0E88;SA     # Lo     [2] LAO LETTER NGO..LAO LETTER CO
0E8A;SA           # Lo         LAO LETTER SO TAM
0E8D;SA           # Lo         LAO LETTER NYO
0E94..0E97;SA     # Lo     [4] LAO LETTER DO..LAO LETTER THO TAM
0E99..0E9F;SA     # Lo     [7] LAO LETTER NO..LAO LETTER FO SUNG
0EA1..0EA3;SA     # Lo     [3] LAO LETTER MO..LAO LETTER LO LING
0EA5;SA           # Lo         LAO LETTER LO LOOT
0EA7;SA           # Lo         LAO LETTER WO
0EAA..0EAB;SA     # Lo     [2] LAO LETTER SO SUNG..LAO LETTER HO SUNG
0EAD..0EB0;SA     # Lo     [4] LAO LETTER O..LAO VOWEL SIGN A
0EB1;SA           # Mn         LAO VOWEL SIGN MAI KAN
0EB2..0EB3;SA     # Lo     [2] LAO VOWEL SIGN AA..LAO VOWEL SIGN AM
0EB4..0EB9;SA     # Mn     [6] LAO VOWEL SIGN I..LAO VOWEL SIGN UU
0EBB..0EBC;SA     # Mn     [2] LAO VOWEL SIGN MAI KON..LAO SEMIVOWEL SIGN LO
0EBD;SA           # Lo         LAO SEMIVOWEL SIGN NYO
0EC0..0EC4;SA     # Lo     [5] LAO VOWEL SIGN E..LAO VOWEL SIGN AI
0EC6;SA           # Lm         LAO KO LA
0EC8..0ECD;SA     # Mn     [6] LAO TONE MAI EK..LAO NIGGAHITA
0ED0..0ED9;NU     # Nd    [10] LAO DIGIT ZERO..LAO DIGIT NINE
0EDC..0EDF;SA     # Lo     [4] LAO HO NO..LAO LETTER KHMU NYO
0F00;AL           # Lo         TIBETAN SYLLABLE OM
0F01..0F03;BB     # So     [3] TIBETAN MARK GTER YIG MGO TRUNCATED A..TIBETAN MARK GTER YIG MGO -UM GTER TSHEG MA
0F04;BB           # Po         TIBETAN MARK INITIAL YIG MGO MDUN MA
0F05;AL           # Po         TIBETAN MARK CLOSING YIG MGO SGAB MA
0F06..0F07;BB     # Po     [2] TIBETAN MARK CARET YIG MGO PHUR SHAD MA..TIBETAN MARK YIG MGO TSHEG SHAD MA
0F08;GL           # Po         TIBETAN MARK SBRUL SHAD
0F09..0F0A;BB     # Po     [2] TIBETAN MARK BSKUR YIG MGO..TIBETAN MARK BKA- SHOG YIG MGO
0F0B;BA           # Po         TIBETAN MARK INTERSYLLABIC TSHEG
0F0C;GL           # Po         TIBETAN MARK DELIMITER TSHEG BSTAR
0F0D..0F11;EX     # Po     [5] TIBETAN MARK SHAD..TIBETAN MARK RIN CHEN SPUNGS SHAD
0F12;GL           # Po         TIBETAN MARK RGYA GRAM SHAD
0F13;AL           # So         TIBETAN MARK CARET -DZUD RTAGS ME LONG CAN
0F14;EX           # Po         TIBETAN MARK GTER TSHEG
0F15..0F17;AL     # So     [3] TIBETAN LOGOTYPE SIGN CHAD RTAGS..TIBETAN ASTROLOGICAL SIGN SGRA GCAN -CHAR RTAGS
0F18..0F19;CM     # Mn     [2] TIBETAN ASTROLOGICAL SIGN -KHYUD PA..TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS
0F1A..0F1F;AL     # So     [6] TIBETAN SIGN RDEL DKAR GCIG..TIBETAN SIGN RDEL DKAR RDEL NAG
0F20..0F29;NU     # Nd    [10] TIBETAN DIGIT ZERO..TIBETAN DIGIT NINE
0F2A..0F33;AL     # No    [10] TIBETAN DIGIT HALF ONE..TIBETAN DIGIT HALF ZERO
0F34;BA           # So         TIBETAN MARK BSDUS RTAGS
0F35;CM           # Mn         TIBETAN MARK NGAS BZUNG NYI ZLA
0F36;AL           # So         TIBETAN MARK CARET -DZUD RTAGS BZHI MIG CAN
0F37;CM           # Mn         TIBETAN MARK NGAS BZUNG SGOR RTAGS
0F38;AL           # So         TIBETAN MARK CHE MGO
0F39;CM           # Mn         TIBETAN MARK TSA -PHRU
0F3A;OP           # Ps         TIBETAN MARK GUG RTAGS GYON
0F3B;CL           # Pe         TIBETAN MARK GUG RTAGS GYAS
0F3C;OP           # Ps         TIBETAN MARK ANG KHANG GYON
0F3D;CL           # Pe         TIBETAN MARK ANG KHANG GYAS
0F3E..0F3F;CM     # Mc     [2] TIBETAN SIGN YAR TSHES..TIBETAN SIGN MAR TSHES
0F40..0F47;AL     # Lo     [8] TIBETAN LETTER KA..TIBETAN LETTER JA
0F49..0F6C;AL     # Lo    [36] TIBETAN LETTER NYA..TIBETAN LETTER RRA
0F71..0F7E;CM     # Mn    [14] TIBETAN VOWEL SIGN AA..TIBETAN SIGN RJES SU NGA RO
0F7F;BA           # Mc         TIBETAN SIGN RNAM BCAD
0F80..0F84;CM     # Mn     [5] TIBETAN VOWEL SIGN REVERSED I..TIBETAN MARK HALANTA
0F85;BA           # Po         TIBETAN MARK PALUTA
0F86..0F87;CM     # Mn     [2] TIBETAN SIGN LCI RTAGS..TIBETAN SIGN YANG RTAGS
0F88..0F8C;AL     # Lo     [5] TIBETAN SIGN LCE TSA CAN..TIBETAN SIGN INVERTED MCHU CAN
0F8D..0F97;CM     # Mn    [11] TIBETAN SUBJOINED SIGN LCE TSA CAN..TIBETAN SUBJOINED LETTER JA
0F99..0FBC;CM     # Mn    [36] TIBETAN SUBJOINED LETTER NYA..TIBETAN SUBJOINED LETTER FIXED-FORM RA
0FBE..0FBF;BA     # So     [2] TIBETAN KU RU KHA..TIBETAN KU RU KHA BZHI MIG CAN
0FC0..0FC5;AL     # So     [6] TIBETAN CANTILLATION SIGN HEAVY BEAT..TIBETAN SYMBOL RDO RJE
0FC6;CM           # Mn         TIBETAN SYMBOL PADMA GDAN
0FC7..0FCC;AL     # So     [6] TIBETAN SYMBOL RDO RJE RGYA GRAM..TIBETAN SYMBOL NOR BU BZHI -KHYIL
0FCE..0FCF;AL     # So     [2] TIBETAN SIGN RDEL NAG RDEL DKAR..TIBETAN SIGN RDEL NAG GSUM
0FD0..0FD1;BB     # Po     [2] TIBETAN MARK BSKA- SHOG GI MGO RGYAN..TIBETAN MARK MNYAM YIG GI MGO RGYAN
0FD2;BA           # Po         TIBETAN MARK NYIS TSHEG
0FD3;BB           # Po         TIBETAN MARK INITIAL BRDA RNYING YIG MGO MDUN MA
0FD4;AL           # Po         TIBETAN MARK CLOSING BRDA RNYING YIG MGO SGAB MA
0FD5..0FD8;AL     # So     [4] RIGHT-FACING SVASTI SIGN..LEFT-FACING SVASTI SIGN WITH DOTS
0FD9..0FDA;GL     # Po     [2] TIBETAN MARK LEADING MCHAN RTAGS..TIBETAN MARK TRAILING MCHAN RTAGS
1000..102A;SA     # Lo    [43] MYANMAR LETTER KA..MYANMAR LETTER AU
102B..102C;SA     # Mc     [2] MYANMAR VOWEL SIGN TALL AA..MYANMAR VOWEL SIGN AA
102D..1030;SA     # Mn     [4] MYANMAR VOWEL SIGN I..MYANMAR VOWEL SIGN UU
1031;SA           # Mc         MYANMAR VOWEL SIGN E
1032..1037;SA     # Mn     [6] MYANMAR VOWEL SIGN AI..MYANMAR SIGN DOT BELOW
1038;SA           # Mc         MYANMAR SIGN VISARGA
1039..103A;SA     # Mn     [2] MYANMAR SIGN VIRAMA..MYANMAR SIGN ASAT
103B..103C;SA     # Mc     [2] MYANMAR CONSONANT SIGN MEDIAL YA..MYANMAR CONSONANT SIGN MEDIAL RA
103D..103E;SA     # Mn     [2] MYANMAR CONSONANT SIGN MEDIAL WA..MYANMAR CONSONANT SIGN MEDIAL HA
103F;SA           # Lo         MYANMAR LETTER GREAT SA
1040..1049;NU     # Nd    [10] MYANMAR DIGIT ZERO..MYANMAR DIGIT NINE
104A..104B;BA     # Po     [2] MYANMAR SIGN LITTLE SECTION..MYANMAR SIGN SECTION
104C..104F;AL     # Po     [4] MYANMAR SYMBOL LOCATIVE..MYANMAR SYMBOL GENITIVE
1050..1055;SA     # Lo     [6] MYANMAR LETTER SHA..MYANMAR LETTER VOCALIC LL
1056..1057;SA     # Mc     [2] MYANMAR VOWEL SIGN VOCALIC R..MYANMAR VOWEL SIGN VOCALIC RR
1058..1059;SA     # Mn     [2] MYANMAR VOWEL SIGN VOCALIC L..MYANMAR VOWEL SIGN VOCALIC LL
105A..105D;SA     # Lo     [4] MYANMAR LETTER MON NGA..MYANMAR LETTER MON BBE
105E..1060;SA     # Mn     [3] MYANMAR CONSONANT SIGN MON MEDIAL NA..MYANMAR CONSONANT SIGN MON MEDIAL LA
1061;SA           # Lo         MYANMAR LETTER SGAW KAREN SHA
1062..1064;SA     # Mc     [3] MYANMAR VOWEL SIGN SGAW KAREN EU..MYANMAR TONE MARK SGAW KAREN KE PHO
1065..1066;SA     # Lo     [2] MYANMAR LETTER WESTERN PWO KAREN THA..MYANMAR LETTER WESTERN PWO KAREN PWA
1067..106D;SA     # Mc     [7] MYANMAR VOWEL SIGN WESTERN PWO KAREN EU..MYANMAR SIGN WESTERN PWO KAREN TONE-5
106E..1070;SA     # Lo     [3] MYANMAR LETTER EASTERN PWO KAREN NNA..MYANMAR LETTER EASTERN PWO KAREN GHWA
1071..1074;SA     # Mn     [4] MYANMAR VOWEL SIGN GEBA KAREN I..MYANMAR VOWEL SIGN KAYAH EE
1075..1081;SA     # Lo    [13] MYANMAR LETTER SHAN KA..MYANMAR LETTER SHAN HA
1082;SA           # Mn         MYANMAR CONSONANT SIGN SHAN MEDIAL WA
1083..1084;SA     # Mc     [2] MYANMAR VOWEL SIGN SHAN AA..MYANMAR VOWEL SIGN SHAN E
1085..1086;SA     # Mn     [2] MYANMAR VOWEL SIGN SHAN E ABOVE..MYANMAR VOWEL SIGN SHAN FINAL Y
1087..108C;SA     # Mc     [6] MYANMAR SIGN SHAN TONE-2..MYANMAR SIGN SHAN COUNCIL TONE-3
108D;SA           # Mn         MYANMAR SIGN SHAN COUNCIL EMPHATIC TONE
108E;SA           # Lo         MYANMAR LETTER RUMAI PALAUNG FA
108F;SA           # Mc         MYANMAR SIGN RUMAI PALAUNG TONE-5
1090..1099;NU     # Nd    [10] MYANMAR SHAN DIGIT ZERO..MYANMAR SHAN DIGIT NINE
109A..109C;SA     # Mc     [3] MYANMAR SIGN KHAMTI TONE-1..MYANMAR VOWEL SIGN AITON A
109D;SA           # Mn         MYANMAR VOWEL SIGN AITON AI
109E..109F;SA     # So     [2] MYANMAR SYMBOL SHAN ONE..MYANMAR SYMBOL SHAN EXCLAMATION
10A0..10C5;AL     # Lu    [38] GEORGIAN CAPITAL LETTER AN..GEORGIAN CAPITAL LETTER HOE
10C7;AL           # Lu         GEORGIAN CAPITAL LETTER YN
10CD;AL           # Lu         GEORGIAN CAPITAL LETTER AEN
10D0..10FA;AL     # Lo    [43] GEORGIAN LETTER AN..GEORGIAN LETTER AIN
10FB;AL           # Po         GEORGIAN PARAGRAPH SEPARATOR
10FC;AL           # Lm         MODIFIER LETTER GEORGIAN NAR
10FD..10FF;AL     # Lo     [3] GEORGIAN LETTER AEN..GEORGIAN LETTER LABIAL SIGN
1100..115F;JL     # Lo    [96] HANGUL CHOSEONG KIYEOK..HANGUL CHOSEONG FILLER
1160..11A7;JV     # Lo    [72] HANGUL JUNGSEONG FILLER..HANGUL JUNGSEONG O-YAE
11A8..11FF;JT     # Lo    [88] HANGUL JONGSEONG KIYEOK..HANGUL JONGSEONG SSANGNIEUN
1200..1248;AL     # Lo    [73] ETHIOPIC SYLLABLE HA..ETHIOPIC SYLLABLE QWA
124A..124D;AL     # Lo     [4] ETHIOPIC SYLLABLE QWI..ETHIOPIC SYLLABLE QWE
1250..1256;AL     # Lo     [7] ETHIOPIC SYLLABLE QHA..ETHIOPIC SYLLABLE QHO
1258;AL           # Lo         ETHIOPIC SYLLABLE QHWA
125A..125D;AL     # Lo     [4] ETHIOPIC SYLLABLE QHWI..ETHIOPIC SYLLABLE QHWE
1260..1288;AL     # Lo    [41] ETHIOPIC SYLLABLE BA..ETHIOPIC SYLLABLE XWA
128A..128D;AL     # Lo     [4] ETHIOPIC SYLLABLE XWI..ETHIOPIC SYLLABLE XWE
1290..12B0;AL     # Lo    [33] ETHIOPIC SYLLABLE NA..ETHIOPIC SYLLABLE KWA
12B2..12B5;AL     # Lo     [4] ETHIOPIC SYLLABLE KWI..ETHIOPIC SYLLABLE KWE
12B8..12BE;AL     # Lo     [7] ETHIOPIC SYLLABLE KXA..ETHIOPIC SYLLABLE KXO
12C0;AL           # Lo         ETHIOPIC SYLLABLE KXWA
12C2..12C5;AL     # Lo     [4] ETHIOPIC SYLLABLE KXWI..ETHIOPIC SYLLABLE KXWE
12C8..12D6;AL     # Lo    [15] ETHIOPIC SYLLABLE WA..ETHIOPIC SYLLABLE PHARYNGEAL O
12D8..1310;AL     # Lo    [57] ETHIOPIC SYLLABLE ZA..ETHIOPIC SYLLABLE GWA
1312..1315;AL     # Lo     [4] ETHIOPIC SYLLABLE GWI..ETHIOPIC SYLLABLE GWE
1318..135A;AL     # Lo    [67] ETHIOPIC SYLLABLE GGA..ETHIOPIC SYLLABLE FYA
135D..135F;CM     # Mn     [3] ETHIOPIC COMBINING GEMINATION AND VOWEL LENGTH MARK..ETHIOPIC COMBINING GEMINATION MARK
1360;AL           # Po         ETHIOPIC SECTION MARK
1361;BA           # Po         ETHIOPIC WORDSPACE
1362..1368;AL     # Po     [7] ETHIOPIC FULL STOP..ETHIOPIC PARAGRAPH SEPARATOR
1369..137C;AL     # No    [20] ETHIOPIC DIGIT ONE..ETHIOPIC NUMBER TEN THOUSAND
1380..138F;AL     # Lo    [16] ETHIOPIC SYLLABLE SEBATBEIT MWA..ETHIOPIC SYLLABLE PWE
1390..1399;AL     # So    [10] ETHIOPIC TONAL MARK YIZET..ETHIOPIC TONAL MARK KURT
13A0..13F4;AL     # Lo    [85] CHEROKEE LETTER A..CHEROKEE LETTER YV
1400;BA           # Pd         CANADIAN SYLLABICS HYPHEN
1401..166C;AL     # Lo   [620] CANADIAN SYLLABICS E..CANADIAN SYLLABICS CARRIER TTSA
166D..166E;AL     # Po     [2] CANADIAN SYLLABICS CHI SIGN..CANADIAN SYLLABICS FULL STOP
166F..167F;AL     # Lo    [17] CANADIAN SYLLABICS QAI..CANADIAN SYLLABICS BLACKFOOT W
1680;BA           # Zs         OGHAM SPACE MARK
1681..169A;AL     # Lo    [26] OGHAM LETTER BEITH..OGHAM LETTER PEITH
169B;OP           # Ps         OGHAM FEATHER MARK
169C;CL           # Pe         OGHAM REVERSED FEATHER MARK
16A0..16EA;AL     # Lo    [75] RUNIC LETTER FEHU FEOH FE F..RUNIC LETTER X
16EB..16ED;BA     # Po     [3] RUNIC SINGLE PUNCTUATION..RUNIC CROSS PUNCTUATION
16EE..16F0;AL     # Nl     [3] RUNIC ARLAUG SYMBOL..RUNIC BELGTHOR SYMBOL
16F1..16F8;AL     # Lo     [8] RUNIC LETTER K..RUNIC LETTER FRANKS CASKET AESC
1700..170C;AL     # Lo    [13] TAGALOG LETTER A..TAGALOG LETTER YA
170E..1711;AL     # Lo     [4] TAGALOG LETTER LA..TAGALOG LETTER HA
1712..1714;CM     # Mn     [3] TAGALOG VOWEL SIGN I..TAGALOG SIGN VIRAMA
1720..1731;AL     # Lo    [18] HANUNOO LETTER A..HANUNOO LETTER HA
1732..1734;CM     # Mn     [3] HANUNOO VOWEL SIGN I..HANUNOO SIGN PAMUDPOD
1735..1736;BA     # Po     [2] PHILIPPINE SINGLE PUNCTUATION..PHILIPPINE DOUBLE PUNCTUATION
1740..1751;AL     # Lo    [18] BUHID LETTER A..BUHID LETTER HA
1752..1753;CM     # Mn     [2] BUHID VOWEL SIGN I..BUHID VOWEL SIGN U
1760..176C;AL     # Lo    [13] TAGBANWA LETTER A..TAGBANWA LETTER YA
176E..1770;AL     # Lo     [3] TAGBANWA LETTER LA..TAGBANWA LETTER SA
1772..1773;CM     # Mn     [2] TAGBANWA VOWEL SIGN I..TAGBANWA VOWEL SIGN U
1780..17B3;SA     # Lo    [52] KHMER LETTER KA..KHMER INDEPENDENT VOWEL QAU
17B4..17B5;SA     # Mn     [2] KHMER VOWEL INHERENT AQ..KHMER VOWEL INHERENT AA
17B6;SA           # Mc         KHMER VOWEL SIGN AA
17B7..17BD;SA     # Mn     [7] KHMER VOWEL SIGN I..KHMER VOWEL SIGN UA
17BE..17C5;SA     # Mc     [8] KHMER VOWEL SIGN OE..KHMER VOWEL SIGN AU
17C6;SA           # Mn         KHMER SIGN NIKAHIT
17C7..17C8;SA     # Mc     [2] KHMER SIGN REAHMUK..KHMER SIGN YUUKALEAPINTU
17C9..17D3;SA     # Mn    [11] KHMER SIGN MUUSIKATOAN..KHMER SIGN BATHAMASAT
17D4..17D5;BA     # Po     [2] KHMER SIGN KHAN..KHMER SIGN BARIYOOSAN
17D6;NS           # Po         KHMER SIGN CAMNUC PII KUUH
17D7;SA           # Lm         KHMER SIGN LEK TOO
17D8;BA           # Po         KHMER SIGN BEYYAL
17D9;AL           # Po         KHMER SIGN PHNAEK MUAN
17DA;BA           # Po         KHMER SIGN KOOMUUT
17DB;PR           # Sc         KHMER CURRENCY SYMBOL RIEL
17DC;SA           # Lo         KHMER SIGN AVAKRAHASANYA
17DD;SA           # Mn         KHMER SIGN ATTHACAN
17E0..17E9;NU     # Nd    [10] KHMER DIGIT ZERO..KHMER DIGIT NINE
17F0..17F9;AL     # No    [10] KHMER SYMBOL LEK ATTAK SON..KHMER SYMBOL LEK ATTAK PRAM-BUON
1800..1801;AL     # Po     [2] MONGOLIAN BIRGA..MONGOLIAN ELLIPSIS
1802..1803;EX     # Po     [2] MONGOLIAN COMMA..MONGOLIAN FULL STOP
1804..1805;BA     # Po     [2] MONGOLIAN COLON..MONGOLIAN FOUR DOTS
1806;BB           # Pd         MONGOLIAN TODO SOFT HYPHEN
1807;AL           # Po         MONGOLIAN SIBE SYLLABLE BOUNDARY MARKER
1808..1809;EX     # Po     [2] MONGOLIAN MANCHU COMMA..MONGOLIAN MANCHU FULL STOP
180A;AL           # Po         MONGOLIAN NIRUGU
180B..180D;CM     # Mn     [3] MONGOLIAN FREE VARIATION SELECTOR ONE..MONGOLIAN FREE VARIATION SELECTOR THREE
180E;GL           # Cf         MONGOLIAN VOWEL SEPARATOR
1810..1819;NU     # Nd    [10] MONGOLIAN DIGIT ZERO..MONGOLIAN DIGIT NINE
1820..1842;AL     # Lo    [35] MONGOLIAN LETTER A..MONGOLIAN LETTER CHI
1843;AL           # Lm         MONGOLIAN LETTER TODO LONG VOWEL SIGN
1844..1877;AL     # Lo    [52] MONGOLIAN LETTER TODO E..MONGOLIAN LETTER MANCHU ZHA
1880..18A8;AL     # Lo    [41] MONGOLIAN LETTER ALI GALI ANUSVARA ONE..MONGOLIAN LETTER MANCHU ALI GALI BHA
18A9;CM           # Mn         MONGOLIAN LETTER ALI GALI DAGALGA
18AA;AL           # Lo         MONGOLIAN LETTER MANCHU ALI GALI LHA
18B0..18F5;AL     # Lo    [70] CANADIAN SYLLABICS OY..CANADIAN SYLLABICS CARRIER DENTAL S
1900..191E;AL     # Lo    [31] LIMBU VOWEL-CARRIER LETTER..LIMBU LETTER TRA
1920..1922;CM     # Mn     [3] LIMBU VOWEL SIGN A..LIMBU VOWEL SIGN U
1923..1926;CM     # Mc     [4] LIMBU VOWEL SIGN EE..LIMBU VOWEL SIGN AU
1927..1928;CM     # Mn     [2] LIMBU VOWEL SIGN E..LIMBU VOWEL SIGN O
1929..192B;CM     # Mc     [3] LIMBU SUBJOINED LETTER YA..LIMBU SUBJOINED LETTER WA
1930..1931;CM     # Mc     [2] LIMBU SMALL LETTER KA..LIMBU SMALL LETTER NGA
1932;CM           # Mn         LIMBU SMALL LETTER ANUSVARA
1933..1938;CM     # Mc     [6] LIMBU SMALL LETTER TA..LIMBU SMALL LETTER LA
1939..193B;CM     # Mn     [3] LIMBU SIGN MUKPHRENG..LIMBU SIGN SA-I
1940;AL           # So         LIMBU SIGN LOO
1944..1945;EX     # Po     [2] LIMBU EXCLAMATION MARK..LIMBU QUESTION MARK
1946..194F;NU     # Nd    [10] LIMBU DIGIT ZERO..LIMBU DIGIT NINE
1950..196D;SA     # Lo    [30] TAI LE LETTER KA..TAI LE LETTER AI
1970..1974;SA     # Lo     [5] TAI LE LETTER TONE-2..TAI LE LETTER TONE-6
1980..19AB;SA     # Lo    [44] NEW TAI LUE LETTER HIGH QA..NEW TAI LUE LETTER LOW SUA
19B0..19C0;SA     # Mc    [17] NEW TAI LUE VOWEL SIGN VOWEL SHORTENER..NEW TAI LUE VOWEL SIGN IY
19C1..19C7;SA     # Lo     [7] NEW TAI LUE LETTER FINAL V..NEW TAI LUE LETTER FINAL B
19C8..19C9;SA     # Mc     [2] NEW TAI LUE TONE MARK-1..NEW TAI LUE TONE MARK-2
19D0..19D9;NU     # Nd    [10] NEW TAI LUE DIGIT ZERO..NEW TAI LUE DIGIT NINE
19DA;SA           # No         NEW TAI LUE THAM DIGIT ONE
19DE..19DF;SA     # So     [2] NEW TAI LUE SIGN LAE..NEW TAI LUE SIGN LAEV
19E0..19FF;AL     # So    [32] KHMER SYMBOL PATHAMASAT..KHMER SYMBOL DAP-PRAM ROC
1A00..1A16;AL     # Lo    [23] BUGINESE LETTER KA..BUGINESE LETTER HA
1A17..1A18;CM     # Mn     [2] BUGINESE VOWEL SIGN I..BUGINESE VOWEL SIGN U
1A19..1A1A;CM     # Mc     [2] BUGINESE VOWEL SIGN E..BUGINESE VOWEL SIGN O
1A1B;CM           # Mn         BUGINESE VOWEL SIGN AE
1A1E..1A1F;AL     # Po     [2] BUGINESE PALLAWA..BUGINESE END OF SECTION
1A20..1A54;SA     # Lo    [53] TAI THAM LETTER HIGH KA..TAI THAM LETTER GREAT SA
1A55;SA           # Mc         TAI THAM CONSONANT SIGN MEDIAL RA
1A56;SA           # Mn         TAI THAM CONSONANT SIGN MEDIAL LA
1A57;SA           # Mc         TAI THAM CONSONANT SIGN LA TANG LAI
1A58..1A5E;SA     # Mn     [7] TAI THAM SIGN MAI KANG LAI..TAI THAM CONSONANT SIGN SA
1A60;SA           # Mn         TAI THAM SIGN SAKOT
1A61;SA           # Mc         TAI THAM VOWEL SIGN A
1A62;SA           # Mn         TAI THAM VOWEL SIGN MAI SAT
1A63..1A64;SA     # Mc     [2] TAI THAM VOWEL SIGN AA..TAI THAM VOWEL SIGN TALL AA
1A65..1A6C;SA     # Mn     [8] TAI THAM VOWEL SIGN I..TAI THAM VOWEL SIGN OA BELOW
1A6D..1A72;SA     # Mc     [6] TAI THAM VOWEL SIGN OY..TAI THAM VOWEL SIGN THAM AI
1A73..1A7C;SA     # Mn    [10] TAI THAM VOWEL SIGN OA ABOVE..TAI THAM SIGN KHUEN-LUE KARAN
1A7F;CM           # Mn         TAI THAM COMBINING CRYPTOGRAMMIC DOT
1A80..1A89;NU     # Nd    [10] TAI THAM HORA DIGIT ZERO..TAI THAM HORA DIGIT NINE
1A90..1A99;NU     # Nd    [10] TAI THAM THAM DIGIT ZERO..TAI THAM THAM DIGIT NINE
1AA0..1AA6;SA     # Po     [7] TAI THAM SIGN WIANG..TAI THAM SIGN REVERSED ROTATED RANA
1AA7;SA           # Lm         TAI THAM SIGN MAI YAMOK
1AA8..1AAD;SA     # Po     [6] TAI THAM SIGN KAAN..TAI THAM SIGN CAANG
1AB0..1ABD;CM     # Mn    [14] COMBINING DOUBLED CIRCUMFLEX ACCENT..COMBINING PARENTHESES BELOW
1ABE;CM           # Me         COMBINING PARENTHESES OVERLAY
1B00..1B03;CM     # Mn     [4] BALINESE SIGN ULU RICEM..BALINESE SIGN SURANG
1B04;CM           # Mc         BALINESE SIGN BISAH
1B05..1B33;AL     # Lo    [47] BALINESE LETTER AKARA..BALINESE LETTER HA
1B34;CM           # Mn         BALINESE SIGN REREKAN
1B35;CM           # Mc         BALINESE VOWEL SIGN TEDUNG
1B36..1B3A;CM     # Mn     [5] BALINESE VOWEL SIGN ULU..BALINESE VOWEL SIGN RA REPA
1B3B;CM           # Mc         BALINESE VOWEL SIGN RA REPA TEDUNG
1B3C;CM           # Mn         BALINESE VOWEL SIGN LA LENGA
1B3D..1B41;CM     # Mc     [5] BALINESE VOWEL SIGN LA LENGA TEDUNG..BALINESE VOWEL SIGN TALING REPA TEDUNG
1B42;CM           # Mn         BALINESE VOWEL SIGN PEPET
1B43..1B44;CM     # Mc     [2] BALINESE VOWEL SIGN PEPET TEDUNG..BALINESE ADEG ADEG
1B45..1B4B;AL     # Lo     [7] BALINESE LETTER KAF SASAK..BALINESE LETTER ASYURA SASAK
1B50..1B59;NU     # Nd    [10] BALINESE DIGIT ZERO..BALINESE DIGIT NINE
1B5A..1B5B;BA     # Po     [2] BALINESE PANTI..BALINESE PAMADA
1B5C;AL           # Po         BALINESE WINDU
1B5D..1B60;BA     # Po     [4] BALINESE CARIK PAMUNGKAH..BALINESE PAMENENG
1B61..1B6A;AL     # So    [10] BALINESE MUSICAL SYMBOL DONG..BALINESE MUSICAL SYMBOL DANG GEDE
1B6B..1B73;CM     # Mn     [9] BALINESE MUSICAL SYMBOL COMBINING TEGEH..BALINESE MUSICAL SYMBOL COMBINING GONG
1B74..1B7C;AL     # So     [9] BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DUG..BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PING
1B80..1B81;CM     # Mn     [2] SUNDANESE SIGN PANYECEK..SUNDANESE SIGN PANGLAYAR
1B82;CM           # Mc         SUNDANESE SIGN PANGWISAD
1B83..1BA0;AL     # Lo    [30] SUNDANESE LETTER A..SUNDANESE LETTER HA
1BA1;CM           # Mc         SUNDANESE CONSONANT SIGN PAMINGKAL
1BA2..1BA5;CM     # Mn     [4] SUNDANESE CONSONANT SIGN PANYAKRA..SUNDANESE VOWEL SIGN PANYUKU
1BA6..1BA7;CM     # Mc     [2] SUNDANESE VOWEL SIGN PANAELAENG..SUNDANESE VOWEL SIGN PANOLONG
1BA8..1BA9;CM     # Mn     [2] SUNDANESE VOWEL SIGN PAMEPET..SUNDANESE VOWEL SIGN PANEULEUNG
1BAA;CM           # Mc         SUNDANESE SIGN PAMAAEH
1BAB..1BAD;CM     # Mn     [3] SUNDANESE SIGN VIRAMA..SUNDANESE CONSONANT SIGN PASANGAN WA
1BAE..1BAF;AL     # Lo     [2] SUNDANESE LETTER KHA..SUNDANESE LETTER SYA
1BB0..1BB9;NU     # Nd    [10] SUNDANESE DIGIT ZERO..SUNDANESE DIGIT NINE
1BBA..1BBF;AL     # Lo     [6] SUNDANESE AVAGRAHA..SUNDANESE LETTER FINAL M
1BC0..1BE5;AL     # Lo    [38] BATAK LETTER A..BATAK LETTER U
1BE6;CM           # Mn         BATAK SIGN TOMPI
1BE7;CM           # Mc         BATAK VOWEL SIGN E
1BE8..1BE9;CM     # Mn     [2] BATAK VOWEL SIGN PAKPAK E..BATAK VOWEL SIGN EE
1BEA..1BEC;CM     # Mc     [3] BATAK VOWEL SIGN I..BATAK VOWEL SIGN O
1BED;CM           # Mn         BATAK VOWEL SIGN KARO O
1BEE;CM           # Mc         BATAK VOWEL SIGN U
1BEF..1BF1;CM     # Mn     [3] BATAK VOWEL SIGN U FOR SIMALUNGUN SA..BATAK CONSONANT SIGN H
1BF2..1BF3;CM     # Mc     [2] BATAK PANGOLAT..BATAK PANONGONAN
1BFC..1BFF;AL     # Po     [4] BATAK SYMBOL BINDU NA METEK..BATAK SYMBOL BINDU PANGOLAT
1C00..1C23;AL     # Lo    [36] LEPCHA LETTER KA..LEPCHA LETTER A
1C24..1C2B;CM     # Mc     [8] LEPCHA SUBJOINED LETTER YA..LEPCHA VOWEL SIGN UU
1C2C..1C33;CM     # Mn     [8] LEPCHA VOWEL SIGN E..LEPCHA CONSONANT SIGN T
1C34..1C35;CM     # Mc     [2] LEPCHA CONSONANT SIGN NYIN-DO..LEPCHA CONSONANT SIGN KANG
1C36..1C37;CM     # Mn     [2] LEPCHA SIGN RAN..LEPCHA SIGN NUKTA
1C3B..1C3F;BA     # Po     [5] LEPCHA PUNCTUATION TA-ROL..LEPCHA PUNCTUATION TSHOOK
1C40..1C49;NU     # Nd    [10] LEPCHA DIGIT ZERO..LEPCHA DIGIT NINE
1C4D..1C4F;AL     # Lo     [3] LEPCHA LETTER TTA..LEPCHA LETTER DDA
1C50..1C59;NU     # Nd    [10] OL CHIKI DIGIT ZERO..OL CHIKI DIGIT NINE
1C5A..1C77;AL     # Lo    [30] OL CHIKI LETTER LA..OL CHIKI LETTER OH
1C78..1C7D;AL     # Lm     [6] OL CHIKI MU TTUDDAG..OL CHIKI AHAD
1C7E..1C7F;BA     # Po     [2] OL CHIKI PUNCTUATION MUCAAD..OL CHIKI PUNCTUATION DOUBLE MUCAAD
1CC0..1CC7;AL     # Po     [8] SUNDANESE PUNCTUATION BINDU SURYA..SUNDANESE PUNCTUATION BINDU BA SATANGA
1CD0..1CD2;CM     # Mn     [3] VEDIC TONE KARSHANA..VEDIC TONE PRENKHA
1CD3;AL           # Po         VEDIC SIGN NIHSHVASA
1CD4..1CE0;CM     # Mn    [13] VEDIC SIGN YAJURVEDIC MIDLINE SVARITA..VEDIC TONE RIGVEDIC KASHMIRI INDEPENDENT SVARITA
1CE1;CM           # Mc         VEDIC TONE ATHARVAVEDIC INDEPENDENT SVARITA
1CE2..1CE8;CM     # Mn     [7] VEDIC SIGN VISARGA SVARITA..VEDIC SIGN VISARGA ANUDATTA WITH TAIL
1CE9..1CEC;AL     # Lo     [4] VEDIC SIGN ANUSVARA ANTARGOMUKHA..VEDIC SIGN ANUSVARA VAMAGOMUKHA WITH TAIL
1CED;CM           # Mn         VEDIC SIGN TIRYAK
1CEE..1CF1;AL     # Lo     [4] VEDIC SIGN HEXIFORM LONG ANUSVARA..VEDIC SIGN ANUSVARA UBHAYATO MUKHA
1CF2..1CF3;CM     # Mc     [2] VEDIC SIGN ARDHAVISARGA..VEDIC SIGN ROTATED ARDHAVISARGA
1CF4;CM           # Mn         VEDIC TONE CANDRA ABOVE
1CF5..1CF6;AL     # Lo     [2] VEDIC SIGN JIHVAMULIYA..VEDIC SIGN UPADHMANIYA
1CF8..1CF9;CM     # Mn     [2] VEDIC TONE RING ABOVE..VEDIC TONE DOUBLE RING ABOVE
1D00..1D2B;AL     # Ll    [44] LATIN LETTER SMALL CAPITAL A..CYRILLIC LETTER SMALL CAPITAL EL
1D2C..1D6A;AL     # Lm    [63] MODIFIER LETTER CAPITAL A..GREEK SUBSCRIPT SMALL LETTER CHI
1D6B..1D77;AL     # Ll    [13] LATIN SMALL LETTER UE..LATIN SMALL LETTER TURNED G
1D78;AL           # Lm         MODIFIER LETTER CYRILLIC EN
1D79..1D7F;AL     # Ll     [7] LATIN SMALL LETTER INSULAR G..LATIN SMALL LETTER UPSILON WITH STROKE
1D80..1D9A;AL     # Ll    [27] LATIN SMALL LETTER B WITH PALATAL HOOK..LATIN SMALL LETTER EZH WITH RETROFLEX HOOK
1D9B..1DBF;AL     # Lm    [37] MODIFIER LETTER SMALL TURNED ALPHA..MODIFIER LETTER SMALL THETA
1DC0..1DF5;CM     # Mn    [54] COMBINING DOTTED GRAVE ACCENT..COMBINING UP TACK ABOVE
1DFC..1DFF;CM     # Mn     [4] COMBINING DOUBLE INVERTED BREVE BELOW..COMBINING RIGHT ARROWHEAD AND DOWN ARROWHEAD BELOW
1E00..1EFF;AL     # L&   [256] LATIN CAPITAL LETTER A WITH RING BELOW..LATIN SMALL LETTER Y WITH LOOP
1F00..1F15;AL     # L&    [22] GREEK SMALL LETTER ALPHA WITH PSILI..GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA
1F18..1F1D;AL     # Lu     [6] GREEK CAPITAL LETTER EPSILON WITH PSILI..GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA
1F20..1F45;AL     # L&    [38] GREEK SMALL LETTER ETA WITH PSILI..GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA
1F48..1F4D;AL     # Lu     [6] GREEK CAPITAL LETTER OMICRON WITH PSILI..GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA
1F50..1F57;AL     # Ll     [8] GREEK SMALL LETTER UPSILON WITH PSILI..GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI
1F59;AL           # Lu         GREEK CAPITAL LETTER UPSILON WITH DASIA
1F5B;AL           # Lu         GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA
1F5D;AL           # Lu         GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA
1F5F..1F7D;AL     # L&    [31] GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI..GREEK SMALL LETTER OMEGA WITH OXIA
1F80..1FB4;AL     # L&    [53] GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI..GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI
1FB6..1FBC;AL     # L&     [7] GREEK SMALL LETTER ALPHA WITH PERISPOMENI..GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI
1FBD;AL           # Sk         GREEK KORONIS
1FBE;AL           # Ll         GREEK PROSGEGRAMMENI
1FBF..1FC1;AL     # Sk     [3] GREEK PSILI..GREEK DIALYTIKA AND PERISPOMENI
1FC2..1FC4;AL     # Ll     [3] GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI..GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI
1FC6..1FCC;AL     # L&     [7] GREEK SMALL LETTER ETA WITH PERISPOMENI..GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI
1FCD..1FCF;AL     # Sk     [3] GREEK PSILI AND VARIA..GREEK PSILI AND PERISPOMENI
1FD0..1FD3;AL     # Ll     [4] GREEK SMALL LETTER IOTA WITH VRACHY..GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA
1FD6..1FDB;AL     # L&     [6] GREEK SMALL LETTER IOTA WITH PERISPOMENI..GREEK CAPITAL LETTER IOTA WITH OXIA
1FDD..1FDF;AL     # Sk     [3] GREEK DASIA AND VARIA..GREEK DASIA AND PERISPOMENI
1FE0..1FEC;AL     # L&    [13] GREEK SMALL LETTER UPSILON WITH VRACHY..GREEK CAPITAL LETTER RHO WITH DASIA
1FED..1FEF;AL     # Sk     [3] GREEK DIALYTIKA AND VARIA..GREEK VARIA
1FF2..1FF4;AL     # Ll     [3] GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI..GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI
1FF6..1FFC;AL     # L&     [7] GREEK SMALL LETTER OMEGA WITH PERISPOMENI..GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI
1FFD;BB           # Sk         GREEK OXIA
1FFE;AL           # Sk         GREEK DASIA
2000..2006;BA     # Zs     [7] EN QUAD..SIX-PER-EM SPACE
2007;GL           # Zs         FIGURE SPACE
2008..200A;BA     # Zs     [3] PUNCTUATION SPACE..HAIR SPACE
200B;ZW           # Cf         ZERO WIDTH SPACE
200C..200F;CM     # Cf     [4] ZERO WIDTH NON-JOINER..RIGHT-TO-LEFT MARK
2010;BA           # Pd         HYPHEN
2011;GL           # Pd         NON-BREAKING HYPHEN
2012..2013;BA     # Pd     [2] FIGURE DASH..EN DASH
2014;B2           # Pd         EM DASH
2015;AI           # Pd         HORIZONTAL BAR
2016;AI           # Po         DOUBLE VERTICAL LINE
2017;AL           # Po         DOUBLE LOW LINE
2018;QU           # Pi         LEFT SINGLE QUOTATION MARK
2019;QU           # Pf         RIGHT SINGLE QUOTATION MARK
201A;OP           # Ps         SINGLE LOW-9 QUOTATION MARK
201B..201C;QU     # Pi     [2] SINGLE HIGH-REVERSED-9 QUOTATION MARK..LEFT DOUBLE QUOTATION MARK
201D;QU           # Pf         RIGHT DOUBLE QUOTATION MARK
201E;OP           # Ps         DOUBLE LOW-9 QUOTATION MARK
201F;QU           # Pi         DOUBLE HIGH-REVERSED-9 QUOTATION MARK
2020..2021;AI     # Po     [2] DAGGER..DOUBLE DAGGER
2022..2023;AL     # Po     [2] BULLET..TRIANGULAR BULLET
2024..2026;IN     # Po     [3] ONE DOT LEADER..HORIZONTAL ELLIPSIS
2027;BA           # Po         HYPHENATION POINT
2028;BK           # Zl         LINE SEPARATOR
2029;BK           # Zp         PARAGRAPH SEPARATOR
202A..202E;CM     # Cf     [5] LEFT-TO-RIGHT EMBEDDING..RIGHT-TO-LEFT OVERRIDE
202F;GL           # Zs         NARROW NO-BREAK SPACE
2030..2037;PO     # Po     [8] PER MILLE SIGN..REVERSED TRIPLE PRIME
2038;AL           # Po         CARET
2039;QU           # Pi         SINGLE LEFT-POINTING ANGLE QUOTATION MARK
203A;QU           # Pf         SINGLE RIGHT-POINTING ANGLE QUOTATION MARK
203B;AI           # Po         REFERENCE MARK
203C..203D;NS     # Po     [2] DOUBLE EXCLAMATION MARK..INTERROBANG
203E;AL           # Po         OVERLINE
203F..2040;AL     # Pc     [2] UNDERTIE..CHARACTER TIE
2041..2043;AL     # Po     [3] CARET INSERTION POINT..HYPHEN BULLET
2044;IS           # Sm         FRACTION SLASH
2045;OP           # Ps         LEFT SQUARE BRACKET WITH QUILL
2046;CL           # Pe         RIGHT SQUARE BRACKET WITH QUILL
2047..2049;NS     # Po     [3] DOUBLE QUESTION MARK..EXCLAMATION QUESTION MARK
204A..2051;AL     # Po     [8] TIRONIAN SIGN ET..TWO ASTERISKS ALIGNED VERTICALLY
2052;AL           # Sm         COMMERCIAL MINUS SIGN
2053;AL           # Po         SWUNG DASH
2054;AL           # Pc         INVERTED UNDERTIE
2055;AL           # Po         FLOWER PUNCTUATION MARK
2056;BA           # Po         THREE DOT PUNCTUATION
2057;AL           # Po         QUADRUPLE PRIME
2058..205B;BA     # Po     [4] FOUR DOT PUNCTUATION..FOUR DOT MARK
205C;AL           # Po         DOTTED CROSS
205D..205E;BA     # Po     [2] TRICOLON..VERTICAL FOUR DOTS
205F;BA           # Zs         MEDIUM MATHEMATICAL SPACE
2060;WJ           # Cf         WORD JOINER
2061..2064;AL     # Cf     [4] FUNCTION APPLICATION..INVISIBLE PLUS
2066..206F;CM     # Cf    [10] LEFT-TO-RIGHT ISOLATE..NOMINAL DIGIT SHAPES
2070;AL           # No         SUPERSCRIPT ZERO
2071;AL           # Lm         SUPERSCRIPT LATIN SMALL LETTER I
2074;AI           # No         SUPERSCRIPT FOUR
2075..2079;AL     # No     [5] SUPERSCRIPT FIVE..SUPERSCRIPT NINE
207A..207C;AL     # Sm     [3] SUPERSCRIPT PLUS SIGN..SUPERSCRIPT EQUALS SIGN
207D;OP           # Ps         SUPERSCRIPT LEFT PARENTHESIS
207E;CL           # Pe         SUPERSCRIPT RIGHT PARENTHESIS
207F;AI           # Lm         SUPERSCRIPT LATIN SMALL LETTER N
2080;AL           # No         SUBSCRIPT ZERO
2081..2084;AI     # No     [4] SUBSCRIPT ONE..SUBSCRIPT FOUR
2085..2089;AL     # No     [5] SUBSCRIPT FIVE..SUBSCRIPT NINE
208A..208C;AL     # Sm     [3] SUBSCRIPT PLUS SIGN..SUBSCRIPT EQUALS SIGN
208D;OP           # Ps         SUBSCRIPT LEFT PARENTHESIS
208E;CL           # Pe         SUBSCRIPT RIGHT PARENTHESIS
2090..209C;AL     # Lm    [13] LATIN SUBSCRIPT SMALL LETTER A..LATIN SUBSCRIPT SMALL LETTER T
20A0..20A6;PR     # Sc     [7] EURO-CURRENCY SIGN..NAIRA SIGN
20A7;PO           # Sc         PESETA SIGN
20A8..20B5;PR     # Sc    [14] RUPEE SIGN..CEDI SIGN
20B6;PO           # Sc         LIVRE TOURNOIS SIGN
20B7..20BA;PR     # Sc     [4] SPESMILO SIGN..TURKISH LIRA SIGN
20BB;PO           # Sc         NORDIC MARK SIGN
20BC..20BD;PR     # Sc     [2] MANAT SIGN..RUBLE SIGN
20BE..20CF;PR     # Cn    [18] <reserved-20BE>..<reserved-20CF>
20D0..20DC;CM     # Mn    [13] COMBINING LEFT HARPOON ABOVE..COMBINING FOUR DOTS ABOVE
20DD..20E0;CM     # Me     [4] COMBINING ENCLOSING CIRCLE..COMBINING ENCLOSING CIRCLE BACKSLASH
20E1;CM           # Mn         COMBINING LEFT RIGHT ARROW ABOVE
20E2..20E4;CM     # Me     [3] COMBINING ENCLOSING SCREEN..COMBINING ENCLOSING UPWARD POINTING TRIANGLE
20E5..20F0;CM     # Mn    [12] COMBINING REVERSE SOLIDUS OVERLAY..COMBINING ASTERISK ABOVE
2100..2101;AL     # So     [2] ACCOUNT OF..ADDRESSED TO THE SUBJECT
2102;AL           # Lu         DOUBLE-STRUCK CAPITAL C
2103;PO           # So         DEGREE CELSIUS
2104;AL           # So         CENTRE LINE SYMBOL
2105;AI           # So         CARE OF
2106;AL           # So         CADA UNA
2107;AL           # Lu         EULER CONSTANT
2108;AL           # So         SCRUPLE
2109;PO           # So         DEGREE FAHRENHEIT
210A..2112;AL     # L&     [9] SCRIPT SMALL G..SCRIPT CAPITAL L
2113;AI           # Ll         SCRIPT SMALL L
2114;AL           # So         L B BAR SYMBOL
2115;AL           # Lu         DOUBLE-STRUCK CAPITAL N
2116;PR           # So         NUMERO SIGN
2117;AL           # So         SOUND RECORDING COPYRIGHT
2118;AL           # Sm         SCRIPT CAPITAL P
2119..211D;AL     # Lu     [5] DOUBLE-STRUCK CAPITAL P..DOUBLE-STRUCK CAPITAL R
211E..2120;AL     # So     [3] PRESCRIPTION TAKE..SERVICE MARK
2121..2122;AI     # So     [2] TELEPHONE SIGN..TRADE MARK SIGN
2123;AL           # So         VERSICLE
2124;AL           # Lu         DOUBLE-STRUCK CAPITAL Z
2125;AL           # So         OUNCE SIGN
2126;AL           # Lu         OHM SIGN
2127;AL           # So         INVERTED OHM SIGN
2128;AL           # Lu         BLACK-LETTER CAPITAL Z
2129;AL           # So         TURNED GREEK SMALL LETTER IOTA
212A;AL           # Lu         KELVIN SIGN
212B;AI           # Lu         ANGSTROM SIGN
212C..212D;AL     # Lu     [2] SCRIPT CAPITAL B..BLACK-LETTER CAPITAL C
212E;AL           # So         ESTIMATED SYMBOL
212F..2134;AL     # L&     [6] SCRIPT SMALL E..SCRIPT SMALL O
2135..2138;AL     # Lo     [4] ALEF SYMBOL..DALET SYMBOL
2139;AL           # Ll         INFORMATION SOURCE
213A..213B;AL     # So     [2] ROTATED CAPITAL Q..FACSIMILE SIGN
213C..213F;AL     # L&     [4] DOUBLE-STRUCK SMALL PI..DOUBLE-STRUCK CAPITAL PI
2140..2144;AL     # Sm     [5] DOUBLE-STRUCK N-ARY SUMMATION..TURNED SANS-SERIF CAPITAL Y
2145..2149;AL     # L&     [5] DOUBLE-STRUCK ITALIC CAPITAL D..DOUBLE-STRUCK ITALIC SMALL J
214A;AL           # So         PROPERTY LINE
214B;AL           # Sm         TURNED AMPERSAND
214C..214D;AL     # So     [2] PER SIGN..AKTIESELSKAB
214E;AL           # Ll         TURNED SMALL F
214F;AL           # So         SYMBOL FOR SAMARITAN SOURCE
2150..2153;AL     # No     [4] VULGAR FRACTION ONE SEVENTH..VULGAR FRACTION ONE THIRD
2154..2155;AI     # No     [2] VULGAR FRACTION TWO THIRDS..VULGAR FRACTION ONE FIFTH
2156..215A;AL     # No     [5] VULGAR FRACTION TWO FIFTHS..VULGAR FRACTION FIVE SIXTHS
215B;AI           # No         VULGAR FRACTION ONE EIGHTH
215C..215D;AL     # No     [2] VULGAR FRACTION THREE EIGHTHS..VULGAR FRACTION FIVE EIGHTHS
215E;AI           # No         VULGAR FRACTION SEVEN EIGHTHS
215F;AL           # No         FRACTION NUMERATOR ONE
2160..216B;AI     # Nl    [12] ROMAN NUMERAL ONE..ROMAN NUMERAL TWELVE
216C..216F;AL     # Nl     [4] ROMAN NUMERAL FIFTY..ROMAN NUMERAL ONE THOUSAND
2170..2179;AI     # Nl    [10] SMALL ROMAN NUMERAL ONE..SMALL ROMAN NUMERAL TEN
217A..2182;AL     # Nl     [9] SMALL ROMAN NUMERAL ELEVEN..ROMAN NUMERAL TEN THOUSAND
2183..2184;AL     # L&     [2] ROMAN NUMERAL REVERSED ONE HUNDRED..LATIN SMALL LETTER REVERSED C
2185..2188;AL     # Nl     [4] ROMAN NUMERAL SIX LATE FORM..ROMAN NUMERAL ONE HUNDRED THOUSAND
2189;AI           # No         VULGAR FRACTION ZERO THIRDS
2190..2194;AI     # Sm     [5] LEFTWARDS ARROW..LEFT RIGHT ARROW
2195..2199;AI     # So     [5] UP DOWN ARROW..SOUTH WEST ARROW
219A..219B;AL     # Sm     [2] LEFTWARDS ARROW WITH STROKE..RIGHTWARDS ARROW WITH STROKE
219C..219F;AL     # So     [4] LEFTWARDS WAVE ARROW..UPWARDS TWO HEADED ARROW
21A0;AL           # Sm         RIGHTWARDS TWO HEADED ARROW
21A1..21A2;AL     # So     [2] DOWNWARDS TWO HEADED ARROW..LEFTWARDS ARROW WITH TAIL
21A3;AL           # Sm         RIGHTWARDS ARROW WITH TAIL
21A4..21A5;AL     # So     [2] LEFTWARDS ARROW FROM BAR..UPWARDS ARROW FROM BAR
21A6;AL           # Sm         RIGHTWARDS ARROW FROM BAR
21A7..21AD;AL     # So     [7] DOWNWARDS ARROW FROM BAR..LEFT RIGHT WAVE ARROW
21AE;AL           # Sm         LEFT RIGHT ARROW WITH STROKE
21AF..21CD;AL     # So    [31] DOWNWARDS ZIGZAG ARROW..LEFTWARDS DOUBLE ARROW WITH STROKE
21CE..21CF;AL     # Sm     [2] LEFT RIGHT DOUBLE ARROW WITH STROKE..RIGHTWARDS DOUBLE ARROW WITH STROKE
21D0..21D1;AL     # So     [2] LEFTWARDS DOUBLE ARROW..UPWARDS DOUBLE ARROW
21D2;AI           # Sm         RIGHTWARDS DOUBLE ARROW
21D3;AL           # So         DOWNWARDS DOUBLE ARROW
21D4;AI           # Sm         LEFT RIGHT DOUBLE ARROW
21D5..21F3;AL     # So    [31] UP DOWN DOUBLE ARROW..UP DOWN WHITE ARROW
21F4..21FF;AL     # Sm    [12] RIGHT ARROW WITH SMALL CIRCLE..LEFT RIGHT OPEN-HEADED ARROW
2200;AI           # Sm         FOR ALL
2201;AL           # Sm         COMPLEMENT
2202..2203;AI     # Sm     [2] PARTIAL DIFFERENTIAL..THERE EXISTS
2204..2206;AL     # Sm     [3] THERE DOES NOT EXIST..INCREMENT
2207..2208;AI     # Sm     [2] NABLA..ELEMENT OF
2209..220A;AL     # Sm     [2] NOT AN ELEMENT OF..SMALL ELEMENT OF
220B;AI           # Sm         CONTAINS AS MEMBER
220C..220E;AL     # Sm     [3] DOES NOT CONTAIN AS MEMBER..END OF PROOF
220F;AI           # Sm         N-ARY PRODUCT
2210;AL           # Sm         N-ARY COPRODUCT
2211;AI           # Sm         N-ARY SUMMATION
2212..2213;PR     # Sm     [2] MINUS SIGN..MINUS-OR-PLUS SIGN
2214;AL           # Sm         DOT PLUS
2215;AI           # Sm         DIVISION SLASH
2216..2219;AL     # Sm     [4] SET MINUS..BULLET OPERATOR
221A;AI           # Sm         SQUARE ROOT
221B..221C;AL     # Sm     [2] CUBE ROOT..FOURTH ROOT
221D..2220;AI     # Sm     [4] PROPORTIONAL TO..ANGLE
2221..2222;AL     # Sm     [2] MEASURED ANGLE..SPHERICAL ANGLE
2223;AI           # Sm         DIVIDES
2224;AL           # Sm         DOES NOT DIVIDE
2225;AI           # Sm         PARALLEL TO
2226;AL           # Sm         NOT PARALLEL TO
2227..222C;AI     # Sm     [6] LOGICAL AND..DOUBLE INTEGRAL
222D;AL           # Sm         TRIPLE INTEGRAL
222E;AI           # Sm         CONTOUR INTEGRAL
222F..2233;AL     # Sm     [5] SURFACE INTEGRAL..ANTICLOCKWISE CONTOUR INTEGRAL
2234..2237;AI     # Sm     [4] THEREFORE..PROPORTION
2238..223B;AL     # Sm     [4] DOT MINUS..HOMOTHETIC
223C..223D;AI     # Sm     [2] TILDE OPERATOR..REVERSED TILDE
223E..2247;AL     # Sm    [10] INVERTED LAZY S..NEITHER APPROXIMATELY NOR ACTUALLY EQUAL TO
2248;AI           # Sm         ALMOST EQUAL TO
2249..224B;AL     # Sm     [3] NOT ALMOST EQUAL TO..TRIPLE TILDE
224C;AI           # Sm         ALL EQUAL TO
224D..2251;AL     # Sm     [5] EQUIVALENT TO..GEOMETRICALLY EQUAL TO
2252;AI           # Sm         APPROXIMATELY EQUAL TO OR THE IMAGE OF
2253..225F;AL     # Sm    [13] IMAGE OF OR APPROXIMATELY EQUAL TO..QUESTIONED EQUAL TO
2260..2261;AI     # Sm     [2] NOT EQUAL TO..IDENTICAL TO
2262..2263;AL     # Sm     [2] NOT IDENTICAL TO..STRICTLY EQUIVALENT TO
2264..2267;AI     # Sm     [4] LESS-THAN OR EQUAL TO..GREATER-THAN OVER EQUAL TO
2268..2269;AL     # Sm     [2] LESS-THAN BUT NOT EQUAL TO..GREATER-THAN BUT NOT EQUAL TO
226A..226B;AI     # Sm     [2] MUCH LESS-THAN..MUCH GREATER-THAN
226C..226D;AL     # Sm     [2] BETWEEN..NOT EQUIVALENT TO
226E..226F;AI     # Sm     [2] NOT LESS-THAN..NOT GREATER-THAN
2270..2281;AL     # Sm    [18] NEITHER LESS-THAN NOR EQUAL TO..DOES NOT SUCCEED
2282..2283;AI     # Sm     [2] SUBSET OF..SUPERSET OF
2284..2285;AL     # Sm     [2] NOT A SUBSET OF..NOT A SUPERSET OF
2286..2287;AI     # Sm     [2] SUBSET OF OR EQUAL TO..SUPERSET OF OR EQUAL TO
2288..2294;AL     # Sm    [13] NEITHER A SUBSET OF NOR EQUAL TO..SQUARE CUP
2295;AI           # Sm         CIRCLED PLUS
2296..2298;AL     # Sm     [3] CIRCLED MINUS..CIRCLED DIVISION SLASH
2299;AI           # Sm         CIRCLED DOT OPERATOR
229A..22A4;AL     # Sm    [11] CIRCLED RING OPERATOR..DOWN TACK
22A5;AI           # Sm         UP TACK
22A6..22BE;AL     # Sm    [25] ASSERTION..RIGHT ANGLE WITH ARC
22BF;AI           # Sm         RIGHT TRIANGLE
22C0..22FF;AL     # Sm    [64] N-ARY LOGICAL AND..Z NOTATION BAG MEMBERSHIP
2300..2307;AL     # So     [8] DIAMETER SIGN..WAVY LINE
2308;OP           # Ps         LEFT CEILING
2309;CL           # Pe         RIGHT CEILING
230A;OP           # Ps         LEFT FLOOR
230B;CL           # Pe         RIGHT FLOOR
230C..2311;AL     # So     [6] BOTTOM RIGHT CROP..SQUARE LOZENGE
2312;AI           # So         ARC
2313..2319;AL     # So     [7] SEGMENT..TURNED NOT SIGN
231A..231B;ID     # So     [2] WATCH..HOURGLASS
231C..231F;AL     # So     [4] TOP LEFT CORNER..BOTTOM RIGHT CORNER
2320..2321;AL     # Sm     [2] TOP HALF INTEGRAL..BOTTOM HALF INTEGRAL
2322..2328;AL     # So     [7] FROWN..KEYBOARD
2329;OP           # Ps         LEFT-POINTING ANGLE BRACKET
232A;CL           # Pe         RIGHT-POINTING ANGLE BRACKET
232B..237B;AL     # So    [81] ERASE TO THE LEFT..NOT CHECK MARK
237C;AL           # Sm         RIGHT ANGLE WITH DOWNWARDS ZIGZAG ARROW
237D..239A;AL     # So    [30] SHOULDERED OPEN BOX..CLEAR SCREEN SYMBOL
239B..23B3;AL     # Sm    [25] LEFT PARENTHESIS UPPER HOOK..SUMMATION BOTTOM
23B4..23DB;AL     # So    [40] TOP SQUARE BRACKET..FUSE
23DC..23E1;AL     # Sm     [6] TOP PARENTHESIS..BOTTOM TORTOISE SHELL BRACKET
23E2..23EF;AL     # So    [14] WHITE TRAPEZIUM..BLACK RIGHT-POINTING TRIANGLE WITH DOUBLE VERTICAL BAR
23F0..23F3;ID     # So     [4] ALARM CLOCK..HOURGLASS WITH FLOWING SAND
23F4..23FA;AL     # So     [7] BLACK MEDIUM LEFT-POINTING TRIANGLE..BLACK CIRCLE FOR RECORD
2400..2426;AL     # So    [39] SYMBOL FOR NULL..SYMBOL FOR SUBSTITUTE FORM TWO
2440..244A;AL     # So    [11] OCR HOOK..OCR DOUBLE BACKSLASH
2460..249B;AI     # No    [60] CIRCLED DIGIT ONE..NUMBER TWENTY FULL STOP
249C..24E9;AI     # So    [78] PARENTHESIZED LATIN SMALL LETTER A..CIRCLED LATIN SMALL LETTER Z
24EA..24FE;AI     # No    [21] CIRCLED DIGIT ZERO..DOUBLE CIRCLED NUMBER TEN
24FF;AL           # No         NEGATIVE CIRCLED DIGIT ZERO
2500..254B;AI     # So    [76] BOX DRAWINGS LIGHT HORIZONTAL..BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL
254C..254F;AL     # So     [4] BOX DRAWINGS LIGHT DOUBLE DASH HORIZONTAL..BOX DRAWINGS HEAVY DOUBLE DASH VERTICAL
2550..2574;AI     # So    [37] BOX DRAWINGS DOUBLE HORIZONTAL..BOX DRAWINGS LIGHT LEFT
2575..257F;AL     # So    [11] BOX DRAWINGS LIGHT UP..BOX DRAWINGS HEAVY UP AND LIGHT DOWN
2580..258F;AI     # So    [16] UPPER HALF BLOCK..LEFT ONE EIGHTH BLOCK
2590..2591;AL     # So     [2] RIGHT HALF BLOCK..LIGHT SHADE
2592..2595;AI     # So     [4] MEDIUM SHADE..RIGHT ONE EIGHTH BLOCK
2596..259F;AL     # So    [10] QUADRANT LOWER LEFT..QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT
25A0..25A1;AI     # So     [2] BLACK SQUARE..WHITE SQUARE
25A2;AL           # So         WHITE SQUARE WITH ROUNDED CORNERS
25A3..25A9;AI     # So     [7] WHITE SQUARE CONTAINING BLACK SMALL SQUARE..SQUARE WITH DIAGONAL CROSSHATCH FILL
25AA..25B1;AL     # So     [8] BLACK SMALL SQUARE..WHITE PARALLELOGRAM
25B2..25B3;AI     # So     [2] BLACK UP-POINTING TRIANGLE..WHITE UP-POINTING TRIANGLE
25B4..25B5;AL     # So     [2] BLACK UP-POINTING SMALL TRIANGLE..WHITE UP-POINTING SMALL TRIANGLE
25B6;AI           # So         BLACK RIGHT-POINTING TRIANGLE
25B7;AI           # Sm         WHITE RIGHT-POINTING TRIANGLE
25B8..25BB;AL     # So     [4] BLACK RIGHT-POINTING SMALL TRIANGLE..WHITE RIGHT-POINTING POINTER
25BC..25BD;AI     # So     [2] BLACK DOWN-POINTING TRIANGLE..WHITE DOWN-POINTING TRIANGLE
25BE..25BF;AL     # So     [2] BLACK DOWN-POINTING SMALL TRIANGLE..WHITE DOWN-POINTING SMALL TRIANGLE
25C0;AI           # So         BLACK LEFT-POINTING TRIANGLE
25C1;AI           # Sm         WHITE LEFT-POINTING TRIANGLE
25C2..25C5;AL     # So     [4] BLACK LEFT-POINTING SMALL TRIANGLE..WHITE LEFT-POINTING POINTER
25C6..25C8;AI     # So     [3] BLACK DIAMOND..WHITE DIAMOND CONTAINING BLACK SMALL DIAMOND
25C9..25CA;AL     # So     [2] FISHEYE..LOZENGE
25CB;AI           # So         WHITE CIRCLE
25CC..25CD;AL     # So     [2] DOTTED CIRCLE..CIRCLE WITH VERTICAL FILL
25CE..25D1;AI     # So     [4] BULLSEYE..CIRCLE WITH RIGHT HALF BLACK
25D2..25E1;AL     # So    [16] CIRCLE WITH LOWER HALF BLACK..LOWER HALF CIRCLE
25E2..25E5;AI     # So     [4] BLACK LOWER RIGHT TRIANGLE..BLACK UPPER RIGHT TRIANGLE
25E6..25EE;AL     # So     [9] WHITE BULLET..UP-POINTING TRIANGLE WITH RIGHT HALF BLACK
25EF;AI           # So         LARGE CIRCLE
25F0..25F7;AL     # So     [8] WHITE SQUARE WITH UPPER LEFT QUADRANT..WHITE CIRCLE WITH UPPER RIGHT QUADRANT
25F8..25FF;AL     # Sm     [8] UPPER LEFT TRIANGLE..LOWER RIGHT TRIANGLE
2600..2603;ID     # So     [4] BLACK SUN WITH RAYS..SNOWMAN
2604;AL           # So         COMET
2605..2606;AI     # So     [2] BLACK STAR..WHITE STAR
2607..2608;AL     # So     [2] LIGHTNING..THUNDERSTORM
2609;AI           # So         SUN
260A..260D;AL     # So     [4] ASCENDING NODE..OPPOSITION
260E..260F;AI     # So     [2] BLACK TELEPHONE..WHITE TELEPHONE
2610..2613;AL     # So     [4] BALLOT BOX..SALTIRE
2614..2615;ID     # So     [2] UMBRELLA WITH RAIN DROPS..HOT BEVERAGE
2616..2617;AI     # So     [2] WHITE SHOGI PIECE..BLACK SHOGI PIECE
2618;ID           # So         SHAMROCK
2619;AL           # So         REVERSED ROTATED FLORAL HEART BULLET
261A..261F;ID     # So     [6] BLACK LEFT POINTING INDEX..WHITE DOWN POINTING INDEX
2620..2638;AL     # So    [25] SKULL AND CROSSBONES..WHEEL OF DHARMA
2639..263B;ID     # So     [3] WHITE FROWNING FACE..BLACK SMILING FACE
263C..263F;AL     # So     [4] WHITE SUN WITH RAYS..MERCURY
2640;AI           # So         FEMALE SIGN
2641;AL           # So         EARTH
2642;AI           # So         MALE SIGN
2643..265F;AL     # So    [29] JUPITER..BLACK CHESS PAWN
2660..2661;AI     # So     [2] BLACK SPADE SUIT..WHITE HEART SUIT
2662;AL           # So         WHITE DIAMOND SUIT
2663..2665;AI     # So     [3] BLACK CLUB SUIT..BLACK HEART SUIT
2666;AL           # So         BLACK DIAMOND SUIT
2667;AI           # So         WHITE CLUB SUIT
2668;ID           # So         HOT SPRINGS
2669..266A;AI     # So     [2] QUARTER NOTE..EIGHTH NOTE
266B;AL           # So         BEAMED EIGHTH NOTES
266C..266D;AI     # So     [2] BEAMED SIXTEENTH NOTES..MUSIC FLAT SIGN
266E;AL           # So         MUSIC NATURAL SIGN
266F;AI           # Sm         MUSIC SHARP SIGN
2670..267E;AL     # So    [15] WEST SYRIAC CROSS..PERMANENT PAPER SIGN
267F;ID           # So         WHEELCHAIR SYMBOL
2680..269D;AL     # So    [30] DIE FACE-1..OUTLINED WHITE STAR
269E..269F;AI     # So     [2] THREE LINES CONVERGING RIGHT..THREE LINES CONVERGING LEFT
26A0..26BC;AL     # So    [29] WARNING SIGN..SESQUIQUADRATE
26BD..26C8;ID     # So    [12] SOCCER BALL..THUNDER CLOUD AND RAIN
26C9..26CC;AI     # So     [4] TURNED WHITE SHOGI PIECE..CROSSING LANES
26CD;ID           # So         DISABLED CAR
26CE;AL           # So         OPHIUCHUS
26CF..26D1;ID     # So     [3] PICK..HELMET WITH WHITE CROSS
26D2;AI           # So         CIRCLED CROSSING LANES
26D3..26D4;ID     # So     [2] CHAINS..NO ENTRY
26D5..26D7;AI     # So     [3] ALTERNATE ONE-WAY LEFT WAY TRAFFIC..WHITE TWO-WAY LEFT WAY TRAFFIC
26D8..26D9;ID     # So     [2] BLACK LEFT LANE MERGE..WHITE LEFT LANE MERGE
26DA..26DB;AI     # So     [2] DRIVE SLOW SIGN..HEAVY WHITE DOWN-POINTING TRIANGLE
26DC;ID           # So         LEFT CLOSED ENTRY
26DD..26DE;AI     # So     [2] SQUARED SALTIRE..FALLING DIAGONAL IN WHITE CIRCLE IN BLACK SQUARE
26DF..26E1;ID     # So     [3] BLACK TRUCK..RESTRICTED LEFT ENTRY-2
26E2;AL           # So         ASTRONOMICAL SYMBOL FOR URANUS
26E3;AI           # So         HEAVY CIRCLE WITH STROKE AND TWO DOTS ABOVE
26E4..26E7;AL     # So     [4] PENTAGRAM..INVERTED PENTAGRAM
26E8..26E9;AI     # So     [2] BLACK CROSS ON SHIELD..SHINTO SHRINE
26EA;ID           # So         CHURCH
26EB..26F0;AI     # So     [6] CASTLE..MOUNTAIN
26F1..26F5;ID     # So     [5] UMBRELLA ON GROUND..SAILBOAT
26F6;AI           # So         SQUARE FOUR CORNERS
26F7..26FA;ID     # So     [4] SKIER..TENT
26FB..26FC;AI     # So     [2] JAPANESE BANK SYMBOL..HEADSTONE GRAVEYARD SYMBOL
26FD..26FF;ID     # So     [3] FUEL PUMP..WHITE FLAG WITH HORIZONTAL MIDDLE BLACK STRIPE
2700..2704;ID     # So     [5] BLACK SAFETY SCISSORS..WHITE SCISSORS
2705..2707;AL     # So     [3] WHITE HEAVY CHECK MARK..TAPE DRIVE
2708..270D;ID     # So     [6] AIRPLANE..WRITING HAND
270E..2756;AL     # So    [73] LOWER RIGHT PENCIL..BLACK DIAMOND MINUS WHITE X
2757;AI           # So         HEAVY EXCLAMATION MARK SYMBOL
2758..275A;AL     # So     [3] LIGHT VERTICAL BAR..HEAVY VERTICAL BAR
275B..2760;QU     # So     [6] HEAVY SINGLE TURNED COMMA QUOTATION MARK ORNAMENT..HEAVY LOW DOUBLE COMMA QUOTATION MARK ORNAMENT
2761;AL           # So         CURVED STEM PARAGRAPH SIGN ORNAMENT
2762..2763;EX     # So     [2] HEAVY EXCLAMATION MARK ORNAMENT..HEAVY HEART EXCLAMATION MARK ORNAMENT
2764..2767;AL     # So     [4] HEAVY BLACK HEART..ROTATED FLORAL HEART BULLET
2768;OP           # Ps         MEDIUM LEFT PARENTHESIS ORNAMENT
2769;CL           # Pe         MEDIUM RIGHT PARENTHESIS ORNAMENT
276A;OP           # Ps         MEDIUM FLATTENED LEFT PARENTHESIS ORNAMENT
276B;CL           # Pe         MEDIUM FLATTENED RIGHT PARENTHESIS ORNAMENT
276C;OP           # Ps         MEDIUM LEFT-POINTING ANGLE BRACKET ORNAMENT
276D;CL           # Pe         MEDIUM RIGHT-POINTING ANGLE BRACKET ORNAMENT
276E;OP           # Ps         HEAVY LEFT-POINTING ANGLE QUOTATION MARK ORNAMENT
276F;CL           # Pe         HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT
2770;OP           # Ps         HEAVY LEFT-POINTING ANGLE BRACKET ORNAMENT
2771;CL           # Pe         HEAVY RIGHT-POINTING ANGLE BRACKET ORNAMENT
2772;OP           # Ps         LIGHT LEFT TORTOISE SHELL BRACKET ORNAMENT
2773;CL           # Pe         LIGHT RIGHT TORTOISE SHELL BRACKET ORNAMENT
2774;OP           # Ps         MEDIUM LEFT CURLY BRACKET ORNAMENT
2775;CL           # Pe         MEDIUM RIGHT CURLY BRACKET ORNAMENT
2776..2793;AI     # No    [30] DINGBAT NEGATIVE CIRCLED DIGIT ONE..DINGBAT NEGATIVE CIRCLED SANS-SERIF NUMBER TEN
2794..27BF;AL     # So    [44] HEAVY WIDE-HEADED RIGHTWARDS ARROW..DOUBLE CURLY LOOP
27C0..27C4;AL     # Sm     [5] THREE DIMENSIONAL ANGLE..OPEN SUPERSET
27C5;OP           # Ps         LEFT S-SHAPED BAG DELIMITER
27C6;CL           # Pe         RIGHT S-SHAPED BAG DELIMITER
27C7..27E5;AL     # Sm    [31] OR WITH DOT INSIDE..WHITE SQUARE WITH RIGHTWARDS TICK
27E6;OP           # Ps         MATHEMATICAL LEFT WHITE SQUARE BRACKET
27E7;CL           # Pe         MATHEMATICAL RIGHT WHITE SQUARE BRACKET
27E8;OP           # Ps         MATHEMATICAL LEFT ANGLE BRACKET
27E9;CL           # Pe         MATHEMATICAL RIGHT ANGLE BRACKET
27EA;OP           # Ps         MATHEMATICAL LEFT DOUBLE ANGLE BRACKET
27EB;CL           # Pe         MATHEMATICAL RIGHT DOUBLE ANGLE BRACKET
27EC;OP           # Ps         MATHEMATICAL LEFT WHITE TORTOISE SHELL BRACKET
27ED;CL           # Pe         MATHEMATICAL RIGHT WHITE TORTOISE SHELL BRACKET
27EE;OP           # Ps         MATHEMATICAL LEFT FLATTENED PARENTHESIS
27EF;CL           # Pe         MATHEMATICAL RIGHT FLATTENED PARENTHESIS
27F0..27FF;AL     # Sm    [16] UPWARDS QUADRUPLE ARROW..LONG RIGHTWARDS SQUIGGLE ARROW
2800..28FF;AL     # So   [256] BRAILLE PATTERN BLANK..BRAILLE PATTERN DOTS-12345678
2900..297F;AL     # Sm   [128] RIGHTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE..DOWN FISH TAIL
2980..2982;AL     # Sm     [3] TRIPLE VERTICAL BAR DELIMITER..Z NOTATION TYPE COLON
2983;OP           # Ps         LEFT WHITE CURLY BRACKET
2984;CL           # Pe         RIGHT WHITE CURLY BRACKET
2985;OP           # Ps         LEFT WHITE PARENTHESIS
2986;CL           # Pe         RIGHT WHITE PARENTHESIS
2987;OP           # Ps         Z NOTATION LEFT IMAGE BRACKET
2988;CL           # Pe         Z NOTATION RIGHT IMAGE BRACKET
2989;OP           # Ps         Z NOTATION LEFT BINDING BRACKET
298A;CL           # Pe         Z NOTATION RIGHT BINDING BRACKET
298B;OP           # Ps         LEFT SQUARE BRACKET WITH UNDERBAR
298C;CL           # Pe         RIGHT SQUARE BRACKET WITH UNDERBAR
298D;OP           # Ps         LEFT SQUARE BRACKET WITH TICK IN TOP CORNER
298E;CL           # Pe         RIGHT SQUARE BRACKET WITH TICK IN BOTTOM CORNER
298F;OP           # Ps         LEFT SQUARE BRACKET WITH TICK IN BOTTOM CORNER
2990;CL           # Pe         RIGHT SQUARE BRACKET WITH TICK IN TOP CORNER
2991;OP           # Ps         LEFT ANGLE BRACKET WITH DOT
2992;CL           # Pe         RIGHT ANGLE BRACKET WITH DOT
2993;OP           # Ps         LEFT ARC LESS-THAN BRACKET
2994;CL           # Pe         RIGHT ARC GREATER-THAN BRACKET
2995;OP           # Ps         DOUBLE LEFT ARC GREATER-THAN BRACKET
2996;CL           # Pe         DOUBLE RIGHT ARC LESS-THAN BRACKET
2997;OP           # Ps         LEFT BLACK TORTOISE SHELL BRACKET
2998;CL           # Pe         RIGHT BLACK TORTOISE SHELL BRACKET
2999..29D7;AL     # Sm    [63] DOTTED FENCE..BLACK HOURGLASS
29D8;OP           # Ps         LEFT WIGGLY FENCE
29D9;CL           # Pe         RIGHT WIGGLY FENCE
29DA;OP           # Ps         LEFT DOUBLE WIGGLY FENCE
29DB;CL           # Pe         RIGHT DOUBLE WIGGLY FENCE
29DC..29FB;AL     # Sm    [32] INCOMPLETE INFINITY..TRIPLE PLUS
29FC;OP           # Ps         LEFT-POINTING CURVED ANGLE BRACKET
29FD;CL           # Pe         RIGHT-POINTING CURVED ANGLE BRACKET
29FE..29FF;AL     # Sm     [2] TINY..MINY
2A00..2AFF;AL     # Sm   [256] N-ARY CIRCLED DOT OPERATOR..N-ARY WHITE VERTICAL BAR
2B00..2B2F;AL     # So    [48] NORTH EAST WHITE ARROW..WHITE VERTICAL ELLIPSE
2B30..2B44;AL     # Sm    [21] LEFT ARROW WITH SMALL CIRCLE..RIGHTWARDS ARROW THROUGH SUPERSET
2B45..2B46;AL     # So     [2] LEFTWARDS QUADRUPLE ARROW..RIGHTWARDS QUADRUPLE ARROW
2B47..2B4C;AL     # Sm     [6] REVERSE TILDE OPERATOR ABOVE RIGHTWARDS ARROW..RIGHTWARDS ARROW ABOVE REVERSE TILDE OPERATOR
2B4D..2B54;AL     # So     [8] DOWNWARDS TRIANGLE-HEADED ZIGZAG ARROW..WHITE RIGHT-POINTING PENTAGON
2B55..2B59;AI     # So     [5] HEAVY LARGE CIRCLE..HEAVY CIRCLED SALTIRE
2B5A..2B73;AL     # So    [26] SLANTED NORTH ARROW WITH HOOKED HEAD..DOWNWARDS TRIANGLE-HEADED ARROW TO BAR
2B76..2B95;AL     # So    [32] NORTH WEST TRIANGLE-HEADED ARROW TO BAR..RIGHTWARDS BLACK ARROW
2B98..2BB9;AL     # So    [34] THREE-D TOP-LIGHTED LEFTWARDS EQUILATERAL ARROWHEAD..UP ARROWHEAD IN A RECTANGLE BOX
2BBD..2BC8;AL     # So    [12] BALLOT BOX WITH LIGHT X..BLACK MEDIUM RIGHT-POINTING TRIANGLE CENTRED
2BCA..2BD1;AL     # So     [8] TOP HALF BLACK CIRCLE..UNCERTAINTY SIGN
2C00..2C2E;AL     # Lu    [47] GLAGOLITIC CAPITAL LETTER AZU..GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE
2C30..2C5E;AL     # Ll    [47] GLAGOLITIC SMALL LETTER AZU..GLAGOLITIC SMALL LETTER LATINATE MYSLITE
2C60..2C7B;AL     # L&    [28] LATIN CAPITAL LETTER L WITH DOUBLE BAR..LATIN LETTER SMALL CAPITAL TURNED E
2C7C..2C7D;AL     # Lm     [2] LATIN SUBSCRIPT SMALL LETTER J..MODIFIER LETTER CAPITAL V
2C7E..2C7F;AL     # Lu     [2] LATIN CAPITAL LETTER S WITH SWASH TAIL..LATIN CAPITAL LETTER Z WITH SWASH TAIL
2C80..2CE4;AL     # L&   [101] COPTIC CAPITAL LETTER ALFA..COPTIC SYMBOL KAI
2CE5..2CEA;AL     # So     [6] COPTIC SYMBOL MI RO..COPTIC SYMBOL SHIMA SIMA
2CEB..2CEE;AL     # L&     [4] COPTIC CAPITAL LETTER CRYPTOGRAMMIC SHEI..COPTIC SMALL LETTER CRYPTOGRAMMIC GANGIA
2CEF..2CF1;CM     # Mn     [3] COPTIC COMBINING NI ABOVE..COPTIC COMBINING SPIRITUS LENIS
2CF2..2CF3;AL     # L&     [2] COPTIC CAPITAL LETTER BOHAIRIC KHEI..COPTIC SMALL LETTER BOHAIRIC KHEI
2CF9;EX           # Po         COPTIC OLD NUBIAN FULL STOP
2CFA..2CFC;BA     # Po     [3] COPTIC OLD NUBIAN DIRECT QUESTION MARK..COPTIC OLD NUBIAN VERSE DIVIDER
2CFD;AL           # No         COPTIC FRACTION ONE HALF
2CFE;EX           # Po         COPTIC FULL STOP
2CFF;BA           # Po         COPTIC MORPHOLOGICAL DIVIDER
2D00..2D25;AL     # Ll    [38] GEORGIAN SMALL LETTER AN..GEORGIAN SMALL LETTER HOE
2D27;AL           # Ll         GEORGIAN SMALL LETTER YN
2D2D;AL           # Ll         GEORGIAN SMALL LETTER AEN
2D30..2D67;AL     # Lo    [56] TIFINAGH LETTER YA..TIFINAGH LETTER YO
2D6F;AL           # Lm         TIFINAGH MODIFIER LETTER LABIALIZATION MARK
2D70;BA           # Po         TIFINAGH SEPARATOR MARK
2D7F;CM           # Mn         TIFINAGH CONSONANT JOINER
2D80..2D96;AL     # Lo    [23] ETHIOPIC SYLLABLE LOA..ETHIOPIC SYLLABLE GGWE
2DA0..2DA6;AL     # Lo     [7] ETHIOPIC SYLLABLE SSA..ETHIOPIC SYLLABLE SSO
2DA8..2DAE;AL     # Lo     [7] ETHIOPIC SYLLABLE CCA..ETHIOPIC SYLLABLE CCO
2DB0..2DB6;AL     # Lo     [7] ETHIOPIC SYLLABLE ZZA..ETHIOPIC SYLLABLE ZZO
2DB8..2DBE;AL     # Lo     [7] ETHIOPIC SYLLABLE CCHA..ETHIOPIC SYLLABLE CCHO
2DC0..2DC6;AL     # Lo     [7] ETHIOPIC SYLLABLE QYA..ETHIOPIC SYLLABLE QYO
2DC8..2DCE;AL     # Lo     [7] ETHIOPIC SYLLABLE KYA..ETHIOPIC SYLLABLE KYO
2DD0..2DD6;AL     # Lo     [7] ETHIOPIC SYLLABLE XYA..ETHIOPIC SYLLABLE XYO
2DD8..2DDE;AL     # Lo     [7] ETHIOPIC SYLLABLE GYA..ETHIOPIC SYLLABLE GYO
2DE0..2DFF;CM     # Mn    [32] COMBINING CYRILLIC LETTER BE..COMBINING CYRILLIC LETTER IOTIFIED BIG YUS
2E00..2E01;QU     # Po     [2] RIGHT ANGLE SUBSTITUTION MARKER..RIGHT ANGLE DOTTED SUBSTITUTION MARKER
2E02;QU           # Pi         LEFT SUBSTITUTION BRACKET
2E03;QU           # Pf         RIGHT SUBSTITUTION BRACKET
2E04;QU           # Pi         LEFT DOTTED SUBSTITUTION BRACKET
2E05;QU           # Pf         RIGHT DOTTED SUBSTITUTION BRACKET
2E06..2E08;QU     # Po     [3] RAISED INTERPOLATION MARKER..DOTTED TRANSPOSITION MARKER
2E09;QU           # Pi         LEFT TRANSPOSITION BRACKET
2E0A;QU           # Pf         RIGHT TRANSPOSITION BRACKET
2E0B;QU           # Po         RAISED SQUARE
2E0C;QU           # Pi         LEFT RAISED OMISSION BRACKET
2E0D;QU           # Pf         RIGHT RAISED OMISSION BRACKET
2E0E..2E15;BA     # Po     [8] EDITORIAL CORONIS..UPWARDS ANCORA
2E16;AL           # Po         DOTTED RIGHT-POINTING ANGLE
2E17;BA           # Pd         DOUBLE OBLIQUE HYPHEN
2E18;OP           # Po         INVERTED INTERROBANG
2E19;BA           # Po         PALM BRANCH
2E1A;AL           # Pd         HYPHEN WITH DIAERESIS
2E1B;AL           # Po         TILDE WITH RING ABOVE
2E1C;QU           # Pi         LEFT LOW PARAPHRASE BRACKET
2E1D;QU           # Pf         RIGHT LOW PARAPHRASE BRACKET
2E1E..2E1F;AL     # Po     [2] TILDE WITH DOT ABOVE..TILDE WITH DOT BELOW
2E20;QU           # Pi         LEFT VERTICAL BAR WITH QUILL
2E21;QU           # Pf         RIGHT VERTICAL BAR WITH QUILL
2E22;OP           # Ps         TOP LEFT HALF BRACKET
2E23;CL           # Pe         TOP RIGHT HALF BRACKET
2E24;OP           # Ps         BOTTOM LEFT HALF BRACKET
2E25;CL           # Pe         BOTTOM RIGHT HALF BRACKET
2E26;OP           # Ps         LEFT SIDEWAYS U BRACKET
2E27;CL           # Pe         RIGHT SIDEWAYS U BRACKET
2E28;OP           # Ps         LEFT DOUBLE PARENTHESIS
2E29;CL           # Pe         RIGHT DOUBLE PARENTHESIS
2E2A..2E2D;BA     # Po     [4] TWO DOTS OVER ONE DOT PUNCTUATION..FIVE DOT MARK
2E2E;EX           # Po         REVERSED QUESTION MARK
2E2F;AL           # Lm         VERTICAL TILDE
2E30..2E31;BA     # Po     [2] RING POINT..WORD SEPARATOR MIDDLE DOT
2E32;AL           # Po         TURNED COMMA
2E33..2E34;BA     # Po     [2] RAISED DOT..RAISED COMMA
2E35..2E39;AL     # Po     [5] TURNED SEMICOLON..TOP HALF SECTION SIGN
2E3A..2E3B;B2     # Pd     [2] TWO-EM DASH..THREE-EM DASH
2E3C..2E3E;BA     # Po     [3] STENOGRAPHIC FULL STOP..WIGGLY VERTICAL LINE
2E3F;AL           # Po         CAPITULUM
2E40;BA           # Pd         DOUBLE HYPHEN
2E41;BA           # Po         REVERSED COMMA
2E42;OP           # Ps         DOUBLE LOW-REVERSED-9 QUOTATION MARK
2E80..2E99;ID     # So    [26] CJK RADICAL REPEAT..CJK RADICAL RAP
2E9B..2EF3;ID     # So    [89] CJK RADICAL CHOKE..CJK RADICAL C-SIMPLIFIED TURTLE
2F00..2FD5;ID     # So   [214] KANGXI RADICAL ONE..KANGXI RADICAL FLUTE
2FF0..2FFB;ID     # So    [12] IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO RIGHT..IDEOGRAPHIC DESCRIPTION CHARACTER OVERLAID
3000;BA           # Zs         IDEOGRAPHIC SPACE
3001..3002;CL     # Po     [2] IDEOGRAPHIC COMMA..IDEOGRAPHIC FULL STOP
3003;ID           # Po         DITTO MARK
3004;ID           # So         JAPANESE INDUSTRIAL STANDARD SYMBOL
3005;NS           # Lm         IDEOGRAPHIC ITERATION MARK
3006;ID           # Lo         IDEOGRAPHIC CLOSING MARK
3007;ID           # Nl         IDEOGRAPHIC NUMBER ZERO
3008;OP           # Ps         LEFT ANGLE BRACKET
3009;CL           # Pe         RIGHT ANGLE BRACKET
300A;OP           # Ps         LEFT DOUBLE ANGLE BRACKET
300B;CL           # Pe         RIGHT DOUBLE ANGLE BRACKET
300C;OP           # Ps         LEFT CORNER BRACKET
300D;CL           # Pe         RIGHT CORNER BRACKET
300E;OP           # Ps         LEFT WHITE CORNER BRACKET
300F;CL           # Pe         RIGHT WHITE CORNER BRACKET
3010;OP           # Ps         LEFT BLACK LENTICULAR BRACKET
3011;CL           # Pe         RIGHT BLACK LENTICULAR BRACKET
3012..3013;ID     # So     [2] POSTAL MARK..GETA MARK
3014;OP           # Ps         LEFT TORTOISE SHELL BRACKET
3015;CL           # Pe         RIGHT TORTOISE SHELL BRACKET
3016;OP           # Ps         LEFT WHITE LENTICULAR BRACKET
3017;CL           # Pe         RIGHT WHITE LENTICULAR BRACKET
3018;OP           # Ps         LEFT WHITE TORTOISE SHELL BRACKET
3019;CL           # Pe         RIGHT WHITE TORTOISE SHELL BRACKET
301A;OP           # Ps         LEFT WHITE SQUARE BRACKET
301B;CL           # Pe         RIGHT WHITE SQUARE BRACKET
301C;NS           # Pd         WAVE DASH
301D;OP           # Ps         REVERSED DOUBLE PRIME QUOTATION MARK
301E..301F;CL     # Pe     [2] DOUBLE PRIME QUOTATION MARK..LOW DOUBLE PRIME QUOTATION MARK
3020;ID           # So         POSTAL MARK FACE
3021..3029;ID     # Nl     [9] HANGZHOU NUMERAL ONE..HANGZHOU NUMERAL NINE
302A..302D;CM     # Mn     [4] IDEOGRAPHIC LEVEL TONE MARK..IDEOGRAPHIC ENTERING TONE MARK
302E..302F;CM     # Mc     [2] HANGUL SINGLE DOT TONE MARK..HANGUL DOUBLE DOT TONE MARK
3030;ID           # Pd         WAVY DASH
3031..3034;ID     # Lm     [4] VERTICAL KANA REPEAT MARK..VERTICAL KANA REPEAT WITH VOICED SOUND MARK UPPER HALF
3035;CM           # Lm         VERTICAL KANA REPEAT MARK LOWER HALF
3036..3037;ID     # So     [2] CIRCLED POSTAL MARK..IDEOGRAPHIC TELEGRAPH LINE FEED SEPARATOR SYMBOL
3038..303A;ID     # Nl     [3] HANGZHOU NUMERAL TEN..HANGZHOU NUMERAL THIRTY
303B;NS           # Lm         VERTICAL IDEOGRAPHIC ITERATION MARK
303C;NS           # Lo         MASU MARK
303D;ID           # Po         PART ALTERNATION MARK
303E..303F;ID     # So     [2] IDEOGRAPHIC VARIATION INDICATOR..IDEOGRAPHIC HALF FILL SPACE
3041;CJ           # Lo         HIRAGANA LETTER SMALL A
3042;ID           # Lo         HIRAGANA LETTER A
3043;CJ           # Lo         HIRAGANA LETTER SMALL I
3044;ID           # Lo         HIRAGANA LETTER I
3045;CJ           # Lo         HIRAGANA LETTER SMALL U
3046;ID           # Lo         HIRAGANA LETTER U
3047;CJ           # Lo         HIRAGANA LETTER SMALL E
3048;ID           # Lo         HIRAGANA LETTER E
3049;CJ           # Lo         HIRAGANA LETTER SMALL O
304A..3062;ID     # Lo    [25] HIRAGANA LETTER O..HIRAGANA LETTER DI
3063;CJ           # Lo         HIRAGANA LETTER SMALL TU
3064..3082;ID     # Lo    [31] HIRAGANA LETTER TU..HIRAGANA LETTER MO
3083;CJ           # Lo         HIRAGANA LETTER SMALL YA
3084;ID           # Lo         HIRAGANA LETTER YA
3085;CJ           # Lo         HIRAGANA LETTER SMALL YU
3086;ID           # Lo         HIRAGANA LETTER YU
3087;CJ           # Lo         HIRAGANA LETTER SMALL YO
3088..308D;ID     # Lo     [6] HIRAGANA LETTER YO..HIRAGANA LETTER RO
308E;CJ           # Lo         HIRAGANA LETTER SMALL WA
308F..3094;ID     # Lo     [6] HIRAGANA LETTER WA..HIRAGANA LETTER VU
3095..3096;CJ     # Lo     [2] HIRAGANA LETTER SMALL KA..HIRAGANA LETTER SMALL KE
3099..309A;CM     # Mn     [2] COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK..COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK
309B..309C;NS     # Sk     [2] KATAKANA-HIRAGANA VOICED SOUND MARK..KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK
309D..309E;NS     # Lm     [2] HIRAGANA ITERATION MARK..HIRAGANA VOICED ITERATION MARK
309F;ID           # Lo         HIRAGANA DIGRAPH YORI
30A0;NS           # Pd         KATAKANA-HIRAGANA DOUBLE HYPHEN
30A1;CJ           # Lo         KATAKANA LETTER SMALL A
30A2;ID           # Lo         KATAKANA LETTER A
30A3;CJ           # Lo         KATAKANA LETTER SMALL I
30A4;ID           # Lo         KATAKANA LETTER I
30A5;CJ           # Lo         KATAKANA LETTER SMALL U
30A6;ID           # Lo         KATAKANA LETTER U
30A7;CJ           # Lo         KATAKANA LETTER SMALL E
30A8;ID           # Lo         KATAKANA LETTER E
30A9;CJ           # Lo         KATAKANA LETTER SMALL O
30AA..30C2;ID     # Lo    [25] KATAKANA LETTER O..KATAKANA LETTER DI
30C3;CJ           # Lo         KATAKANA LETTER SMALL TU
30C4..30E2;ID     # Lo    [31] KATAKANA LETTER TU..KATAKANA LETTER MO
30E3;CJ           # Lo         KATAKANA LETTER SMALL YA
30E4;ID           # Lo         KATAKANA LETTER YA
30E5;CJ           # Lo         KATAKANA LETTER SMALL YU
30E6;ID           # Lo         KATAKANA LETTER YU
30E7;CJ           # Lo         KATAKANA LETTER SMALL YO
30E8..30ED;ID     # Lo     [6] KATAKANA LETTER YO..KATAKANA LETTER RO
30EE;CJ           # Lo         KATAKANA LETTER SMALL WA
30EF..30F4;ID     # Lo     [6] KATAKANA LETTER WA..KATAKANA LETTER VU
30F5..30F6;CJ     # Lo     [2] KATAKANA LETTER SMALL KA..KATAKANA LETTER SMALL KE
30F7..30FA;ID     # Lo     [4] KATAKANA LETTER VA..KATAKANA LETTER VO
30FB;NS           # Po         KATAKANA MIDDLE DOT
30FC;CJ           # Lm         KATAKANA-HIRAGANA PROLONGED SOUND MARK
30FD..30FE;NS     # Lm     [2] KATAKANA ITERATION MARK..KATAKANA VOICED ITERATION MARK
30FF;ID           # Lo         KATAKANA DIGRAPH KOTO
3105..312D;ID     # Lo    [41] BOPOMOFO LETTER B..BOPOMOFO LETTER IH
3131..318E;ID     # Lo    [94] HANGUL LETTER KIYEOK..HANGUL LETTER ARAEAE
3190..3191;ID     # So     [2] IDEOGRAPHIC ANNOTATION LINKING MARK..IDEOGRAPHIC ANNOTATION REVERSE MARK
3192..3195;ID     # No     [4] IDEOGRAPHIC ANNOTATION ONE MARK..IDEOGRAPHIC ANNOTATION FOUR MARK
3196..319F;ID     # So    [10] IDEOGRAPHIC ANNOTATION TOP MARK..IDEOGRAPHIC ANNOTATION MAN MARK
31A0..31BA;ID     # Lo    [27] BOPOMOFO LETTER BU..BOPOMOFO LETTER ZY
31C0..31E3;ID     # So    [36] CJK STROKE T..CJK STROKE Q
31F0..31FF;CJ     # Lo    [16] KATAKANA LETTER SMALL KU..KATAKANA LETTER SMALL RO
3200..321E;ID     # So    [31] PARENTHESIZED HANGUL KIYEOK..PARENTHESIZED KOREAN CHARACTER O HU
3220..3229;ID     # No    [10] PARENTHESIZED IDEOGRAPH ONE..PARENTHESIZED IDEOGRAPH TEN
322A..3247;ID     # So    [30] PARENTHESIZED IDEOGRAPH MOON..CIRCLED IDEOGRAPH KOTO
3248..324F;AI     # No     [8] CIRCLED NUMBER TEN ON BLACK SQUARE..CIRCLED NUMBER EIGHTY ON BLACK SQUARE
3250;ID           # So         PARTNERSHIP SIGN
3251..325F;ID     # No    [15] CIRCLED NUMBER TWENTY ONE..CIRCLED NUMBER THIRTY FIVE
3260..327F;ID     # So    [32] CIRCLED HANGUL KIYEOK..KOREAN STANDARD SYMBOL
3280..3289;ID     # No    [10] CIRCLED IDEOGRAPH ONE..CIRCLED IDEOGRAPH TEN
328A..32B0;ID     # So    [39] CIRCLED IDEOGRAPH MOON..CIRCLED IDEOGRAPH NIGHT
32B1..32BF;ID     # No    [15] CIRCLED NUMBER THIRTY SIX..CIRCLED NUMBER FIFTY
32C0..32FE;ID     # So    [63] IDEOGRAPHIC TELEGRAPH SYMBOL FOR JANUARY..CIRCLED KATAKANA WO
3300..33FF;ID     # So   [256] SQUARE APAATO..SQUARE GAL
3400..4DB5;ID     # Lo  [6582] CJK UNIFIED IDEOGRAPH-3400..CJK UNIFIED IDEOGRAPH-4DB5
4DB6..4DBF;ID     # Cn    [10] <reserved-4DB6>..<reserved-4DBF>
4DC0..4DFF;AL     # So    [64] HEXAGRAM FOR THE CREATIVE HEAVEN..HEXAGRAM FOR BEFORE COMPLETION
4E00..9FCC;ID     # Lo [20941] CJK UNIFIED IDEOGRAPH-4E00..CJK UNIFIED IDEOGRAPH-9FCC
9FCD..9FFF;ID     # Cn    [51] <reserved-9FCD>..<reserved-9FFF>
A000..A014;ID     # Lo    [21] YI SYLLABLE IT..YI SYLLABLE E
A015;NS           # Lm         YI SYLLABLE WU
A016..A48C;ID     # Lo  [1143] YI SYLLABLE BIT..YI SYLLABLE YYR
A490..A4C6;ID     # So    [55] YI RADICAL QOT..YI RADICAL KE
A4D0..A4F7;AL     # Lo    [40] LISU LETTER BA..LISU LETTER OE
A4F8..A4FD;AL     # Lm     [6] LISU LETTER TONE MYA TI..LISU LETTER TONE MYA JEU
A4FE..A4FF;BA     # Po     [2] LISU PUNCTUATION COMMA..LISU PUNCTUATION FULL STOP
A500..A60B;AL     # Lo   [268] VAI SYLLABLE EE..VAI SYLLABLE NG
A60C;AL           # Lm         VAI SYLLABLE LENGTHENER
A60D;BA           # Po         VAI COMMA
A60E;EX           # Po         VAI FULL STOP
A60F;BA           # Po         VAI QUESTION MARK
A610..A61F;AL     # Lo    [16] VAI SYLLABLE NDOLE FA..VAI SYMBOL JONG
A620..A629;NU     # Nd    [10] VAI DIGIT ZERO..VAI DIGIT NINE
A62A..A62B;AL     # Lo     [2] VAI SYLLABLE NDOLE MA..VAI SYLLABLE NDOLE DO
A640..A66D;AL     # L&    [46] CYRILLIC CAPITAL LETTER ZEMLYA..CYRILLIC SMALL LETTER DOUBLE MONOCULAR O
A66E;AL           # Lo         CYRILLIC LETTER MULTIOCULAR O
A66F;CM           # Mn         COMBINING CYRILLIC VZMET
A670..A672;CM     # Me     [3] COMBINING CYRILLIC TEN MILLIONS SIGN..COMBINING CYRILLIC THOUSAND MILLIONS SIGN
A673;AL           # Po         SLAVONIC ASTERISK
A674..A67D;CM     # Mn    [10] COMBINING CYRILLIC LETTER UKRAINIAN IE..COMBINING CYRILLIC PAYEROK
A67E;AL           # Po         CYRILLIC KAVYKA
A67F;AL           # Lm         CYRILLIC PAYEROK
A680..A69B;AL     # L&    [28] CYRILLIC CAPITAL LETTER DWE..CYRILLIC SMALL LETTER CROSSED O
A69C..A69D;AL     # Lm     [2] MODIFIER LETTER CYRILLIC HARD SIGN..MODIFIER LETTER CYRILLIC SOFT SIGN
A69F;CM           # Mn         COMBINING CYRILLIC LETTER IOTIFIED E
A6A0..A6E5;AL     # Lo    [70] BAMUM LETTER A..BAMUM LETTER KI
A6E6..A6EF;AL     # Nl    [10] BAMUM LETTER MO..BAMUM LETTER KOGHOM
A6F0..A6F1;CM     # Mn     [2] BAMUM COMBINING MARK KOQNDON..BAMUM COMBINING MARK TUKWENTIS
A6F2;AL           # Po         BAMUM NJAEMLI
A6F3..A6F7;BA     # Po     [5] BAMUM FULL STOP..BAMUM QUESTION MARK
A700..A716;AL     # Sk    [23] MODIFIER LETTER CHINESE TONE YIN PING..MODIFIER LETTER EXTRA-LOW LEFT-STEM TONE BAR
A717..A71F;AL     # Lm     [9] MODIFIER LETTER DOT VERTICAL BAR..MODIFIER LETTER LOW INVERTED EXCLAMATION MARK
A720..A721;AL     # Sk     [2] MODIFIER LETTER STRESS AND HIGH TONE..MODIFIER LETTER STRESS AND LOW TONE
A722..A76F;AL     # L&    [78] LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF..LATIN SMALL LETTER CON
A770;AL           # Lm         MODIFIER LETTER US
A771..A787;AL     # L&    [23] LATIN SMALL LETTER DUM..LATIN SMALL LETTER INSULAR T
A788;AL           # Lm         MODIFIER LETTER LOW CIRCUMFLEX ACCENT
A789..A78A;AL     # Sk     [2] MODIFIER LETTER COLON..MODIFIER LETTER SHORT EQUALS SIGN
A78B..A78E;AL     # L&     [4] LATIN CAPITAL LETTER SALTILLO..LATIN SMALL LETTER L WITH RETROFLEX HOOK AND BELT
A790..A7AD;AL     # L&    [30] LATIN CAPITAL LETTER N WITH DESCENDER..LATIN CAPITAL LETTER L WITH BELT
A7B0..A7B1;AL     # Lu     [2] LATIN CAPITAL LETTER TURNED K..LATIN CAPITAL LETTER TURNED T
A7F7;AL           # Lo         LATIN EPIGRAPHIC LETTER SIDEWAYS I
A7F8..A7F9;AL     # Lm     [2] MODIFIER LETTER CAPITAL H WITH STROKE..MODIFIER LETTER SMALL LIGATURE OE
A7FA;AL           # Ll         LATIN LETTER SMALL CAPITAL TURNED M
A7FB..A7FF;AL     # Lo     [5] LATIN EPIGRAPHIC LETTER REVERSED F..LATIN EPIGRAPHIC LETTER ARCHAIC M
A800..A801;AL     # Lo     [2] SYLOTI NAGRI LETTER A..SYLOTI NAGRI LETTER I
A802;CM           # Mn         SYLOTI NAGRI SIGN DVISVARA
A803..A805;AL     # Lo     [3] SYLOTI NAGRI LETTER U..SYLOTI NAGRI LETTER O
A806;CM           # Mn         SYLOTI NAGRI SIGN HASANTA
A807..A80A;AL     # Lo     [4] SYLOTI NAGRI LETTER KO..SYLOTI NAGRI LETTER GHO
A80B;CM           # Mn         SYLOTI NAGRI SIGN ANUSVARA
A80C..A822;AL     # Lo    [23] SYLOTI NAGRI LETTER CO..SYLOTI NAGRI LETTER HO
A823..A824;CM     # Mc     [2] SYLOTI NAGRI VOWEL SIGN A..SYLOTI NAGRI VOWEL SIGN I
A825..A826;CM     # Mn     [2] SYLOTI NAGRI VOWEL SIGN U..SYLOTI NAGRI VOWEL SIGN E
A827;CM           # Mc         SYLOTI NAGRI VOWEL SIGN OO
A828..A82B;AL     # So     [4] SYLOTI NAGRI POETRY MARK-1..SYLOTI NAGRI POETRY MARK-4
A830..A835;AL     # No     [6] NORTH INDIC FRACTION ONE QUARTER..NORTH INDIC FRACTION THREE SIXTEENTHS
A836..A837;AL     # So     [2] NORTH INDIC QUARTER MARK..NORTH INDIC PLACEHOLDER MARK
A838;PO           # Sc         NORTH INDIC RUPEE MARK
A839;AL           # So         NORTH INDIC QUANTITY MARK
A840..A873;AL     # Lo    [52] PHAGS-PA LETTER KA..PHAGS-PA LETTER CANDRABINDU
A874..A875;BB     # Po     [2] PHAGS-PA SINGLE HEAD MARK..PHAGS-PA DOUBLE HEAD MARK
A876..A877;EX     # Po     [2] PHAGS-PA MARK SHAD..PHAGS-PA MARK DOUBLE SHAD
A880..A881;CM     # Mc     [2] SAURASHTRA SIGN ANUSVARA..SAURASHTRA SIGN VISARGA
A882..A8B3;AL     # Lo    [50] SAURASHTRA LETTER A..SAURASHTRA LETTER LLA
A8B4..A8C3;CM     # Mc    [16] SAURASHTRA CONSONANT SIGN HAARU..SAURASHTRA VOWEL SIGN AU
A8C4;CM           # Mn         SAURASHTRA SIGN VIRAMA
A8CE..A8CF;BA     # Po     [2] SAURASHTRA DANDA..SAURASHTRA DOUBLE DANDA
A8D0..A8D9;NU     # Nd    [10] SAURASHTRA DIGIT ZERO..SAURASHTRA DIGIT NINE
A8E0..A8F1;CM     # Mn    [18] COMBINING DEVANAGARI DIGIT ZERO..COMBINING DEVANAGARI SIGN AVAGRAHA
A8F2..A8F7;AL     # Lo     [6] DEVANAGARI SIGN SPACING CANDRABINDU..DEVANAGARI SIGN CANDRABINDU AVAGRAHA
A8F8..A8FA;AL     # Po     [3] DEVANAGARI SIGN PUSHPIKA..DEVANAGARI CARET
A8FB;AL           # Lo         DEVANAGARI HEADSTROKE
A900..A909;NU     # Nd    [10] KAYAH LI DIGIT ZERO..KAYAH LI DIGIT NINE
A90A..A925;AL     # Lo    [28] KAYAH LI LETTER KA..KAYAH LI LETTER OO
A926..A92D;CM     # Mn     [8] KAYAH LI VOWEL UE..KAYAH LI TONE CALYA PLOPHU
A92E..A92F;BA     # Po     [2] KAYAH LI SIGN CWI..KAYAH LI SIGN SHYA
A930..A946;AL     # Lo    [23] REJANG LETTER KA..REJANG LETTER A
A947..A951;CM     # Mn    [11] REJANG VOWEL SIGN I..REJANG CONSONANT SIGN R
A952..A953;CM     # Mc     [2] REJANG CONSONANT SIGN H..REJANG VIRAMA
A95F;AL           # Po         REJANG SECTION MARK
A960..A97C;JL     # Lo    [29] HANGUL CHOSEONG TIKEUT-MIEUM..HANGUL CHOSEONG SSANGYEORINHIEUH
A980..A982;CM     # Mn     [3] JAVANESE SIGN PANYANGGA..JAVANESE SIGN LAYAR
A983;CM           # Mc         JAVANESE SIGN WIGNYAN
A984..A9B2;AL     # Lo    [47] JAVANESE LETTER A..JAVANESE LETTER HA
A9B3;CM           # Mn         JAVANESE SIGN CECAK TELU
A9B4..A9B5;CM     # Mc     [2] JAVANESE VOWEL SIGN TARUNG..JAVANESE VOWEL SIGN TOLONG
A9B6..A9B9;CM     # Mn     [4] JAVANESE VOWEL SIGN WULU..JAVANESE VOWEL SIGN SUKU MENDUT
A9BA..A9BB;CM     # Mc     [2] JAVANESE VOWEL SIGN TALING..JAVANESE VOWEL SIGN DIRGA MURE
A9BC;CM           # Mn         JAVANESE VOWEL SIGN PEPET
A9BD..A9C0;CM     # Mc     [4] JAVANESE CONSONANT SIGN KERET..JAVANESE PANGKON
A9C1..A9C6;AL     # Po     [6] JAVANESE LEFT RERENGGAN..JAVANESE PADA WINDU
A9C7..A9C9;BA     # Po     [3] JAVANESE PADA PANGKAT..JAVANESE PADA LUNGSI
A9CA..A9CD;AL     # Po     [4] JAVANESE PADA ADEG..JAVANESE TURNED PADA PISELEH
A9CF;AL           # Lm         JAVANESE PANGRANGKEP
A9D0..A9D9;NU     # Nd    [10] JAVANESE DIGIT ZERO..JAVANESE DIGIT NINE
A9DE..A9DF;AL     # Po     [2] JAVANESE PADA TIRTA TUMETES..JAVANESE PADA ISEN-ISEN
A9E0..A9E4;SA     # Lo     [5] MYANMAR LETTER SHAN GHA..MYANMAR LETTER SHAN BHA
A9E5;SA           # Mn         MYANMAR SIGN SHAN SAW
A9E6;SA           # Lm         MYANMAR MODIFIER LETTER SHAN REDUPLICATION
A9E7..A9EF;SA     # Lo     [9] MYANMAR LETTER TAI LAING NYA..MYANMAR LETTER TAI LAING NNA
A9F0..A9F9;NU     # Nd    [10] MYANMAR TAI LAING DIGIT ZERO..MYANMAR TAI LAING DIGIT NINE
A9FA..A9FE;SA     # Lo     [5] MYANMAR LETTER TAI LAING LLA..MYANMAR LETTER TAI LAING BHA
AA00..AA28;AL     # Lo    [41] CHAM LETTER A..CHAM LETTER HA
AA29..AA2E;CM     # Mn     [6] CHAM VOWEL SIGN AA..CHAM VOWEL SIGN OE
AA2F..AA30;CM     # Mc     [2] CHAM VOWEL SIGN O..CHAM VOWEL SIGN AI
AA31..AA32;CM     # Mn     [2] CHAM VOWEL SIGN AU..CHAM VOWEL SIGN UE
AA33..AA34;CM     # Mc     [2] CHAM CONSONANT SIGN YA..CHAM CONSONANT SIGN RA
AA35..AA36;CM     # Mn     [2] CHAM CONSONANT SIGN LA..CHAM CONSONANT SIGN WA
AA40..AA42;AL     # Lo     [3] CHAM LETTER FINAL K..CHAM LETTER FINAL NG
AA43;CM           # Mn         CHAM CONSONANT SIGN FINAL NG
AA44..AA4B;AL     # Lo     [8] CHAM LETTER FINAL CH..CHAM LETTER FINAL SS
AA4C;CM           # Mn         CHAM CONSONANT SIGN FINAL M
AA4D;CM           # Mc         CHAM CONSONANT SIGN FINAL H
AA50..AA59;NU     # Nd    [10] CHAM DIGIT ZERO..CHAM DIGIT NINE
AA5C;AL           # Po         CHAM PUNCTUATION SPIRAL
AA5D..AA5F;BA     # Po     [3] CHAM PUNCTUATION DANDA..CHAM PUNCTUATION TRIPLE DANDA
AA60..AA6F;SA     # Lo    [16] MYANMAR LETTER KHAMTI GA..MYANMAR LETTER KHAMTI FA
AA70;SA           # Lm         MYANMAR MODIFIER LETTER KHAMTI REDUPLICATION
AA71..AA76;SA     # Lo     [6] MYANMAR LETTER KHAMTI XA..MYANMAR LOGOGRAM KHAMTI HM
AA77..AA79;SA     # So     [3] MYANMAR SYMBOL AITON EXCLAMATION..MYANMAR SYMBOL AITON TWO
AA7A;SA           # Lo         MYANMAR LETTER AITON RA
AA7B;SA           # Mc         MYANMAR SIGN PAO KAREN TONE
AA7C;SA           # Mn         MYANMAR SIGN TAI LAING TONE-2
AA7D;SA           # Mc         MYANMAR SIGN TAI LAING TONE-5
AA7E..AA7F;SA     # Lo     [2] MYANMAR LETTER SHWE PALAUNG CHA..MYANMAR LETTER SHWE PALAUNG SHA
AA80..AAAF;SA     # Lo    [48] TAI VIET LETTER LOW KO..TAI VIET LETTER HIGH O
AAB0;SA           # Mn         TAI VIET MAI KANG
AAB1;SA           # Lo         TAI VIET VOWEL AA
AAB2..AAB4;SA     # Mn     [3] TAI VIET VOWEL I..TAI VIET VOWEL U
AAB5..AAB6;SA     # Lo     [2] TAI VIET VOWEL E..TAI VIET VOWEL O
AAB7..AAB8;SA     # Mn     [2] TAI VIET MAI KHIT..TAI VIET VOWEL IA
AAB9..AABD;SA     # Lo     [5] TAI VIET VOWEL UEA..TAI VIET VOWEL AN
AABE..AABF;SA     # Mn     [2] TAI VIET VOWEL AM..TAI VIET TONE MAI EK
AAC0;SA           # Lo         TAI VIET TONE MAI NUENG
AAC1;SA           # Mn         TAI VIET TONE MAI THO
AAC2;SA           # Lo         TAI VIET TONE MAI SONG
AADB..AADC;SA     # Lo     [2] TAI VIET SYMBOL KON..TAI VIET SYMBOL NUENG
AADD;SA           # Lm         TAI VIET SYMBOL SAM
AADE..AADF;SA     # Po     [2] TAI VIET SYMBOL HO HOI..TAI VIET SYMBOL KOI KOI
AAE0..AAEA;AL     # Lo    [11] MEETEI MAYEK LETTER E..MEETEI MAYEK LETTER SSA
AAEB;CM           # Mc         MEETEI MAYEK VOWEL SIGN II
AAEC..AAED;CM     # Mn     [2] MEETEI MAYEK VOWEL SIGN UU..MEETEI MAYEK VOWEL SIGN AAI
AAEE..AAEF;CM     # Mc     [2] MEETEI MAYEK VOWEL SIGN AU..MEETEI MAYEK VOWEL SIGN AAU
AAF0..AAF1;BA     # Po     [2] MEETEI MAYEK CHEIKHAN..MEETEI MAYEK AHANG KHUDAM
AAF2;AL           # Lo         MEETEI MAYEK ANJI
AAF3..AAF4;AL     # Lm     [2] MEETEI MAYEK SYLLABLE REPETITION MARK..MEETEI MAYEK WORD REPETITION MARK
AAF5;CM           # Mc         MEETEI MAYEK VOWEL SIGN VISARGA
AAF6;CM           # Mn         MEETEI MAYEK VIRAMA
AB01..AB06;AL     # Lo     [6] ETHIOPIC SYLLABLE TTHU..ETHIOPIC SYLLABLE TTHO
AB09..AB0E;AL     # Lo     [6] ETHIOPIC SYLLABLE DDHU..ETHIOPIC SYLLABLE DDHO
AB11..AB16;AL     # Lo     [6] ETHIOPIC SYLLABLE DZU..ETHIOPIC SYLLABLE DZO
AB20..AB26;AL     # Lo     [7] ETHIOPIC SYLLABLE CCHHA..ETHIOPIC SYLLABLE CCHHO
AB28..AB2E;AL     # Lo     [7] ETHIOPIC SYLLABLE BBA..ETHIOPIC SYLLABLE BBO
AB30..AB5A;AL     # Ll    [43] LATIN SMALL LETTER BARRED ALPHA..LATIN SMALL LETTER Y WITH SHORT RIGHT LEG
AB5B;AL           # Sk         MODIFIER BREVE WITH INVERTED BREVE
AB5C..AB5F;AL     # Lm     [4] MODIFIER LETTER SMALL HENG..MODIFIER LETTER SMALL U WITH LEFT HOOK
AB64..AB65;AL     # Ll     [2] LATIN SMALL LETTER INVERTED ALPHA..GREEK LETTER SMALL CAPITAL OMEGA
ABC0..ABE2;AL     # Lo    [35] MEETEI MAYEK LETTER KOK..MEETEI MAYEK LETTER I LONSUM
ABE3..ABE4;CM     # Mc     [2] MEETEI MAYEK VOWEL SIGN ONAP..MEETEI MAYEK VOWEL SIGN INAP
ABE5;CM           # Mn         MEETEI MAYEK VOWEL SIGN ANAP
ABE6..ABE7;CM     # Mc     [2] MEETEI MAYEK VOWEL SIGN YENAP..MEETEI MAYEK VOWEL SIGN SOUNAP
ABE8;CM           # Mn         MEETEI MAYEK VOWEL SIGN UNAP
ABE9..ABEA;CM     # Mc     [2] MEETEI MAYEK VOWEL SIGN CHEINAP..MEETEI MAYEK VOWEL SIGN NUNG
ABEB;BA           # Po         MEETEI MAYEK CHEIKHEI
ABEC;CM           # Mc         MEETEI MAYEK LUM IYEK
ABED;CM           # Mn         MEETEI MAYEK APUN IYEK
ABF0..ABF9;NU     # Nd    [10] MEETEI MAYEK DIGIT ZERO..MEETEI MAYEK DIGIT NINE
AC00;H2           # Lo         HANGUL SYLLABLE GA
AC01..AC1B;H3     # Lo    [27] HANGUL SYLLABLE GAG..HANGUL SYLLABLE GAH
AC1C;H2           # Lo         HANGUL SYLLABLE GAE
AC1D..AC37;H3     # Lo    [27] HANGUL SYLLABLE GAEG..HANGUL SYLLABLE GAEH
AC38;H2           # Lo         HANGUL SYLLABLE GYA
AC39..AC53;H3     # Lo    [27] HANGUL SYLLABLE GYAG..HANGUL SYLLABLE GYAH
AC54;H2           # Lo         HANGUL SYLLABLE GYAE
AC55..AC6F;H3     # Lo    [27] HANGUL SYLLABLE GYAEG..HANGUL SYLLABLE GYAEH
AC70;H2           # Lo         HANGUL SYLLABLE GEO
AC71..AC8B;H3     # Lo    [27] HANGUL SYLLABLE GEOG..HANGUL SYLLABLE GEOH
AC8C;H2           # Lo         HANGUL SYLLABLE GE
AC8D..ACA7;H3     # Lo    [27] HANGUL SYLLABLE GEG..HANGUL SYLLABLE GEH
ACA8;H2           # Lo         HANGUL SYLLABLE GYEO
ACA9..ACC3;H3     # Lo    [27] HANGUL SYLLABLE GYEOG..HANGUL SYLLABLE GYEOH
ACC4;H2           # Lo         HANGUL SYLLABLE GYE
ACC5..ACDF;H3     # Lo    [27] HANGUL SYLLABLE GYEG..HANGUL SYLLABLE GYEH
ACE0;H2           # Lo         HANGUL SYLLABLE GO
ACE1..ACFB;H3     # Lo    [27] HANGUL SYLLABLE GOG..HANGUL SYLLABLE GOH
ACFC;H2           # Lo         HANGUL SYLLABLE GWA
ACFD..AD17;H3     # Lo    [27] HANGUL SYLLABLE GWAG..HANGUL SYLLABLE GWAH
AD18;H2           # Lo         HANGUL SYLLABLE GWAE
AD19..AD33;H3     # Lo    [27] HANGUL SYLLABLE GWAEG..HANGUL SYLLABLE GWAEH
AD34;H2           # Lo         HANGUL SYLLABLE GOE
AD35..AD4F;H3     # Lo    [27] HANGUL SYLLABLE GOEG..HANGUL SYLLABLE GOEH
AD50;H2           # Lo         HANGUL SYLLABLE GYO
AD51..AD6B;H3     # Lo    [27] HANGUL SYLLABLE GYOG..HANGUL SYLLABLE GYOH
AD6C;H2           # Lo         HANGUL SYLLABLE GU
AD6D..AD87;H3     # Lo    [27] HANGUL SYLLABLE GUG..HANGUL SYLLABLE GUH
AD88;H2           # Lo         HANGUL SYLLABLE GWEO
AD89..ADA3;H3     # Lo    [27] HANGUL SYLLABLE GWEOG..HANGUL SYLLABLE GWEOH
ADA4;H2           # Lo         HANGUL SYLLABLE GWE
ADA5..ADBF;H3     # Lo    [27] HANGUL SYLLABLE GWEG..HANGUL SYLLABLE GWEH
ADC0;H2           # Lo         HANGUL SYLLABLE GWI
ADC1..ADDB;H3     # Lo    [27] HANGUL SYLLABLE GWIG..HANGUL SYLLABLE GWIH
ADDC;H2           # Lo         HANGUL SYLLABLE GYU
ADDD..ADF7;H3     # Lo    [27] HANGUL SYLLABLE GYUG..HANGUL SYLLABLE GYUH
ADF8;H2           # Lo         HANGUL SYLLABLE GEU
ADF9..AE13;H3     # Lo    [27] HANGUL SYLLABLE GEUG..HANGUL SYLLABLE GEUH
AE14;H2           # Lo         HANGUL SYLLABLE GYI
AE15..AE2F;H3     # Lo    [27] HANGUL SYLLABLE GYIG..HANGUL SYLLABLE GYIH
AE30;H2           # Lo         HANGUL SYLLABLE GI
AE31..AE4B;H3     # Lo    [27] HANGUL SYLLABLE GIG..HANGUL SYLLABLE GIH
AE4C;H2           # Lo         HANGUL SYLLABLE GGA
AE4D..AE67;H3     # Lo    [27] HANGUL SYLLABLE GGAG..HANGUL SYLLABLE GGAH
AE68;H2           # Lo         HANGUL SYLLABLE GGAE
AE69..AE83;H3     # Lo    [27] HANGUL SYLLABLE GGAEG..HANGUL SYLLABLE GGAEH
AE84;H2           # Lo         HANGUL SYLLABLE GGYA
AE85..AE9F;H3     # Lo    [27] HANGUL SYLLABLE GGYAG..HANGUL SYLLABLE GGYAH
AEA0;H2           # Lo         HANGUL SYLLABLE GGYAE
AEA1..AEBB;H3     # Lo    [27] HANGUL SYLLABLE GGYAEG..HANGUL SYLLABLE GGYAEH
AEBC;H2           # Lo         HANGUL SYLLABLE GGEO
AEBD..AED7;H3     # Lo    [27] HANGUL SYLLABLE GGEOG..HANGUL SYLLABLE GGEOH
AED8;H2           # Lo         HANGUL SYLLABLE GGE
AED9..AEF3;H3     # Lo    [27] HANGUL SYLLABLE GGEG..HANGUL SYLLABLE GGEH
AEF4;H2           # Lo         HANGUL SYLLABLE GGYEO
AEF5..AF0F;H3     # Lo    [27] HANGUL SYLLABLE GGYEOG..HANGUL SYLLABLE GGYEOH
AF10;H2           # Lo         HANGUL SYLLABLE GGYE
AF11..AF2B;H3     # Lo    [27] HANGUL SYLLABLE GGYEG..HANGUL SYLLABLE GGYEH
AF2C;H2           # Lo         HANGUL SYLLABLE GGO
AF2D..AF47;H3     # Lo    [27] HANGUL SYLLABLE GGOG..HANGUL SYLLABLE GGOH
AF48;H2           # Lo         HANGUL SYLLABLE GGWA
AF49..AF63;H3     # Lo    [27] HANGUL SYLLABLE GGWAG..HANGUL SYLLABLE GGWAH
AF64;H2           # Lo         HANGUL SYLLABLE GGWAE
AF65..AF7F;H3     # Lo    [27] HANGUL SYLLABLE GGWAEG..HANGUL SYLLABLE GGWAEH
AF80;H2           # Lo         HANGUL SYLLABLE GGOE
AF81..AF9B;H3     # Lo    [27] HANGUL SYLLABLE GGOEG..HANGUL SYLLABLE GGOEH
AF9C;H2           # Lo         HANGUL SYLLABLE GGYO
AF9D..AFB7;H3     # Lo    [27] HANGUL SYLLABLE GGYOG..HANGUL SYLLABLE GGYOH
AFB8;H2           # Lo         HANGUL SYLLABLE GGU
AFB9..AFD3;H3     # Lo    [27] HANGUL SYLLABLE GGUG..HANGUL SYLLABLE GGUH
AFD4;H2           # Lo         HANGUL SYLLABLE GGWEO
AFD5..AFEF;H3     # Lo    [27] HANGUL SYLLABLE GGWEOG..HANGUL SYLLABLE GGWEOH
AFF0;H2           # Lo         HANGUL SYLLABLE GGWE
AFF1..B00B;H3     # Lo    [27] HANGUL SYLLABLE GGWEG..HANGUL SYLLABLE GGWEH
B00C;H2           # Lo         HANGUL SYLLABLE GGWI
B00D..B027;H3     # Lo    [27] HANGUL SYLLABLE GGWIG..HANGUL SYLLABLE GGWIH
B028;H2           # Lo         HANGUL SYLLABLE GGYU
B029..B043;H3     # Lo    [27] HANGUL SYLLABLE GGYUG..HANGUL SYLLABLE GGYUH
B044;H2           # Lo         HANGUL SYLLABLE GGEU
B045..B05F;H3     # Lo    [27] HANGUL SYLLABLE GGEUG..HANGUL SYLLABLE GGEUH
B060;H2           # Lo         HANGUL SYLLABLE GGYI
B061..B07B;H3     # Lo    [27] HANGUL SYLLABLE GGYIG..HANGUL SYLLABLE GGYIH
B07C;H2           # Lo         HANGUL SYLLABLE GGI
B07D..B097;H3     # Lo    [27] HANGUL SYLLABLE GGIG..HANGUL SYLLABLE GGIH
B098;H2           # Lo         HANGUL SYLLABLE NA
B099..B0B3;H3     # Lo    [27] HANGUL SYLLABLE NAG..HANGUL SYLLABLE NAH
B0B4;H2           # Lo         HANGUL SYLLABLE NAE
B0B5..B0CF;H3     # Lo    [27] HANGUL SYLLABLE NAEG..HANGUL SYLLABLE NAEH
B0D0;H2           # Lo         HANGUL SYLLABLE NYA
B0D1..B0EB;H3     # Lo    [27] HANGUL SYLLABLE NYAG..HANGUL SYLLABLE NYAH
B0EC;H2           # Lo         HANGUL SYLLABLE NYAE
B0ED..B107;H3     # Lo    [27] HANGUL SYLLABLE NYAEG..HANGUL SYLLABLE NYAEH
B108;H2           # Lo         HANGUL SYLLABLE NEO
B109..B123;H3     # Lo    [27] HANGUL SYLLABLE NEOG..HANGUL SYLLABLE NEOH
B124;H2           # Lo         HANGUL SYLLABLE NE
B125..B13F;H3     # Lo    [27] HANGUL SYLLABLE NEG..HANGUL SYLLABLE NEH
B140;H2           # Lo         HANGUL SYLLABLE NYEO
B141..B15B;H3     # Lo    [27] HANGUL SYLLABLE NYEOG..HANGUL SYLLABLE NYEOH
B15C;H2           # Lo         HANGUL SYLLABLE NYE
B15D..B177;H3     # Lo    [27] HANGUL SYLLABLE NYEG..HANGUL SYLLABLE NYEH
B178;H2           # Lo         HANGUL SYLLABLE NO
B179..B193;H3     # Lo    [27] HANGUL SYLLABLE NOG..HANGUL SYLLABLE NOH
B194;H2           # Lo         HANGUL SYLLABLE NWA
B195..B1AF;H3     # Lo    [27] HANGUL SYLLABLE NWAG..HANGUL SYLLABLE NWAH
B1B0;H2           # Lo         HANGUL SYLLABLE NWAE
B1B1..B1CB;H3     # Lo    [27] HANGUL SYLLABLE NWAEG..HANGUL SYLLABLE NWAEH
B1CC;H2           # Lo         HANGUL SYLLABLE NOE
B1CD..B1E7;H3     # Lo    [27] HANGUL SYLLABLE NOEG..HANGUL SYLLABLE NOEH
B1E8;H2           # Lo         HANGUL SYLLABLE NYO
B1E9..B203;H3     # Lo    [27] HANGUL SYLLABLE NYOG..HANGUL SYLLABLE NYOH
B204;H2           # Lo         HANGUL SYLLABLE NU
B205..B21F;H3     # Lo    [27] HANGUL SYLLABLE NUG..HANGUL SYLLABLE NUH
B220;H2           # Lo         HANGUL SYLLABLE NWEO
B221..B23B;H3     # Lo    [27] HANGUL SYLLABLE NWEOG..HANGUL SYLLABLE NWEOH
B23C;H2           # Lo         HANGUL SYLLABLE NWE
B23D..B257;H3     # Lo    [27] HANGUL SYLLABLE NWEG..HANGUL SYLLABLE NWEH
B258;H2           # Lo         HANGUL SYLLABLE NWI
B259..B273;H3     # Lo    [27] HANGUL SYLLABLE NWIG..HANGUL SYLLABLE NWIH
B274;H2           # Lo         HANGUL SYLLABLE NYU
B275..B28F;H3     # Lo    [27] HANGUL SYLLABLE NYUG..HANGUL SYLLABLE NYUH
B290;H2           # Lo         HANGUL SYLLABLE NEU
B291..B2AB;H3     # Lo    [27] HANGUL SYLLABLE NEUG..HANGUL SYLLABLE NEUH
B2AC;H2           # Lo         HANGUL SYLLABLE NYI
B2AD..B2C7;H3     # Lo    [27] HANGUL SYLLABLE NYIG..HANGUL SYLLABLE NYIH
B2C8;H2           # Lo         HANGUL SYLLABLE NI
B2C9..B2E3;H3     # Lo    [27] HANGUL SYLLABLE NIG..HANGUL SYLLABLE NIH
B2E4;H2           # Lo         HANGUL SYLLABLE DA
B2E5..B2FF;H3     # Lo    [27] HANGUL SYLLABLE DAG..HANGUL SYLLABLE DAH
B300;H2           # Lo         HANGUL SYLLABLE DAE
B301..B31B;H3     # Lo    [27] HANGUL SYLLABLE DAEG..HANGUL SYLLABLE DAEH
B31C;H2           # Lo         HANGUL SYLLABLE DYA
B31D..B337;H3     # Lo    [27] HANGUL SYLLABLE DYAG..HANGUL SYLLABLE DYAH
B338;H2           # Lo         HANGUL SYLLABLE DYAE
B339..B353;H3     # Lo    [27] HANGUL SYLLABLE DYAEG..HANGUL SYLLABLE DYAEH
B354;H2           # Lo         HANGUL SYLLABLE DEO
B355..B36F;H3     # Lo    [27] HANGUL SYLLABLE DEOG..HANGUL SYLLABLE DEOH
B370;H2           # Lo         HANGUL SYLLABLE DE
B371..B38B;H3     # Lo    [27] HANGUL SYLLABLE DEG..HANGUL SYLLABLE DEH
B38C;H2           # Lo         HANGUL SYLLABLE DYEO
B38D..B3A7;H3     # Lo    [27] HANGUL SYLLABLE DYEOG..HANGUL SYLLABLE DYEOH
B3A8;H2           # Lo         HANGUL SYLLABLE DYE
B3A9..B3C3;H3     # Lo    [27] HANGUL SYLLABLE DYEG..HANGUL SYLLABLE DYEH
B3C4;H2           # Lo         HANGUL SYLLABLE DO
B3C5..B3DF;H3     # Lo    [27] HANGUL SYLLABLE DOG..HANGUL SYLLABLE DOH
B3E0;H2           # Lo         HANGUL SYLLABLE DWA
B3E1..B3FB;H3     # Lo    [27] HANGUL SYLLABLE DWAG..HANGUL SYLLABLE DWAH
B3FC;H2           # Lo         HANGUL SYLLABLE DWAE
B3FD..B417;H3     # Lo    [27] HANGUL SYLLABLE DWAEG..HANGUL SYLLABLE DWAEH
B418;H2           # Lo         HANGUL SYLLABLE DOE
B419..B433;H3     # Lo    [27] HANGUL SYLLABLE DOEG..HANGUL SYLLABLE DOEH
B434;H2           # Lo         HANGUL SYLLABLE DYO
B435..B44F;H3     # Lo    [27] HANGUL SYLLABLE DYOG..HANGUL SYLLABLE DYOH
B450;H2           # Lo         HANGUL SYLLABLE DU
B451..B46B;H3     # Lo    [27] HANGUL SYLLABLE DUG..HANGUL SYLLABLE DUH
B46C;H2           # Lo         HANGUL SYLLABLE DWEO
B46D..B487;H3     # Lo    [27] HANGUL SYLLABLE DWEOG..HANGUL SYLLABLE DWEOH
B488;H2           # Lo         HANGUL SYLLABLE DWE
B489..B4A3;H3     # Lo    [27] HANGUL SYLLABLE DWEG..HANGUL SYLLABLE DWEH
B4A4;H2           # Lo         HANGUL SYLLABLE DWI
B4A5..B4BF;H3     # Lo    [27] HANGUL SYLLABLE DWIG..HANGUL SYLLABLE DWIH
B4C0;H2           # Lo         HANGUL SYLLABLE DYU
B4C1..B4DB;H3     # Lo    [27] HANGUL SYLLABLE DYUG..HANGUL SYLLABLE DYUH
B4DC;H2           # Lo         HANGUL SYLLABLE DEU
B4DD..B4F7;H3     # Lo    [27] HANGUL SYLLABLE DEUG..HANGUL SYLLABLE DEUH
B4F8;H2           # Lo         HANGUL SYLLABLE DYI
B4F9..B513;H3     # Lo    [27] HANGUL SYLLABLE DYIG..HANGUL SYLLABLE DYIH
B514;H2           # Lo         HANGUL SYLLABLE DI
B515..B52F;H3     # Lo    [27] HANGUL SYLLABLE DIG..HANGUL SYLLABLE DIH
B530;H2           # Lo         HANGUL SYLLABLE DDA
B531..B54B;H3     # Lo    [27] HANGUL SYLLABLE DDAG..HANGUL SYLLABLE DDAH
B54C;H2           # Lo         HANGUL SYLLABLE DDAE
B54D..B567;H3     # Lo    [27] HANGUL SYLLABLE DDAEG..HANGUL SYLLABLE DDAEH
B568;H2           # Lo         HANGUL SYLLABLE DDYA
B569..B583;H3     # Lo    [27] HANGUL SYLLABLE DDYAG..HANGUL SYLLABLE DDYAH
B584;H2           # Lo         HANGUL SYLLABLE DDYAE
B585..B59F;H3     # Lo    [27] HANGUL SYLLABLE DDYAEG..HANGUL SYLLABLE DDYAEH
B5A0;H2           # Lo         HANGUL SYLLABLE DDEO
B5A1..B5BB;H3     # Lo    [27] HANGUL SYLLABLE DDEOG..HANGUL SYLLABLE DDEOH
B5BC;H2           # Lo         HANGUL SYLLABLE DDE
B5BD..B5D7;H3     # Lo    [27] HANGUL SYLLABLE DDEG..HANGUL SYLLABLE DDEH
B5D8;H2           # Lo         HANGUL SYLLABLE DDYEO
B5D9..B5F3;H3     # Lo    [27] HANGUL SYLLABLE DDYEOG..HANGUL SYLLABLE DDYEOH
B5F4;H2           # Lo         HANGUL SYLLABLE DDYE
B5F5..B60F;H3     # Lo    [27] HANGUL SYLLABLE DDYEG..HANGUL SYLLABLE DDYEH
B610;H2           # Lo         HANGUL SYLLABLE DDO
B611..B62B;H3     # Lo    [27] HANGUL SYLLABLE DDOG..HANGUL SYLLABLE DDOH
B62C;H2           # Lo         HANGUL SYLLABLE DDWA
B62D..B647;H3     # Lo    [27] HANGUL SYLLABLE DDWAG..HANGUL SYLLABLE DDWAH
B648;H2           # Lo         HANGUL SYLLABLE DDWAE
B649..B663;H3     # Lo    [27] HANGUL SYLLABLE DDWAEG..HANGUL SYLLABLE DDWAEH
B664;H2           # Lo         HANGUL SYLLABLE DDOE
B665..B67F;H3     # Lo    [27] HANGUL SYLLABLE DDOEG..HANGUL SYLLABLE DDOEH
B680;H2           # Lo         HANGUL SYLLABLE DDYO
B681..B69B;H3     # Lo    [27] HANGUL SYLLABLE DDYOG..HANGUL SYLLABLE DDYOH
B69C;H2           # Lo         HANGUL SYLLABLE DDU
B69D..B6B7;H3     # Lo    [27] HANGUL SYLLABLE DDUG..HANGUL SYLLABLE DDUH
B6B8;H2           # Lo         HANGUL SYLLABLE DDWEO
B6B9..B6D3;H3     # Lo    [27] HANGUL SYLLABLE DDWEOG..HANGUL SYLLABLE DDWEOH
B6D4;H2           # Lo         HANGUL SYLLABLE DDWE
B6D5..B6EF;H3     # Lo    [27] HANGUL SYLLABLE DDWEG..HANGUL SYLLABLE DDWEH
B6F0;H2           # Lo         HANGUL SYLLABLE DDWI
B6F1..B70B;H3     # Lo    [27] HANGUL SYLLABLE DDWIG..HANGUL SYLLABLE DDWIH
B70C;H2           # Lo         HANGUL SYLLABLE DDYU
B70D..B727;H3     # Lo    [27] HANGUL SYLLABLE DDYUG..HANGUL SYLLABLE DDYUH
B728;H2           # Lo         HANGUL SYLLABLE DDEU
B729..B743;H3     # Lo    [27] HANGUL SYLLABLE DDEUG..HANGUL SYLLABLE DDEUH
B744;H2           # Lo         HANGUL SYLLABLE DDYI
B745..B75F;H3     # Lo    [27] HANGUL SYLLABLE DDYIG..HANGUL SYLLABLE DDYIH
B760;H2           # Lo         HANGUL SYLLABLE DDI
B761..B77B;H3     # Lo    [27] HANGUL SYLLABLE DDIG..HANGUL SYLLABLE DDIH
B77C;H2           # Lo         HANGUL SYLLABLE RA
B77D..B797;H3     # Lo    [27] HANGUL SYLLABLE RAG..HANGUL SYLLABLE RAH
B798;H2           # Lo         HANGUL SYLLABLE RAE
B799..B7B3;H3     # Lo    [27] HANGUL SYLLABLE RAEG..HANGUL SYLLABLE RAEH
B7B4;H2           # Lo         HANGUL SYLLABLE RYA
B7B5..B7CF;H3     # Lo    [27] HANGUL SYLLABLE RYAG..HANGUL SYLLABLE RYAH
B7D0;H2           # Lo         HANGUL SYLLABLE RYAE
B7D1..B7EB;H3     # Lo    [27] HANGUL SYLLABLE RYAEG..HANGUL SYLLABLE RYAEH
B7EC;H2           # Lo         HANGUL SYLLABLE REO
B7ED..B807;H3     # Lo    [27] HANGUL SYLLABLE REOG..HANGUL SYLLABLE REOH
B808;H2           # Lo         HANGUL SYLLABLE RE
B809..B823;H3     # Lo    [27] HANGUL SYLLABLE REG..HANGUL SYLLABLE REH
B824;H2           # Lo         HANGUL SYLLABLE RYEO
B825..B83F;H3     # Lo    [27] HANGUL SYLLABLE RYEOG..HANGUL SYLLABLE RYEOH
B840;H2           # Lo         HANGUL SYLLABLE RYE
B841..B85B;H3     # Lo    [27] HANGUL SYLLABLE RYEG..HANGUL SYLLABLE RYEH
B85C;H2           # Lo         HANGUL SYLLABLE RO
B85D..B877;H3     # Lo    [27] HANGUL SYLLABLE ROG..HANGUL SYLLABLE ROH
B878;H2           # Lo         HANGUL SYLLABLE RWA
B879..B893;H3     # Lo    [27] HANGUL SYLLABLE RWAG..HANGUL SYLLABLE RWAH
B894;H2           # Lo         HANGUL SYLLABLE RWAE
B895..B8AF;H3     # Lo    [27] HANGUL SYLLABLE RWAEG..HANGUL SYLLABLE RWAEH
B8B0;H2           # Lo         HANGUL SYLLABLE ROE
B8B1..B8CB;H3     # Lo    [27] HANGUL SYLLABLE ROEG..HANGUL SYLLABLE ROEH
B8CC;H2           # Lo         HANGUL SYLLABLE RYO
B8CD..B8E7;H3     # Lo    [27] HANGUL SYLLABLE RYOG..HANGUL SYLLABLE RYOH
B8E8;H2           # Lo         HANGUL SYLLABLE RU
B8E9..B903;H3     # Lo    [27] HANGUL SYLLABLE RUG..HANGUL SYLLABLE RUH
B904;H2           # Lo         HANGUL SYLLABLE RWEO
B905..B91F;H3     # Lo    [27] HANGUL SYLLABLE RWEOG..HANGUL SYLLABLE RWEOH
B920;H2           # Lo         HANGUL SYLLABLE RWE
B921..B93B;H3     # Lo    [27] HANGUL SYLLABLE RWEG..HANGUL SYLLABLE RWEH
B93C;H2           # Lo         HANGUL SYLLABLE RWI
B93D..B957;H3     # Lo    [27] HANGUL SYLLABLE RWIG..HANGUL SYLLABLE RWIH
B958;H2           # Lo         HANGUL SYLLABLE RYU
B959..B973;H3     # Lo    [27] HANGUL SYLLABLE RYUG..HANGUL SYLLABLE RYUH
B974;H2           # Lo         HANGUL SYLLABLE REU
B975..B98F;H3     # Lo    [27] HANGUL SYLLABLE REUG..HANGUL SYLLABLE REUH
B990;H2           # Lo         HANGUL SYLLABLE RYI
B991..B9AB;H3     # Lo    [27] HANGUL SYLLABLE RYIG..HANGUL SYLLABLE RYIH
B9AC;H2           # Lo         HANGUL SYLLABLE RI
B9AD..B9C7;H3     # Lo    [27] HANGUL SYLLABLE RIG..HANGUL SYLLABLE RIH
B9C8;H2           # Lo         HANGUL SYLLABLE MA
B9C9..B9E3;H3     # Lo    [27] HANGUL SYLLABLE MAG..HANGUL SYLLABLE MAH
B9E4;H2           # Lo         HANGUL SYLLABLE MAE
B9E5..B9FF;H3     # Lo    [27] HANGUL SYLLABLE MAEG..HANGUL SYLLABLE MAEH
BA00;H2           # Lo         HANGUL SYLLABLE MYA
BA01..BA1B;H3     # Lo    [27] HANGUL SYLLABLE MYAG..HANGUL SYLLABLE MYAH
BA1C;H2           # Lo         HANGUL SYLLABLE MYAE
BA1D..BA37;H3     # Lo    [27] HANGUL SYLLABLE MYAEG..HANGUL SYLLABLE MYAEH
BA38;H2           # Lo         HANGUL SYLLABLE MEO
BA39..BA53;H3     # Lo    [27] HANGUL SYLLABLE MEOG..HANGUL SYLLABLE MEOH
BA54;H2           # Lo         HANGUL SYLLABLE ME
BA55..BA6F;H3     # Lo    [27] HANGUL SYLLABLE MEG..HANGUL SYLLABLE MEH
BA70;H2           # Lo         HANGUL SYLLABLE MYEO
BA71..BA8B;H3     # Lo    [27] HANGUL SYLLABLE MYEOG..HANGUL SYLLABLE MYEOH
BA8C;H2           # Lo         HANGUL SYLLABLE MYE
BA8D..BAA7;H3     # Lo    [27] HANGUL SYLLABLE MYEG..HANGUL SYLLABLE MYEH
BAA8;H2           # Lo         HANGUL SYLLABLE MO
BAA9..BAC3;H3     # Lo    [27] HANGUL SYLLABLE MOG..HANGUL SYLLABLE MOH
BAC4;H2           # Lo         HANGUL SYLLABLE MWA
BAC5..BADF;H3     # Lo    [27] HANGUL SYLLABLE MWAG..HANGUL SYLLABLE MWAH
BAE0;H2           # Lo         HANGUL SYLLABLE MWAE
BAE1..BAFB;H3     # Lo    [27] HANGUL SYLLABLE MWAEG..HANGUL SYLLABLE MWAEH
BAFC;H2           # Lo         HANGUL SYLLABLE MOE
BAFD..BB17;H3     # Lo    [27] HANGUL SYLLABLE MOEG..HANGUL SYLLABLE MOEH
BB18;H2           # Lo         HANGUL SYLLABLE MYO
BB19..BB33;H3     # Lo    [27] HANGUL SYLLABLE MYOG..HANGUL SYLLABLE MYOH
BB34;H2           # Lo         HANGUL SYLLABLE MU
BB35..BB4F;H3     # Lo    [27] HANGUL SYLLABLE MUG..HANGUL SYLLABLE MUH
BB50;H2           # Lo         HANGUL SYLLABLE MWEO
BB51..BB6B;H3     # Lo    [27] HANGUL SYLLABLE MWEOG..HANGUL SYLLABLE MWEOH
BB6C;H2           # Lo         HANGUL SYLLABLE MWE
BB6D..BB87;H3     # Lo    [27] HANGUL SYLLABLE MWEG..HANGUL SYLLABLE MWEH
BB88;H2           # Lo         HANGUL SYLLABLE MWI
BB89..BBA3;H3     # Lo    [27] HANGUL SYLLABLE MWIG..HANGUL SYLLABLE MWIH
BBA4;H2           # Lo         HANGUL SYLLABLE MYU
BBA5..BBBF;H3     # Lo    [27] HANGUL SYLLABLE MYUG..HANGUL SYLLABLE MYUH
BBC0;H2           # Lo         HANGUL SYLLABLE MEU
BBC1..BBDB;H3     # Lo    [27] HANGUL SYLLABLE MEUG..HANGUL SYLLABLE MEUH
BBDC;H2           # Lo         HANGUL SYLLABLE MYI
BBDD..BBF7;H3     # Lo    [27] HANGUL SYLLABLE MYIG..HANGUL SYLLABLE MYIH
BBF8;H2           # Lo         HANGUL SYLLABLE MI
BBF9..BC13;H3     # Lo    [27] HANGUL SYLLABLE MIG..HANGUL SYLLABLE MIH
BC14;H2           # Lo         HANGUL SYLLABLE BA
BC15..BC2F;H3     # Lo    [27] HANGUL SYLLABLE BAG..HANGUL SYLLABLE BAH
BC30;H2           # Lo         HANGUL SYLLABLE BAE
BC31..BC4B;H3     # Lo    [27] HANGUL SYLLABLE BAEG..HANGUL SYLLABLE BAEH
BC4C;H2           # Lo         HANGUL SYLLABLE BYA
BC4D..BC67;H3     # Lo    [27] HANGUL SYLLABLE BYAG..HANGUL SYLLABLE BYAH
BC68;H2           # Lo         HANGUL SYLLABLE BYAE
BC69..BC83;H3     # Lo    [27] HANGUL SYLLABLE BYAEG..HANGUL SYLLABLE BYAEH
BC84;H2           # Lo         HANGUL SYLLABLE BEO
BC85..BC9F;H3     # Lo    [27] HANGUL SYLLABLE BEOG..HANGUL SYLLABLE BEOH
BCA0;H2           # Lo         HANGUL SYLLABLE BE
BCA1..BCBB;H3     # Lo    [27] HANGUL SYLLABLE BEG..HANGUL SYLLABLE BEH
BCBC;H2           # Lo         HANGUL SYLLABLE BYEO
BCBD..BCD7;H3     # Lo    [27] HANGUL SYLLABLE BYEOG..HANGUL SYLLABLE BYEOH
BCD8;H2           # Lo         HANGUL SYLLABLE BYE
BCD9..BCF3;H3     # Lo    [27] HANGUL SYLLABLE BYEG..HANGUL SYLLABLE BYEH
BCF4;H2           # Lo         HANGUL SYLLABLE BO
BCF5..BD0F;H3     # Lo    [27] HANGUL SYLLABLE BOG..HANGUL SYLLABLE BOH
BD10;H2           # Lo         HANGUL SYLLABLE BWA
BD11..BD2B;H3     # Lo    [27] HANGUL SYLLABLE BWAG..HANGUL SYLLABLE BWAH
BD2C;H2           # Lo         HANGUL SYLLABLE BWAE
BD2D..BD47;H3     # Lo    [27] HANGUL SYLLABLE BWAEG..HANGUL SYLLABLE BWAEH
BD48;H2           # Lo         HANGUL SYLLABLE BOE
BD49..BD63;H3     # Lo    [27] HANGUL SYLLABLE BOEG..HANGUL SYLLABLE BOEH
BD64;H2           # Lo         HANGUL SYLLABLE BYO
BD65..BD7F;H3     # Lo    [27] HANGUL SYLLABLE BYOG..HANGUL SYLLABLE BYOH
BD80;H2           # Lo         HANGUL SYLLABLE BU
BD81..BD9B;H3     # Lo    [27] HANGUL SYLLABLE BUG..HANGUL SYLLABLE BUH
BD9C;H2           # Lo         HANGUL SYLLABLE BWEO
BD9D..BDB7;H3     # Lo    [27] HANGUL SYLLABLE BWEOG..HANGUL SYLLABLE BWEOH
BDB8;H2           # Lo         HANGUL SYLLABLE BWE
BDB9..BDD3;H3     # Lo    [27] HANGUL SYLLABLE BWEG..HANGUL SYLLABLE BWEH
BDD4;H2           # Lo         HANGUL SYLLABLE BWI
BDD5..BDEF;H3     # Lo    [27] HANGUL SYLLABLE BWIG..HANGUL SYLLABLE BWIH
BDF0;H2           # Lo         HANGUL SYLLABLE BYU
BDF1..BE0B;H3     # Lo    [27] HANGUL SYLLABLE BYUG..HANGUL SYLLABLE BYUH
BE0C;H2           # Lo         HANGUL SYLLABLE BEU
BE0D..BE27;H3     # Lo    [27] HANGUL SYLLABLE BEUG..HANGUL SYLLABLE BEUH
BE28;H2           # Lo         HANGUL SYLLABLE BYI
BE29..BE43;H3     # Lo    [27] HANGUL SYLLABLE BYIG..HANGUL SYLLABLE BYIH
BE44;H2           # Lo         HANGUL SYLLABLE BI
BE45..BE5F;H3     # Lo    [27] HANGUL SYLLABLE BIG..HANGUL SYLLABLE BIH
BE60;H2           # Lo         HANGUL SYLLABLE BBA
BE61..BE7B;H3     # Lo    [27] HANGUL SYLLABLE BBAG..HANGUL SYLLABLE BBAH
BE7C;H2           # Lo         HANGUL SYLLABLE BBAE
BE7D..BE97;H3     # Lo    [27] HANGUL SYLLABLE BBAEG..HANGUL SYLLABLE BBAEH
BE98;H2           # Lo         HANGUL SYLLABLE BBYA
BE99..BEB3;H3     # Lo    [27] HANGUL SYLLABLE BBYAG..HANGUL SYLLABLE BBYAH
BEB4;H2           # Lo         HANGUL SYLLABLE BBYAE
BEB5..BECF;H3     # Lo    [27] HANGUL SYLLABLE BBYAEG..HANGUL SYLLABLE BBYAEH
BED0;H2           # Lo         HANGUL SYLLABLE BBEO
BED1..BEEB;H3     # Lo    [27] HANGUL SYLLABLE BBEOG..HANGUL SYLLABLE BBEOH
BEEC;H2           # Lo         HANGUL SYLLABLE BBE
BEED..BF07;H3     # Lo    [27] HANGUL SYLLABLE BBEG..HANGUL SYLLABLE BBEH
BF08;H2           # Lo         HANGUL SYLLABLE BBYEO
BF09..BF23;H3     # Lo    [27] HANGUL SYLLABLE BBYEOG..HANGUL SYLLABLE BBYEOH
BF24;H2           # Lo         HANGUL SYLLABLE BBYE
BF25..BF3F;H3     # Lo    [27] HANGUL SYLLABLE BBYEG..HANGUL SYLLABLE BBYEH
BF40;H2           # Lo         HANGUL SYLLABLE BBO
BF41..BF5B;H3     # Lo    [27] HANGUL SYLLABLE BBOG..HANGUL SYLLABLE BBOH
BF5C;H2           # Lo         HANGUL SYLLABLE BBWA
BF5D..BF77;H3     # Lo    [27] HANGUL SYLLABLE BBWAG..HANGUL SYLLABLE BBWAH
BF78;H2           # Lo         HANGUL SYLLABLE BBWAE
BF79..BF93;H3     # Lo    [27] HANGUL SYLLABLE BBWAEG..HANGUL SYLLABLE BBWAEH
BF94;H2           # Lo         HANGUL SYLLABLE BBOE
BF95..BFAF;H3     # Lo    [27] HANGUL SYLLABLE BBOEG..HANGUL SYLLABLE BBOEH
BFB0;H2           # Lo         HANGUL SYLLABLE BBYO
BFB1..BFCB;H3     # Lo    [27] HANGUL SYLLABLE BBYOG..HANGUL SYLLABLE BBYOH
BFCC;H2           # Lo         HANGUL SYLLABLE BBU
BFCD..BFE7;H3     # Lo    [27] HANGUL SYLLABLE BBUG..HANGUL SYLLABLE BBUH
BFE8;H2           # Lo         HANGUL SYLLABLE BBWEO
BFE9..C003;H3     # Lo    [27] HANGUL SYLLABLE BBWEOG..HANGUL SYLLABLE BBWEOH
C004;H2           # Lo         HANGUL SYLLABLE BBWE
C005..C01F;H3     # Lo    [27] HANGUL SYLLABLE BBWEG..HANGUL SYLLABLE BBWEH
C020;H2           # Lo         HANGUL SYLLABLE BBWI
C021..C03B;H3     # Lo    [27] HANGUL SYLLABLE BBWIG..HANGUL SYLLABLE BBWIH
C03C;H2           # Lo         HANGUL SYLLABLE BBYU
C03D..C057;H3     # Lo    [27] HANGUL SYLLABLE BBYUG..HANGUL SYLLABLE BBYUH
C058;H2           # Lo         HANGUL SYLLABLE BBEU
C059..C073;H3     # Lo    [27] HANGUL SYLLABLE BBEUG..HANGUL SYLLABLE BBEUH
C074;H2           # Lo         HANGUL SYLLABLE BBYI
C075..C08F;H3     # Lo    [27] HANGUL SYLLABLE BBYIG..HANGUL SYLLABLE BBYIH
C090;H2           # Lo         HANGUL SYLLABLE BBI
C091..C0AB;H3     # Lo    [27] HANGUL SYLLABLE BBIG..HANGUL SYLLABLE BBIH
C0AC;H2           # Lo         HANGUL SYLLABLE SA
C0AD..C0C7;H3     # Lo    [27] HANGUL SYLLABLE SAG..HANGUL SYLLABLE SAH
C0C8;H2           # Lo         HANGUL SYLLABLE SAE
C0C9..C0E3;H3     # Lo    [27] HANGUL SYLLABLE SAEG..HANGUL SYLLABLE SAEH
C0E4;H2           # Lo         HANGUL SYLLABLE SYA
C0E5..C0FF;H3     # Lo    [27] HANGUL SYLLABLE SYAG..HANGUL SYLLABLE SYAH
C100;H2           # Lo         HANGUL SYLLABLE SYAE
C101..C11B;H3     # Lo    [27] HANGUL SYLLABLE SYAEG..HANGUL SYLLABLE SYAEH
C11C;H2           # Lo         HANGUL SYLLABLE SEO
C11D..C137;H3     # Lo    [27] HANGUL SYLLABLE SEOG..HANGUL SYLLABLE SEOH
C138;H2           # Lo         HANGUL SYLLABLE SE
C139..C153;H3     # Lo    [27] HANGUL SYLLABLE SEG..HANGUL SYLLABLE SEH
C154;H2           # Lo         HANGUL SYLLABLE SYEO
C155..C16F;H3     # Lo    [27] HANGUL SYLLABLE SYEOG..HANGUL SYLLABLE SYEOH
C170;H2           # Lo         HANGUL SYLLABLE SYE
C171..C18B;H3     # Lo    [27] HANGUL SYLLABLE SYEG..HANGUL SYLLABLE SYEH
C18C;H2           # Lo         HANGUL SYLLABLE SO
C18D..C1A7;H3     # Lo    [27] HANGUL SYLLABLE SOG..HANGUL SYLLABLE SOH
C1A8;H2           # Lo         HANGUL SYLLABLE SWA
C1A9..C1C3;H3     # Lo    [27] HANGUL SYLLABLE SWAG..HANGUL SYLLABLE SWAH
C1C4;H2           # Lo         HANGUL SYLLABLE SWAE
C1C5..C1DF;H3     # Lo    [27] HANGUL SYLLABLE SWAEG..HANGUL SYLLABLE SWAEH
C1E0;H2           # Lo         HANGUL SYLLABLE SOE
C1E1..C1FB;H3     # Lo    [27] HANGUL SYLLABLE SOEG..HANGUL SYLLABLE SOEH
C1FC;H2           # Lo         HANGUL SYLLABLE SYO
C1FD..C217;H3     # Lo    [27] HANGUL SYLLABLE SYOG..HANGUL SYLLABLE SYOH
C218;H2           # Lo         HANGUL SYLLABLE SU
C219..C233;H3     # Lo    [27] HANGUL SYLLABLE SUG..HANGUL SYLLABLE SUH
C234;H2           # Lo         HANGUL SYLLABLE SWEO
C235..C24F;H3     # Lo    [27] HANGUL SYLLABLE SWEOG..HANGUL SYLLABLE SWEOH
C250;H2           # Lo         HANGUL SYLLABLE SWE
C251..C26B;H3     # Lo    [27] HANGUL SYLLABLE SWEG..HANGUL SYLLABLE SWEH
C26C;H2           # Lo         HANGUL SYLLABLE SWI
C26D..C287;H3     # Lo    [27] HANGUL SYLLABLE SWIG..HANGUL SYLLABLE SWIH
C288;H2           # Lo         HANGUL SYLLABLE SYU
C289..C2A3;H3     # Lo    [27] HANGUL SYLLABLE SYUG..HANGUL SYLLABLE SYUH
C2A4;H2           # Lo         HANGUL SYLLABLE SEU
C2A5..C2BF;H3     # Lo    [27] HANGUL SYLLABLE SEUG..HANGUL SYLLABLE SEUH
C2C0;H2           # Lo         HANGUL SYLLABLE SYI
C2C1..C2DB;H3     # Lo    [27] HANGUL SYLLABLE SYIG..HANGUL SYLLABLE SYIH
C2DC;H2           # Lo         HANGUL SYLLABLE SI
C2DD..C2F7;H3     # Lo    [27] HANGUL SYLLABLE SIG..HANGUL SYLLABLE SIH
C2F8;H2           # Lo         HANGUL SYLLABLE SSA
C2F9..C313;H3     # Lo    [27] HANGUL SYLLABLE SSAG..HANGUL SYLLABLE SSAH
C314;H2           # Lo         HANGUL SYLLABLE SSAE
C315..C32F;H3     # Lo    [27] HANGUL SYLLABLE SSAEG..HANGUL SYLLABLE SSAEH
C330;H2           # Lo         HANGUL SYLLABLE SSYA
C331..C34B;H3     # Lo    [27] HANGUL SYLLABLE SSYAG..HANGUL SYLLABLE SSYAH
C34C;H2           # Lo         HANGUL SYLLABLE SSYAE
C34D..C367;H3     # Lo    [27] HANGUL SYLLABLE SSYAEG..HANGUL SYLLABLE SSYAEH
C368;H2           # Lo         HANGUL SYLLABLE SSEO
C369..C383;H3     # Lo    [27] HANGUL SYLLABLE SSEOG..HANGUL SYLLABLE SSEOH
C384;H2           # Lo         HANGUL SYLLABLE SSE
C385..C39F;H3     # Lo    [27] HANGUL SYLLABLE SSEG..HANGUL SYLLABLE SSEH
C3A0;H2           # Lo         HANGUL SYLLABLE SSYEO
C3A1..C3BB;H3     # Lo    [27] HANGUL SYLLABLE SSYEOG..HANGUL SYLLABLE SSYEOH
C3BC;H2           # Lo         HANGUL SYLLABLE SSYE
C3BD..C3D7;H3     # Lo    [27] HANGUL SYLLABLE SSYEG..HANGUL SYLLABLE SSYEH
C3D8;H2           # Lo         HANGUL SYLLABLE SSO
C3D9..C3F3;H3     # Lo    [27] HANGUL SYLLABLE SSOG..HANGUL SYLLABLE SSOH
C3F4;H2           # Lo         HANGUL SYLLABLE SSWA
C3F5..C40F;H3     # Lo    [27] HANGUL SYLLABLE SSWAG..HANGUL SYLLABLE SSWAH
C410;H2           # Lo         HANGUL SYLLABLE SSWAE
C411..C42B;H3     # Lo    [27] HANGUL SYLLABLE SSWAEG..HANGUL SYLLABLE SSWAEH
C42C;H2           # Lo         HANGUL SYLLABLE SSOE
C42D..C447;H3     # Lo    [27] HANGUL SYLLABLE SSOEG..HANGUL SYLLABLE SSOEH
C448;H2           # Lo         HANGUL SYLLABLE SSYO
C449..C463;H3     # Lo    [27] HANGUL SYLLABLE SSYOG..HANGUL SYLLABLE SSYOH
C464;H2           # Lo         HANGUL SYLLABLE SSU
C465..C47F;H3     # Lo    [27] HANGUL SYLLABLE SSUG..HANGUL SYLLABLE SSUH
C480;H2           # Lo         HANGUL SYLLABLE SSWEO
C481..C49B;H3     # Lo    [27] HANGUL SYLLABLE SSWEOG..HANGUL SYLLABLE SSWEOH
C49C;H2           # Lo         HANGUL SYLLABLE SSWE
C49D..C4B7;H3     # Lo    [27] HANGUL SYLLABLE SSWEG..HANGUL SYLLABLE SSWEH
C4B8;H2           # Lo         HANGUL SYLLABLE SSWI
C4B9..C4D3;H3     # Lo    [27] HANGUL SYLLABLE SSWIG..HANGUL SYLLABLE SSWIH
C4D4;H2           # Lo         HANGUL SYLLABLE SSYU
C4D5..C4EF;H3     # Lo    [27] HANGUL SYLLABLE SSYUG..HANGUL SYLLABLE SSYUH
C4F0;H2           # Lo         HANGUL SYLLABLE SSEU
C4F1..C50B;H3     # Lo    [27] HANGUL SYLLABLE SSEUG..HANGUL SYLLABLE SSEUH
C50C;H2           # Lo         HANGUL SYLLABLE SSYI
C50D..C527;H3     # Lo    [27] HANGUL SYLLABLE SSYIG..HANGUL SYLLABLE SSYIH
C528;H2           # Lo         HANGUL SYLLABLE SSI
C529..C543;H3     # Lo    [27] HANGUL SYLLABLE SSIG..HANGUL SYLLABLE SSIH
C544;H2           # Lo         HANGUL SYLLABLE A
C545..C55F;H3     # Lo    [27] HANGUL SYLLABLE AG..HANGUL SYLLABLE AH
C560;H2           # Lo         HANGUL SYLLABLE AE
C561..C57B;H3     # Lo    [27] HANGUL SYLLABLE AEG..HANGUL SYLLABLE AEH
C57C;H2           # Lo         HANGUL SYLLABLE YA
C57D..C597;H3     # Lo    [27] HANGUL SYLLABLE YAG..HANGUL SYLLABLE YAH
C598;H2           # Lo         HANGUL SYLLABLE YAE
C599..C5B3;H3     # Lo    [27] HANGUL SYLLABLE YAEG..HANGUL SYLLABLE YAEH
C5B4;H2           # Lo         HANGUL SYLLABLE EO
C5B5..C5CF;H3     # Lo    [27] HANGUL SYLLABLE EOG..HANGUL SYLLABLE EOH
C5D0;H2           # Lo         HANGUL SYLLABLE E
C5D1..C5EB;H3     # Lo    [27] HANGUL SYLLABLE EG..HANGUL SYLLABLE EH
C5EC;H2           # Lo         HANGUL SYLLABLE YEO
C5ED..C607;H3     # Lo    [27] HANGUL SYLLABLE YEOG..HANGUL SYLLABLE YEOH
C608;H2           # Lo         HANGUL SYLLABLE YE
C609..C623;H3     # Lo    [27] HANGUL SYLLABLE YEG..HANGUL SYLLABLE YEH
C624;H2           # Lo         HANGUL SYLLABLE O
C625..C63F;H3     # Lo    [27] HANGUL SYLLABLE OG..HANGUL SYLLABLE OH
C640;H2           # Lo         HANGUL SYLLABLE WA
C641..C65B;H3     # Lo    [27] HANGUL SYLLABLE WAG..HANGUL SYLLABLE WAH
C65C;H2           # Lo         HANGUL SYLLABLE WAE
C65D..C677;H3     # Lo    [27] HANGUL SYLLABLE WAEG..HANGUL SYLLABLE WAEH
C678;H2           # Lo         HANGUL SYLLABLE OE
C679..C693;H3     # Lo    [27] HANGUL SYLLABLE OEG..HANGUL SYLLABLE OEH
C694;H2           # Lo         HANGUL SYLLABLE YO
C695..C6AF;H3     # Lo    [27] HANGUL SYLLABLE YOG..HANGUL SYLLABLE YOH
C6B0;H2           # Lo         HANGUL SYLLABLE U
C6B1..C6CB;H3     # Lo    [27] HANGUL SYLLABLE UG..HANGUL SYLLABLE UH
C6CC;H2           # Lo         HANGUL SYLLABLE WEO
C6CD..C6E7;H3     # Lo    [27] HANGUL SYLLABLE WEOG..HANGUL SYLLABLE WEOH
C6E8;H2           # Lo         HANGUL SYLLABLE WE
C6E9..C703;H3     # Lo    [27] HANGUL SYLLABLE WEG..HANGUL SYLLABLE WEH
C704;H2           # Lo         HANGUL SYLLABLE WI
C705..C71F;H3     # Lo    [27] HANGUL SYLLABLE WIG..HANGUL SYLLABLE WIH
C720;H2           # Lo         HANGUL SYLLABLE YU
C721..C73B;H3     # Lo    [27] HANGUL SYLLABLE YUG..HANGUL SYLLABLE YUH
C73C;H2           # Lo         HANGUL SYLLABLE EU
C73D..C757;H3     # Lo    [27] HANGUL SYLLABLE EUG..HANGUL SYLLABLE EUH
C758;H2           # Lo         HANGUL SYLLABLE YI
C759..C773;H3     # Lo    [27] HANGUL SYLLABLE YIG..HANGUL SYLLABLE YIH
C774;H2           # Lo         HANGUL SYLLABLE I
C775..C78F;H3     # Lo    [27] HANGUL SYLLABLE IG..HANGUL SYLLABLE IH
C790;H2           # Lo         HANGUL SYLLABLE JA
C791..C7AB;H3     # Lo    [27] HANGUL SYLLABLE JAG..HANGUL SYLLABLE JAH
C7AC;H2           # Lo         HANGUL SYLLABLE JAE
C7AD..C7C7;H3     # Lo    [27] HANGUL SYLLABLE JAEG..HANGUL SYLLABLE JAEH
C7C8;H2           # Lo         HANGUL SYLLABLE JYA
C7C9..C7E3;H3     # Lo    [27] HANGUL SYLLABLE JYAG..HANGUL SYLLABLE JYAH
C7E4;H2           # Lo         HANGUL SYLLABLE JYAE
C7E5..C7FF;H3     # Lo    [27] HANGUL SYLLABLE JYAEG..HANGUL SYLLABLE JYAEH
C800;H2           # Lo         HANGUL SYLLABLE JEO
C801..C81B;H3     # Lo    [27] HANGUL SYLLABLE JEOG..HANGUL SYLLABLE JEOH
C81C;H2           # Lo         HANGUL SYLLABLE JE
C81D..C837;H3     # Lo    [27] HANGUL SYLLABLE JEG..HANGUL SYLLABLE JEH
C838;H2           # Lo         HANGUL SYLLABLE JYEO
C839..C853;H3     # Lo    [27] HANGUL SYLLABLE JYEOG..HANGUL SYLLABLE JYEOH
C854;H2           # Lo         HANGUL SYLLABLE JYE
C855..C86F;H3     # Lo    [27] HANGUL SYLLABLE JYEG..HANGUL SYLLABLE JYEH
C870;H2           # Lo         HANGUL SYLLABLE JO
C871..C88B;H3     # Lo    [27] HANGUL SYLLABLE JOG..HANGUL SYLLABLE JOH
C88C;H2           # Lo         HANGUL SYLLABLE JWA
C88D..C8A7;H3     # Lo    [27] HANGUL SYLLABLE JWAG..HANGUL SYLLABLE JWAH
C8A8;H2           # Lo         HANGUL SYLLABLE JWAE
C8A9..C8C3;H3     # Lo    [27] HANGUL SYLLABLE JWAEG..HANGUL SYLLABLE JWAEH
C8C4;H2           # Lo         HANGUL SYLLABLE JOE
C8C5..C8DF;H3     # Lo    [27] HANGUL SYLLABLE JOEG..HANGUL SYLLABLE JOEH
C8E0;H2           # Lo         HANGUL SYLLABLE JYO
C8E1..C8FB;H3     # Lo    [27] HANGUL SYLLABLE JYOG..HANGUL SYLLABLE JYOH
C8FC;H2           # Lo         HANGUL SYLLABLE JU
C8FD..C917;H3     # Lo    [27] HANGUL SYLLABLE JUG..HANGUL SYLLABLE JUH
C918;H2           # Lo         HANGUL SYLLABLE JWEO
C919..C933;H3     # Lo    [27] HANGUL SYLLABLE JWEOG..HANGUL SYLLABLE JWEOH
C934;H2           # Lo         HANGUL SYLLABLE JWE
C935..C94F;H3     # Lo    [27] HANGUL SYLLABLE JWEG..HANGUL SYLLABLE JWEH
C950;H2           # Lo         HANGUL SYLLABLE JWI
C951..C96B;H3     # Lo    [27] HANGUL SYLLABLE JWIG..HANGUL SYLLABLE JWIH
C96C;H2           # Lo         HANGUL SYLLABLE JYU
C96D..C987;H3     # Lo    [27] HANGUL SYLLABLE JYUG..HANGUL SYLLABLE JYUH
C988;H2           # Lo         HANGUL SYLLABLE JEU
C989..C9A3;H3     # Lo    [27] HANGUL SYLLABLE JEUG..HANGUL SYLLABLE JEUH
C9A4;H2           # Lo         HANGUL SYLLABLE JYI
C9A5..C9BF;H3     # Lo    [27] HANGUL SYLLABLE JYIG..HANGUL SYLLABLE JYIH
C9C0;H2           # Lo         HANGUL SYLLABLE JI
C9C1..C9DB;H3     # Lo    [27] HANGUL SYLLABLE JIG..HANGUL SYLLABLE JIH
C9DC;H2           # Lo         HANGUL SYLLABLE JJA
C9DD..C9F7;H3     # Lo    [27] HANGUL SYLLABLE JJAG..HANGUL SYLLABLE JJAH
C9F8;H2           # Lo         HANGUL SYLLABLE JJAE
C9F9..CA13;H3     # Lo    [27] HANGUL SYLLABLE JJAEG..HANGUL SYLLABLE JJAEH
CA14;H2           # Lo         HANGUL SYLLABLE JJYA
CA15..CA2F;H3     # Lo    [27] HANGUL SYLLABLE JJYAG..HANGUL SYLLABLE JJYAH
CA30;H2           # Lo         HANGUL SYLLABLE JJYAE
CA31..CA4B;H3     # Lo    [27] HANGUL SYLLABLE JJYAEG..HANGUL SYLLABLE JJYAEH
CA4C;H2           # Lo         HANGUL SYLLABLE JJEO
CA4D..CA67;H3     # Lo    [27] HANGUL SYLLABLE JJEOG..HANGUL SYLLABLE JJEOH
CA68;H2           # Lo         HANGUL SYLLABLE JJE
CA69..CA83;H3     # Lo    [27] HANGUL SYLLABLE JJEG..HANGUL SYLLABLE JJEH
CA84;H2           # Lo         HANGUL SYLLABLE JJYEO
CA85..CA9F;H3     # Lo    [27] HANGUL SYLLABLE JJYEOG..HANGUL SYLLABLE JJYEOH
CAA0;H2           # Lo         HANGUL SYLLABLE JJYE
CAA1..CABB;H3     # Lo    [27] HANGUL SYLLABLE JJYEG..HANGUL SYLLABLE JJYEH
CABC;H2           # Lo         HANGUL SYLLABLE JJO
CABD..CAD7;H3     # Lo    [27] HANGUL SYLLABLE JJOG..HANGUL SYLLABLE JJOH
CAD8;H2           # Lo         HANGUL SYLLABLE JJWA
CAD9..CAF3;H3     # Lo    [27] HANGUL SYLLABLE JJWAG..HANGUL SYLLABLE JJWAH
CAF4;H2           # Lo         HANGUL SYLLABLE JJWAE
CAF5..CB0F;H3     # Lo    [27] HANGUL SYLLABLE JJWAEG..HANGUL SYLLABLE JJWAEH
CB10;H2           # Lo         HANGUL SYLLABLE JJOE
CB11..CB2B;H3     # Lo    [27] HANGUL SYLLABLE JJOEG..HANGUL SYLLABLE JJOEH
CB2C;H2           # Lo         HANGUL SYLLABLE JJYO
CB2D..CB47;H3     # Lo    [27] HANGUL SYLLABLE JJYOG..HANGUL SYLLABLE JJYOH
CB48;H2           # Lo         HANGUL SYLLABLE JJU
CB49..CB63;H3     # Lo    [27] HANGUL SYLLABLE JJUG..HANGUL SYLLABLE JJUH
CB64;H2           # Lo         HANGUL SYLLABLE JJWEO
CB65..CB7F;H3     # Lo    [27] HANGUL SYLLABLE JJWEOG..HANGUL SYLLABLE JJWEOH
CB80;H2           # Lo         HANGUL SYLLABLE JJWE
CB81..CB9B;H3     # Lo    [27] HANGUL SYLLABLE JJWEG..HANGUL SYLLABLE JJWEH
CB9C;H2           # Lo         HANGUL SYLLABLE JJWI
CB9D..CBB7;H3     # Lo    [27] HANGUL SYLLABLE JJWIG..HANGUL SYLLABLE JJWIH
CBB8;H2           # Lo         HANGUL SYLLABLE JJYU
CBB9..CBD3;H3     # Lo    [27] HANGUL SYLLABLE JJYUG..HANGUL SYLLABLE JJYUH
CBD4;H2           # Lo         HANGUL SYLLABLE JJEU
CBD5..CBEF;H3     # Lo    [27] HANGUL SYLLABLE JJEUG..HANGUL SYLLABLE JJEUH
CBF0;H2           # Lo         HANGUL SYLLABLE JJYI
CBF1..CC0B;H3     # Lo    [27] HANGUL SYLLABLE JJYIG..HANGUL SYLLABLE JJYIH
CC0C;H2           # Lo         HANGUL SYLLABLE JJI
CC0D..CC27;H3     # Lo    [27] HANGUL SYLLABLE JJIG..HANGUL SYLLABLE JJIH
CC28;H2           # Lo         HANGUL SYLLABLE CA
CC29..CC43;H3     # Lo    [27] HANGUL SYLLABLE CAG..HANGUL SYLLABLE CAH
CC44;H2           # Lo         HANGUL SYLLABLE CAE
CC45..CC5F;H3     # Lo    [27] HANGUL SYLLABLE CAEG..HANGUL SYLLABLE CAEH
CC60;H2           # Lo         HANGUL SYLLABLE CYA
CC61..CC7B;H3     # Lo    [27] HANGUL SYLLABLE CYAG..HANGUL SYLLABLE CYAH
CC7C;H2           # Lo         HANGUL SYLLABLE CYAE
CC7D..CC97;H3     # Lo    [27] HANGUL SYLLABLE CYAEG..HANGUL SYLLABLE CYAEH
CC98;H2           # Lo         HANGUL SYLLABLE CEO
CC99..CCB3;H3     # Lo    [27] HANGUL SYLLABLE CEOG..HANGUL SYLLABLE CEOH
CCB4;H2           # Lo         HANGUL SYLLABLE CE
CCB5..CCCF;H3     # Lo    [27] HANGUL SYLLABLE CEG..HANGUL SYLLABLE CEH
CCD0;H2           # Lo         HANGUL SYLLABLE CYEO
CCD1..CCEB;H3     # Lo    [27] HANGUL SYLLABLE CYEOG..HANGUL SYLLABLE CYEOH
CCEC;H2           # Lo         HANGUL SYLLABLE CYE
CCED..CD07;H3     # Lo    [27] HANGUL SYLLABLE CYEG..HANGUL SYLLABLE CYEH
CD08;H2           # Lo         HANGUL SYLLABLE CO
CD09..CD23;H3     # Lo    [27] HANGUL SYLLABLE COG..HANGUL SYLLABLE COH
CD24;H2           # Lo         HANGUL SYLLABLE CWA
CD25..CD3F;H3     # Lo    [27] HANGUL SYLLABLE CWAG..HANGUL SYLLABLE CWAH
CD40;H2           # Lo         HANGUL SYLLABLE CWAE
CD41..CD5B;H3     # Lo    [27] HANGUL SYLLABLE CWAEG..HANGUL SYLLABLE CWAEH
CD5C;H2           # Lo         HANGUL SYLLABLE COE
CD5D..CD77;H3     # Lo    [27] HANGUL SYLLABLE COEG..HANGUL SYLLABLE COEH
CD78;H2           # Lo         HANGUL SYLLABLE CYO
CD79..CD93;H3     # Lo    [27] HANGUL SYLLABLE CYOG..HANGUL SYLLABLE CYOH
CD94;H2           # Lo         HANGUL SYLLABLE CU
CD95..CDAF;H3     # Lo    [27] HANGUL SYLLABLE CUG..HANGUL SYLLABLE CUH
CDB0;H2           # Lo         HANGUL SYLLABLE CWEO
CDB1..CDCB;H3     # Lo    [27] HANGUL SYLLABLE CWEOG..HANGUL SYLLABLE CWEOH
CDCC;H2           # Lo         HANGUL SYLLABLE CWE
CDCD..CDE7;H3     # Lo    [27] HANGUL SYLLABLE CWEG..HANGUL SYLLABLE CWEH
CDE8;H2           # Lo         HANGUL SYLLABLE CWI
CDE9..CE03;H3     # Lo    [27] HANGUL SYLLABLE CWIG..HANGUL SYLLABLE CWIH
CE04;H2           # Lo         HANGUL SYLLABLE CYU
CE05..CE1F;H3     # Lo    [27] HANGUL SYLLABLE CYUG..HANGUL SYLLABLE CYUH
CE20;H2           # Lo         HANGUL SYLLABLE CEU
CE21..CE3B;H3     # Lo    [27] HANGUL SYLLABLE CEUG..HANGUL SYLLABLE CEUH
CE3C;H2           # Lo         HANGUL SYLLABLE CYI
CE3D..CE57;H3     # Lo    [27] HANGUL SYLLABLE CYIG..HANGUL SYLLABLE CYIH
CE58;H2           # Lo         HANGUL SYLLABLE CI
CE59..CE73;H3     # Lo    [27] HANGUL SYLLABLE CIG..HANGUL SYLLABLE CIH
CE74;H2           # Lo         HANGUL SYLLABLE KA
CE75..CE8F;H3     # Lo    [27] HANGUL SYLLABLE KAG..HANGUL SYLLABLE KAH
CE90;H2           # Lo         HANGUL SYLLABLE KAE
CE91..CEAB;H3     # Lo    [27] HANGUL SYLLABLE KAEG..HANGUL SYLLABLE KAEH
CEAC;H2           # Lo         HANGUL SYLLABLE KYA
CEAD..CEC7;H3     # Lo    [27] HANGUL SYLLABLE KYAG..HANGUL SYLLABLE KYAH
CEC8;H2           # Lo         HANGUL SYLLABLE KYAE
CEC9..CEE3;H3     # Lo    [27] HANGUL SYLLABLE KYAEG..HANGUL SYLLABLE KYAEH
CEE4;H2           # Lo         HANGUL SYLLABLE KEO
CEE5..CEFF;H3     # Lo    [27] HANGUL SYLLABLE KEOG..HANGUL SYLLABLE KEOH
CF00;H2           # Lo         HANGUL SYLLABLE KE
CF01..CF1B;H3     # Lo    [27] HANGUL SYLLABLE KEG..HANGUL SYLLABLE KEH
CF1C;H2           # Lo         HANGUL SYLLABLE KYEO
CF1D..CF37;H3     # Lo    [27] HANGUL SYLLABLE KYEOG..HANGUL SYLLABLE KYEOH
CF38;H2           # Lo         HANGUL SYLLABLE KYE
CF39..CF53;H3     # Lo    [27] HANGUL SYLLABLE KYEG..HANGUL SYLLABLE KYEH
CF54;H2           # Lo         HANGUL SYLLABLE KO
CF55..CF6F;H3     # Lo    [27] HANGUL SYLLABLE KOG..HANGUL SYLLABLE KOH
CF70;H2           # Lo         HANGUL SYLLABLE KWA
CF71..CF8B;H3     # Lo    [27] HANGUL SYLLABLE KWAG..HANGUL SYLLABLE KWAH
CF8C;H2           # Lo         HANGUL SYLLABLE KWAE
CF8D..CFA7;H3     # Lo    [27] HANGUL SYLLABLE KWAEG..HANGUL SYLLABLE KWAEH
CFA8;H2           # Lo         HANGUL SYLLABLE KOE
CFA9..CFC3;H3     # Lo    [27] HANGUL SYLLABLE KOEG..HANGUL SYLLABLE KOEH
CFC4;H2           # Lo         HANGUL SYLLABLE KYO
CFC5..CFDF;H3     # Lo    [27] HANGUL SYLLABLE KYOG..HANGUL SYLLABLE KYOH
CFE0;H2           # Lo         HANGUL SYLLABLE KU
CFE1..CFFB;H3     # Lo    [27] HANGUL SYLLABLE KUG..HANGUL SYLLABLE KUH
CFFC;H2           # Lo         HANGUL SYLLABLE KWEO
CFFD..D017;H3     # Lo    [27] HANGUL SYLLABLE KWEOG..HANGUL SYLLABLE KWEOH
D018;H2           # Lo         HANGUL SYLLABLE KWE
D019..D033;H3     # Lo    [27] HANGUL SYLLABLE KWEG..HANGUL SYLLABLE KWEH
D034;H2           # Lo         HANGUL SYLLABLE KWI
D035..D04F;H3     # Lo    [27] HANGUL SYLLABLE KWIG..HANGUL SYLLABLE KWIH
D050;H2           # Lo         HANGUL SYLLABLE KYU
D051..D06B;H3     # Lo    [27] HANGUL SYLLABLE KYUG..HANGUL SYLLABLE KYUH
D06C;H2           # Lo         HANGUL SYLLABLE KEU
D06D..D087;H3     # Lo    [27] HANGUL SYLLABLE KEUG..HANGUL SYLLABLE KEUH
D088;H2           # Lo         HANGUL SYLLABLE KYI
D089..D0A3;H3     # Lo    [27] HANGUL SYLLABLE KYIG..HANGUL SYLLABLE KYIH
D0A4;H2           # Lo         HANGUL SYLLABLE KI
D0A5..D0BF;H3     # Lo    [27] HANGUL SYLLABLE KIG..HANGUL SYLLABLE KIH
D0C0;H2           # Lo         HANGUL SYLLABLE TA
D0C1..D0DB;H3     # Lo    [27] HANGUL SYLLABLE TAG..HANGUL SYLLABLE TAH
D0DC;H2           # Lo         HANGUL SYLLABLE TAE
D0DD..D0F7;H3     # Lo    [27] HANGUL SYLLABLE TAEG..HANGUL SYLLABLE TAEH
D0F8;H2           # Lo         HANGUL SYLLABLE TYA
D0F9..D113;H3     # Lo    [27] HANGUL SYLLABLE TYAG..HANGUL SYLLABLE TYAH
D114;H2           # Lo         HANGUL SYLLABLE TYAE
D115..D12F;H3     # Lo    [27] HANGUL SYLLABLE TYAEG..HANGUL SYLLABLE TYAEH
D130;H2           # Lo         HANGUL SYLLABLE TEO
D131..D14B;H3     # Lo    [27] HANGUL SYLLABLE TEOG..HANGUL SYLLABLE TEOH
D14C;H2           # Lo         HANGUL SYLLABLE TE
D14D..D167;H3     # Lo    [27] HANGUL SYLLABLE TEG..HANGUL SYLLABLE TEH
D168;H2           # Lo         HANGUL SYLLABLE TYEO
D169..D183;H3     # Lo    [27] HANGUL SYLLABLE TYEOG..HANGUL SYLLABLE TYEOH
D184;H2           # Lo         HANGUL SYLLABLE TYE
D185..D19F;H3     # Lo    [27] HANGUL SYLLABLE TYEG..HANGUL SYLLABLE TYEH
D1A0;H2           # Lo         HANGUL SYLLABLE TO
D1A1..D1BB;H3     # Lo    [27] HANGUL SYLLABLE TOG..HANGUL SYLLABLE TOH
D1BC;H2           # Lo         HANGUL SYLLABLE TWA
D1BD..D1D7;H3     # Lo    [27] HANGUL SYLLABLE TWAG..HANGUL SYLLABLE TWAH
D1D8;H2           # Lo         HANGUL SYLLABLE TWAE
D1D9..D1F3;H3     # Lo    [27] HANGUL SYLLABLE TWAEG..HANGUL SYLLABLE TWAEH
D1F4;H2           # Lo         HANGUL SYLLABLE TOE
D1F5..D20F;H3     # Lo    [27] HANGUL SYLLABLE TOEG..HANGUL SYLLABLE TOEH
D210;H2           # Lo         HANGUL SYLLABLE TYO
D211..D22B;H3     # Lo    [27] HANGUL SYLLABLE TYOG..HANGUL SYLLABLE TYOH
D22C;H2           # Lo         HANGUL SYLLABLE TU
D22D..D247;H3     # Lo    [27] HANGUL SYLLABLE TUG..HANGUL SYLLABLE TUH
D248;H2           # Lo         HANGUL SYLLABLE TWEO
D249..D263;H3     # Lo    [27] HANGUL SYLLABLE TWEOG..HANGUL SYLLABLE TWEOH
D264;H2           # Lo         HANGUL SYLLABLE TWE
D265..D27F;H3     # Lo    [27] HANGUL SYLLABLE TWEG..HANGUL SYLLABLE TWEH
D280;H2           # Lo         HANGUL SYLLABLE TWI
D281..D29B;H3     # Lo    [27] HANGUL SYLLABLE TWIG..HANGUL SYLLABLE TWIH
D29C;H2           # Lo         HANGUL SYLLABLE TYU
D29D..D2B7;H3     # Lo    [27] HANGUL SYLLABLE TYUG..HANGUL SYLLABLE TYUH
D2B8;H2           # Lo         HANGUL SYLLABLE TEU
D2B9..D2D3;H3     # Lo    [27] HANGUL SYLLABLE TEUG..HANGUL SYLLABLE TEUH
D2D4;H2           # Lo         HANGUL SYLLABLE TYI
D2D5..D2EF;H3     # Lo    [27] HANGUL SYLLABLE TYIG..HANGUL SYLLABLE TYIH
D2F0;H2           # Lo         HANGUL SYLLABLE TI
D2F1..D30B;H3     # Lo    [27] HANGUL SYLLABLE TIG..HANGUL SYLLABLE TIH
D30C;H2           # Lo         HANGUL SYLLABLE PA
D30D..D327;H3     # Lo    [27] HANGUL SYLLABLE PAG..HANGUL SYLLABLE PAH
D328;H2           # Lo         HANGUL SYLLABLE PAE
D329..D343;H3     # Lo    [27] HANGUL SYLLABLE PAEG..HANGUL SYLLABLE PAEH
D344;H2           # Lo         HANGUL SYLLABLE PYA
D345..D35F;H3     # Lo    [27] HANGUL SYLLABLE PYAG..HANGUL SYLLABLE PYAH
D360;H2           # Lo         HANGUL SYLLABLE PYAE
D361..D37B;H3     # Lo    [27] HANGUL SYLLABLE PYAEG..HANGUL SYLLABLE PYAEH
D37C;H2           # Lo         HANGUL SYLLABLE PEO
D37D..D397;H3     # Lo    [27] HANGUL SYLLABLE PEOG..HANGUL SYLLABLE PEOH
D398;H2           # Lo         HANGUL SYLLABLE PE
D399..D3B3;H3     # Lo    [27] HANGUL SYLLABLE PEG..HANGUL SYLLABLE PEH
D3B4;H2           # Lo         HANGUL SYLLABLE PYEO
D3B5..D3CF;H3     # Lo    [27] HANGUL SYLLABLE PYEOG..HANGUL SYLLABLE PYEOH
D3D0;H2           # Lo         HANGUL SYLLABLE PYE
D3D1..D3EB;H3     # Lo    [27] HANGUL SYLLABLE PYEG..HANGUL SYLLABLE PYEH
D3EC;H2           # Lo         HANGUL SYLLABLE PO
D3ED..D407;H3     # Lo    [27] HANGUL SYLLABLE POG..HANGUL SYLLABLE POH
D408;H2           # Lo         HANGUL SYLLABLE PWA
D409..D423;H3     # Lo    [27] HANGUL SYLLABLE PWAG..HANGUL SYLLABLE PWAH
D424;H2           # Lo         HANGUL SYLLABLE PWAE
D425..D43F;H3     # Lo    [27] HANGUL SYLLABLE PWAEG..HANGUL SYLLABLE PWAEH
D440;H2           # Lo         HANGUL SYLLABLE POE
D441..D45B;H3     # Lo    [27] HANGUL SYLLABLE POEG..HANGUL SYLLABLE POEH
D45C;H2           # Lo         HANGUL SYLLABLE PYO
D45D..D477;H3     # Lo    [27] HANGUL SYLLABLE PYOG..HANGUL SYLLABLE PYOH
D478;H2           # Lo         HANGUL SYLLABLE PU
D479..D493;H3     # Lo    [27] HANGUL SYLLABLE PUG..HANGUL SYLLABLE PUH
D494;H2           # Lo         HANGUL SYLLABLE PWEO
D495..D4AF;H3     # Lo    [27] HANGUL SYLLABLE PWEOG..HANGUL SYLLABLE PWEOH
D4B0;H2           # Lo         HANGUL SYLLABLE PWE
D4B1..D4CB;H3     # Lo    [27] HANGUL SYLLABLE PWEG..HANGUL SYLLABLE PWEH
D4CC;H2           # Lo         HANGUL SYLLABLE PWI
D4CD..D4E7;H3     # Lo    [27] HANGUL SYLLABLE PWIG..HANGUL SYLLABLE PWIH
D4E8;H2           # Lo         HANGUL SYLLABLE PYU
D4E9..D503;H3     # Lo    [27] HANGUL SYLLABLE PYUG..HANGUL SYLLABLE PYUH
D504;H2           # Lo         HANGUL SYLLABLE PEU
D505..D51F;H3     # Lo    [27] HANGUL SYLLABLE PEUG..HANGUL SYLLABLE PEUH
D520;H2           # Lo         HANGUL SYLLABLE PYI
D521..D53B;H3     # Lo    [27] HANGUL SYLLABLE PYIG..HANGUL SYLLABLE PYIH
D53C;H2           # Lo         HANGUL SYLLABLE PI
D53D..D557;H3     # Lo    [27] HANGUL SYLLABLE PIG..HANGUL SYLLABLE PIH
D558;H2           # Lo         HANGUL SYLLABLE HA
D559..D573;H3     # Lo    [27] HANGUL SYLLABLE HAG..HANGUL SYLLABLE HAH
D574;H2           # Lo         HANGUL SYLLABLE HAE
D575..D58F;H3     # Lo    [27] HANGUL SYLLABLE HAEG..HANGUL SYLLABLE HAEH
D590;H2           # Lo         HANGUL SYLLABLE HYA
D591..D5AB;H3     # Lo    [27] HANGUL SYLLABLE HYAG..HANGUL SYLLABLE HYAH
D5AC;H2           # Lo         HANGUL SYLLABLE HYAE
D5AD..D5C7;H3     # Lo    [27] HANGUL SYLLABLE HYAEG..HANGUL SYLLABLE HYAEH
D5C8;H2           # Lo         HANGUL SYLLABLE HEO
D5C9..D5E3;H3     # Lo    [27] HANGUL SYLLABLE HEOG..HANGUL SYLLABLE HEOH
D5E4;H2           # Lo         HANGUL SYLLABLE HE
D5E5..D5FF;H3     # Lo    [27] HANGUL SYLLABLE HEG..HANGUL SYLLABLE HEH
D600;H2           # Lo         HANGUL SYLLABLE HYEO
D601..D61B;H3     # Lo    [27] HANGUL SYLLABLE HYEOG..HANGUL SYLLABLE HYEOH
D61C;H2           # Lo         HANGUL SYLLABLE HYE
D61D..D637;H3     # Lo    [27] HANGUL SYLLABLE HYEG..HANGUL SYLLABLE HYEH
D638;H2           # Lo         HANGUL SYLLABLE HO
D639..D653;H3     # Lo    [27] HANGUL SYLLABLE HOG..HANGUL SYLLABLE HOH
D654;H2           # Lo         HANGUL SYLLABLE HWA
D655..D66F;H3     # Lo    [27] HANGUL SYLLABLE HWAG..HANGUL SYLLABLE HWAH
D670;H2           # Lo         HANGUL SYLLABLE HWAE
D671..D68B;H3     # Lo    [27] HANGUL SYLLABLE HWAEG..HANGUL SYLLABLE HWAEH
D68C;H2           # Lo         HANGUL SYLLABLE HOE
D68D..D6A7;H3     # Lo    [27] HANGUL SYLLABLE HOEG..HANGUL SYLLABLE HOEH
D6A8;H2           # Lo         HANGUL SYLLABLE HYO
D6A9..D6C3;H3     # Lo    [27] HANGUL SYLLABLE HYOG..HANGUL SYLLABLE HYOH
D6C4;H2           # Lo         HANGUL SYLLABLE HU
D6C5..D6DF;H3     # Lo    [27] HANGUL SYLLABLE HUG..HANGUL SYLLABLE HUH
D6E0;H2           # Lo         HANGUL SYLLABLE HWEO
D6E1..D6FB;H3     # Lo    [27] HANGUL SYLLABLE HWEOG..HANGUL SYLLABLE HWEOH
D6FC;H2           # Lo         HANGUL SYLLABLE HWE
D6FD..D717;H3     # Lo    [27] HANGUL SYLLABLE HWEG..HANGUL SYLLABLE HWEH
D718;H2           # Lo         HANGUL SYLLABLE HWI
D719..D733;H3     # Lo    [27] HANGUL SYLLABLE HWIG..HANGUL SYLLABLE HWIH
D734;H2           # Lo         HANGUL SYLLABLE HYU
D735..D74F;H3     # Lo    [27] HANGUL SYLLABLE HYUG..HANGUL SYLLABLE HYUH
D750;H2           # Lo         HANGUL SYLLABLE HEU
D751..D76B;H3     # Lo    [27] HANGUL SYLLABLE HEUG..HANGUL SYLLABLE HEUH
D76C;H2           # Lo         HANGUL SYLLABLE HYI
D76D..D787;H3     # Lo    [27] HANGUL SYLLABLE HYIG..HANGUL SYLLABLE HYIH
D788;H2           # Lo         HANGUL SYLLABLE HI
D789..D7A3;H3     # Lo    [27] HANGUL SYLLABLE HIG..HANGUL SYLLABLE HIH
D7B0..D7C6;JV     # Lo    [23] HANGUL JUNGSEONG O-YEO..HANGUL JUNGSEONG ARAEA-E
D7CB..D7FB;JT     # Lo    [49] HANGUL JONGSEONG NIEUN-RIEUL..HANGUL JONGSEONG PHIEUPH-THIEUTH
D800..DB7F;SG     # Cs   [896] <surrogate-D800>..<surrogate-DB7F>
DB80..DBFF;SG     # Cs   [128] <surrogate-DB80>..<surrogate-DBFF>
DC00..DFFF;SG     # Cs  [1024] <surrogate-DC00>..<surrogate-DFFF>
E000..F8FF;XX     # Co  [6400] <private-use-E000>..<private-use-F8FF>
F900..FA6D;ID     # Lo   [366] CJK COMPATIBILITY IDEOGRAPH-F900..CJK COMPATIBILITY IDEOGRAPH-FA6D
FA6E..FA6F;ID     # Cn     [2] <reserved-FA6E>..<reserved-FA6F>
FA70..FAD9;ID     # Lo   [106] CJK COMPATIBILITY IDEOGRAPH-FA70..CJK COMPATIBILITY IDEOGRAPH-FAD9
FADA..FAFF;ID     # Cn    [38] <reserved-FADA>..<reserved-FAFF>
FB00..FB06;AL     # Ll     [7] LATIN SMALL LIGATURE FF..LATIN SMALL LIGATURE ST
FB13..FB17;AL     # Ll     [5] ARMENIAN SMALL LIGATURE MEN NOW..ARMENIAN SMALL LIGATURE MEN XEH
FB1D;HL           # Lo         HEBREW LETTER YOD WITH HIRIQ
FB1E;CM           # Mn         HEBREW POINT JUDEO-SPANISH VARIKA
FB1F..FB28;HL     # Lo    [10] HEBREW LIGATURE YIDDISH YOD YOD PATAH..HEBREW LETTER WIDE TAV
FB29;AL           # Sm         HEBREW LETTER ALTERNATIVE PLUS SIGN
FB2A..FB36;HL     # Lo    [13] HEBREW LETTER SHIN WITH SHIN DOT..HEBREW LETTER ZAYIN WITH DAGESH
FB38..FB3C;HL     # Lo     [5] HEBREW LETTER TET WITH DAGESH..HEBREW LETTER LAMED WITH DAGESH
FB3E;HL           # Lo         HEBREW LETTER MEM WITH DAGESH
FB40..FB41;HL     # Lo     [2] HEBREW LETTER NUN WITH DAGESH..HEBREW LETTER SAMEKH WITH DAGESH
FB43..FB44;HL     # Lo     [2] HEBREW LETTER FINAL PE WITH DAGESH..HEBREW LETTER PE WITH DAGESH
FB46..FB4F;HL     # Lo    [10] HEBREW LETTER TSADI WITH DAGESH..HEBREW LIGATURE ALEF LAMED
FB50..FBB1;AL     # Lo    [98] ARABIC LETTER ALEF WASLA ISOLATED FORM..ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM
FBB2..FBC1;AL     # Sk    [16] ARABIC SYMBOL DOT ABOVE..ARABIC SYMBOL SMALL TAH BELOW
FBD3..FD3D;AL     # Lo   [363] ARABIC LETTER NG ISOLATED FORM..ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM
FD3E;CL           # Pe         ORNATE LEFT PARENTHESIS
FD3F;OP           # Ps         ORNATE RIGHT PARENTHESIS
FD50..FD8F;AL     # Lo    [64] ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM..ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM
FD92..FDC7;AL     # Lo    [54] ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM..ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM
FDF0..FDFB;AL     # Lo    [12] ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM..ARABIC LIGATURE JALLAJALALOUHOU
FDFC;PO           # Sc         RIAL SIGN
FDFD;AL           # So         ARABIC LIGATURE BISMILLAH AR-RAHMAN AR-RAHEEM
FE00..FE0F;CM     # Mn    [16] VARIATION SELECTOR-1..VARIATION SELECTOR-16
FE10;IS           # Po         PRESENTATION FORM FOR VERTICAL COMMA
FE11..FE12;CL     # Po     [2] PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC COMMA..PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC FULL STOP
FE13..FE14;IS     # Po     [2] PRESENTATION FORM FOR VERTICAL COLON..PRESENTATION FORM FOR VERTICAL SEMICOLON
FE15..FE16;EX     # Po     [2] PRESENTATION FORM FOR VERTICAL EXCLAMATION MARK..PRESENTATION FORM FOR VERTICAL QUESTION MARK
FE17;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT WHITE LENTICULAR BRACKET
FE18;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT WHITE LENTICULAR BRAKCET
FE19;IN           # Po         PRESENTATION FORM FOR VERTICAL HORIZONTAL ELLIPSIS
FE20..FE2D;CM     # Mn    [14] COMBINING LIGATURE LEFT HALF..COMBINING CONJOINING MACRON BELOW
FE30;ID           # Po         PRESENTATION FORM FOR VERTICAL TWO DOT LEADER
FE31..FE32;ID     # Pd     [2] PRESENTATION FORM FOR VERTICAL EM DASH..PRESENTATION FORM FOR VERTICAL EN DASH
FE33..FE34;ID     # Pc     [2] PRESENTATION FORM FOR VERTICAL LOW LINE..PRESENTATION FORM FOR VERTICAL WAVY LOW LINE
FE35;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT PARENTHESIS
FE36;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT PARENTHESIS
FE37;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT CURLY BRACKET
FE38;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT CURLY BRACKET
FE39;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT TORTOISE SHELL BRACKET
FE3A;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT TORTOISE SHELL BRACKET
FE3B;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT BLACK LENTICULAR BRACKET
FE3C;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET
FE3D;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET
FE3E;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT DOUBLE ANGLE BRACKET
FE3F;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT ANGLE BRACKET
FE40;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT ANGLE BRACKET
FE41;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT CORNER BRACKET
FE42;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT CORNER BRACKET
FE43;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET
FE44;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT WHITE CORNER BRACKET
FE45..FE46;ID     # Po     [2] SESAME DOT..WHITE SESAME DOT
FE47;OP           # Ps         PRESENTATION FORM FOR VERTICAL LEFT SQUARE BRACKET
FE48;CL           # Pe         PRESENTATION FORM FOR VERTICAL RIGHT SQUARE BRACKET
FE49..FE4C;ID     # Po     [4] DASHED OVERLINE..DOUBLE WAVY OVERLINE
FE4D..FE4F;ID     # Pc     [3] DASHED LOW LINE..WAVY LOW LINE
FE50;CL           # Po         SMALL COMMA
FE51;ID           # Po         SMALL IDEOGRAPHIC COMMA
FE52;CL           # Po         SMALL FULL STOP
FE54..FE55;NS     # Po     [2] SMALL SEMICOLON..SMALL COLON
FE56..FE57;EX     # Po     [2] SMALL QUESTION MARK..SMALL EXCLAMATION MARK
FE58;ID           # Pd         SMALL EM DASH
FE59;OP           # Ps         SMALL LEFT PARENTHESIS
FE5A;CL           # Pe         SMALL RIGHT PARENTHESIS
FE5B;OP           # Ps         SMALL LEFT CURLY BRACKET
FE5C;CL           # Pe         SMALL RIGHT CURLY BRACKET
FE5D;OP           # Ps         SMALL LEFT TORTOISE SHELL BRACKET
FE5E;CL           # Pe         SMALL RIGHT TORTOISE SHELL BRACKET
FE5F..FE61;ID     # Po     [3] SMALL NUMBER SIGN..SMALL ASTERISK
FE62;ID           # Sm         SMALL PLUS SIGN
FE63;ID           # Pd         SMALL HYPHEN-MINUS
FE64..FE66;ID     # Sm     [3] SMALL LESS-THAN SIGN..SMALL EQUALS SIGN
FE68;ID           # Po         SMALL REVERSE SOLIDUS
FE69;PR           # Sc         SMALL DOLLAR SIGN
FE6A;PO           # Po         SMALL PERCENT SIGN
FE6B;ID           # Po         SMALL COMMERCIAL AT
FE70..FE74;AL     # Lo     [5] ARABIC FATHATAN ISOLATED FORM..ARABIC KASRATAN ISOLATED FORM
FE76..FEFC;AL     # Lo   [135] ARABIC FATHA ISOLATED FORM..ARABIC LIGATURE LAM WITH ALEF FINAL FORM
FEFF;WJ           # Cf         ZERO WIDTH NO-BREAK SPACE
FF01;EX           # Po         FULLWIDTH EXCLAMATION MARK
FF02..FF03;ID     # Po     [2] FULLWIDTH QUOTATION MARK..FULLWIDTH NUMBER SIGN
FF04;PR           # Sc         FULLWIDTH DOLLAR SIGN
FF05;PO           # Po         FULLWIDTH PERCENT SIGN
FF06..FF07;ID     # Po     [2] FULLWIDTH AMPERSAND..FULLWIDTH APOSTROPHE
FF08;OP           # Ps         FULLWIDTH LEFT PARENTHESIS
FF09;CL           # Pe         FULLWIDTH RIGHT PARENTHESIS
FF0A;ID           # Po         FULLWIDTH ASTERISK
FF0B;ID           # Sm         FULLWIDTH PLUS SIGN
FF0C;CL           # Po         FULLWIDTH COMMA
FF0D;ID           # Pd         FULLWIDTH HYPHEN-MINUS
FF0E;CL           # Po         FULLWIDTH FULL STOP
FF0F;ID           # Po         FULLWIDTH SOLIDUS
FF10..FF19;ID     # Nd    [10] FULLWIDTH DIGIT ZERO..FULLWIDTH DIGIT NINE
FF1A..FF1B;NS     # Po     [2] FULLWIDTH COLON..FULLWIDTH SEMICOLON
FF1C..FF1E;ID     # Sm     [3] FULLWIDTH LESS-THAN SIGN..FULLWIDTH GREATER-THAN SIGN
FF1F;EX           # Po         FULLWIDTH QUESTION MARK
FF20;ID           # Po         FULLWIDTH COMMERCIAL AT
FF21..FF3A;ID     # Lu    [26] FULLWIDTH LATIN CAPITAL LETTER A..FULLWIDTH LATIN CAPITAL LETTER Z
FF3B;OP           # Ps         FULLWIDTH LEFT SQUARE BRACKET
FF3C;ID           # Po         FULLWIDTH REVERSE SOLIDUS
FF3D;CL           # Pe         FULLWIDTH RIGHT SQUARE BRACKET
FF3E;ID           # Sk         FULLWIDTH CIRCUMFLEX ACCENT
FF3F;ID           # Pc         FULLWIDTH LOW LINE
FF40;ID           # Sk         FULLWIDTH GRAVE ACCENT
FF41..FF5A;ID     # Ll    [26] FULLWIDTH LATIN SMALL LETTER A..FULLWIDTH LATIN SMALL LETTER Z
FF5B;OP           # Ps         FULLWIDTH LEFT CURLY BRACKET
FF5C;ID           # Sm         FULLWIDTH VERTICAL LINE
FF5D;CL           # Pe         FULLWIDTH RIGHT CURLY BRACKET
FF5E;ID           # Sm         FULLWIDTH TILDE
FF5F;OP           # Ps         FULLWIDTH LEFT WHITE PARENTHESIS
FF60;CL           # Pe         FULLWIDTH RIGHT WHITE PARENTHESIS
FF61;CL           # Po         HALFWIDTH IDEOGRAPHIC FULL STOP
FF62;OP           # Ps         HALFWIDTH LEFT CORNER BRACKET
FF63;CL           # Pe         HALFWIDTH RIGHT CORNER BRACKET
FF64;CL           # Po         HALFWIDTH IDEOGRAPHIC COMMA
FF65;NS           # Po         HALFWIDTH KATAKANA MIDDLE DOT
FF66;AL           # Lo         HALFWIDTH KATAKANA LETTER WO
FF67..FF6F;CJ     # Lo     [9] HALFWIDTH KATAKANA LETTER SMALL A..HALFWIDTH KATAKANA LETTER SMALL TU
FF70;CJ           # Lm         HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK
FF71..FF9D;AL     # Lo    [45] HALFWIDTH KATAKANA LETTER A..HALFWIDTH KATAKANA LETTER N
FF9E..FF9F;NS     # Lm     [2] HALFWIDTH KATAKANA VOICED SOUND MARK..HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK
FFA0..FFBE;AL     # Lo    [31] HALFWIDTH HANGUL FILLER..HALFWIDTH HANGUL LETTER HIEUH
FFC2..FFC7;AL     # Lo     [6] HALFWIDTH HANGUL LETTER A..HALFWIDTH HANGUL LETTER E
FFCA..FFCF;AL     # Lo     [6] HALFWIDTH HANGUL LETTER YEO..HALFWIDTH HANGUL LETTER OE
FFD2..FFD7;AL     # Lo     [6] HALFWIDTH HANGUL LETTER YO..HALFWIDTH HANGUL LETTER YU
FFDA..FFDC;AL     # Lo     [3] HALFWIDTH HANGUL LETTER EU..HALFWIDTH HANGUL LETTER I
FFE0;PO           # Sc         FULLWIDTH CENT SIGN
FFE1;PR           # Sc         FULLWIDTH POUND SIGN
FFE2;ID           # Sm         FULLWIDTH NOT SIGN
FFE3;ID           # Sk         FULLWIDTH MACRON
FFE4;ID           # So         FULLWIDTH BROKEN BAR
FFE5..FFE6;PR     # Sc     [2] FULLWIDTH YEN SIGN..FULLWIDTH WON SIGN
FFE8;AL           # So         HALFWIDTH FORMS LIGHT VERTICAL
FFE9..FFEC;AL     # Sm     [4] HALFWIDTH LEFTWARDS ARROW..HALFWIDTH DOWNWARDS ARROW
FFED..FFEE;AL     # So     [2] HALFWIDTH BLACK SQUARE..HALFWIDTH WHITE CIRCLE
FFF9..FFFB;CM     # Cf     [3] INTERLINEAR ANNOTATION ANCHOR..INTERLINEAR ANNOTATION TERMINATOR
FFFC;CB           # So         OBJECT REPLACEMENT CHARACTER
FFFD;AI           # So         REPLACEMENT CHARACTER
10000..1000B;AL   # Lo    [12] LINEAR B SYLLABLE B008 A..LINEAR B SYLLABLE B046 JE
1000D..10026;AL   # Lo    [26] LINEAR B SYLLABLE B036 JO..LINEAR B SYLLABLE B032 QO
10028..1003A;AL   # Lo    [19] LINEAR B SYLLABLE B060 RA..LINEAR B SYLLABLE B042 WO
1003C..1003D;AL   # Lo     [2] LINEAR B SYLLABLE B017 ZA..LINEAR B SYLLABLE B074 ZE
1003F..1004D;AL   # Lo    [15] LINEAR B SYLLABLE B020 ZO..LINEAR B SYLLABLE B091 TWO
10050..1005D;AL   # Lo    [14] LINEAR B SYMBOL B018..LINEAR B SYMBOL B089
10080..100FA;AL   # Lo   [123] LINEAR B IDEOGRAM B100 MAN..LINEAR B IDEOGRAM VESSEL B305
10100..10102;BA   # Po     [3] AEGEAN WORD SEPARATOR LINE..AEGEAN CHECK MARK
10107..10133;AL   # No    [45] AEGEAN NUMBER ONE..AEGEAN NUMBER NINETY THOUSAND
10137..1013F;AL   # So     [9] AEGEAN WEIGHT BASE UNIT..AEGEAN MEASURE THIRD SUBUNIT
10140..10174;AL   # Nl    [53] GREEK ACROPHONIC ATTIC ONE QUARTER..GREEK ACROPHONIC STRATIAN FIFTY MNAS
10175..10178;AL   # No     [4] GREEK ONE HALF SIGN..GREEK THREE QUARTERS SIGN
10179..10189;AL   # So    [17] GREEK YEAR SIGN..GREEK TRYBLION BASE SIGN
1018A..1018B;AL   # No     [2] GREEK ZERO SIGN..GREEK ONE QUARTER SIGN
1018C;AL          # So         GREEK SINUSOID SIGN
10190..1019B;AL   # So    [12] ROMAN SEXTANS SIGN..ROMAN CENTURIAL SIGN
101A0;AL          # So         GREEK SYMBOL TAU RHO
101D0..101FC;AL   # So    [45] PHAISTOS DISC SIGN PEDESTRIAN..PHAISTOS DISC SIGN WAVY BAND
101FD;CM          # Mn         PHAISTOS DISC SIGN COMBINING OBLIQUE STROKE
10280..1029C;AL   # Lo    [29] LYCIAN LETTER A..LYCIAN LETTER X
102A0..102D0;AL   # Lo    [49] CARIAN LETTER A..CARIAN LETTER UUU3
102E0;CM          # Mn         COPTIC EPACT THOUSANDS MARK
102E1..102FB;AL   # No    [27] COPTIC EPACT DIGIT ONE..COPTIC EPACT NUMBER NINE HUNDRED
10300..1031F;AL   # Lo    [32] OLD ITALIC LETTER A..OLD ITALIC LETTER ESS
10320..10323;AL   # No     [4] OLD ITALIC NUMERAL ONE..OLD ITALIC NUMERAL FIFTY
10330..10340;AL   # Lo    [17] GOTHIC LETTER AHSA..GOTHIC LETTER PAIRTHRA
10341;AL          # Nl         GOTHIC LETTER NINETY
10342..10349;AL   # Lo     [8] GOTHIC LETTER RAIDA..GOTHIC LETTER OTHAL
1034A;AL          # Nl         GOTHIC LETTER NINE HUNDRED
10350..10375;AL   # Lo    [38] OLD PERMIC LETTER AN..OLD PERMIC LETTER IA
10376..1037A;CM   # Mn     [5] COMBINING OLD PERMIC LETTER AN..COMBINING OLD PERMIC LETTER SII
10380..1039D;AL   # Lo    [30] UGARITIC LETTER ALPA..UGARITIC LETTER SSU
1039F;BA          # Po         UGARITIC WORD DIVIDER
103A0..103C3;AL   # Lo    [36] OLD PERSIAN SIGN A..OLD PERSIAN SIGN HA
103C8..103CF;AL   # Lo     [8] OLD PERSIAN SIGN AURAMAZDAA..OLD PERSIAN SIGN BUUMISH
103D0;BA          # Po         OLD PERSIAN WORD DIVIDER
103D1..103D5;AL   # Nl     [5] OLD PERSIAN NUMBER ONE..OLD PERSIAN NUMBER HUNDRED
10400..1044F;AL   # L&    [80] DESERET CAPITAL LETTER LONG I..DESERET SMALL LETTER EW
10450..1047F;AL   # Lo    [48] SHAVIAN LETTER PEEP..SHAVIAN LETTER YEW
10480..1049D;AL   # Lo    [30] OSMANYA LETTER ALEF..OSMANYA LETTER OO
104A0..104A9;NU   # Nd    [10] OSMANYA DIGIT ZERO..OSMANYA DIGIT NINE
10500..10527;AL   # Lo    [40] ELBASAN LETTER A..ELBASAN LETTER KHE
10530..10563;AL   # Lo    [52] CAUCASIAN ALBANIAN LETTER ALT..CAUCASIAN ALBANIAN LETTER KIW
1056F;AL          # Po         CAUCASIAN ALBANIAN CITATION MARK
10600..10736;AL   # Lo   [311] LINEAR A SIGN AB001..LINEAR A SIGN A664
10740..10755;AL   # Lo    [22] LINEAR A SIGN A701 A..LINEAR A SIGN A732 JE
10760..10767;AL   # Lo     [8] LINEAR A SIGN A800..LINEAR A SIGN A807
10800..10805;AL   # Lo     [6] CYPRIOT SYLLABLE A..CYPRIOT SYLLABLE JA
10808;AL          # Lo         CYPRIOT SYLLABLE JO
1080A..10835;AL   # Lo    [44] CYPRIOT SYLLABLE KA..CYPRIOT SYLLABLE WO
10837..10838;AL   # Lo     [2] CYPRIOT SYLLABLE XA..CYPRIOT SYLLABLE XE
1083C;AL          # Lo         CYPRIOT SYLLABLE ZA
1083F;AL          # Lo         CYPRIOT SYLLABLE ZO
10840..10855;AL   # Lo    [22] IMPERIAL ARAMAIC LETTER ALEPH..IMPERIAL ARAMAIC LETTER TAW
10857;BA          # Po         IMPERIAL ARAMAIC SECTION SIGN
10858..1085F;AL   # No     [8] IMPERIAL ARAMAIC NUMBER ONE..IMPERIAL ARAMAIC NUMBER TEN THOUSAND
10860..10876;AL   # Lo    [23] PALMYRENE LETTER ALEPH..PALMYRENE LETTER TAW
10877..10878;AL   # So     [2] PALMYRENE LEFT-POINTING FLEURON..PALMYRENE RIGHT-POINTING FLEURON
10879..1087F;AL   # No     [7] PALMYRENE NUMBER ONE..PALMYRENE NUMBER TWENTY
10880..1089E;AL   # Lo    [31] NABATAEAN LETTER FINAL ALEPH..NABATAEAN LETTER TAW
108A7..108AF;AL   # No     [9] NABATAEAN NUMBER ONE..NABATAEAN NUMBER ONE HUNDRED
10900..10915;AL   # Lo    [22] PHOENICIAN LETTER ALF..PHOENICIAN LETTER TAU
10916..1091B;AL   # No     [6] PHOENICIAN NUMBER ONE..PHOENICIAN NUMBER THREE
1091F;BA          # Po         PHOENICIAN WORD SEPARATOR
10920..10939;AL   # Lo    [26] LYDIAN LETTER A..LYDIAN LETTER C
1093F;AL          # Po         LYDIAN TRIANGULAR MARK
10980..1099F;AL   # Lo    [32] MEROITIC HIEROGLYPHIC LETTER A..MEROITIC HIEROGLYPHIC SYMBOL VIDJ-2
109A0..109B7;AL   # Lo    [24] MEROITIC CURSIVE LETTER A..MEROITIC CURSIVE LETTER DA
109BE..109BF;AL   # Lo     [2] MEROITIC CURSIVE LOGOGRAM RMT..MEROITIC CURSIVE LOGOGRAM IMN
10A00;AL          # Lo         KHAROSHTHI LETTER A
10A01..10A03;CM   # Mn     [3] KHAROSHTHI VOWEL SIGN I..KHAROSHTHI VOWEL SIGN VOCALIC R
10A05..10A06;CM   # Mn     [2] KHAROSHTHI VOWEL SIGN E..KHAROSHTHI VOWEL SIGN O
10A0C..10A0F;CM   # Mn     [4] KHAROSHTHI VOWEL LENGTH MARK..KHAROSHTHI SIGN VISARGA
10A10..10A13;AL   # Lo     [4] KHAROSHTHI LETTER KA..KHAROSHTHI LETTER GHA
10A15..10A17;AL   # Lo     [3] KHAROSHTHI LETTER CA..KHAROSHTHI LETTER JA
10A19..10A33;AL   # Lo    [27] KHAROSHTHI LETTER NYA..KHAROSHTHI LETTER TTTHA
10A38..10A3A;CM   # Mn     [3] KHAROSHTHI SIGN BAR ABOVE..KHAROSHTHI SIGN DOT BELOW
10A3F;CM          # Mn         KHAROSHTHI VIRAMA
10A40..10A47;AL   # No     [8] KHAROSHTHI DIGIT ONE..KHAROSHTHI NUMBER ONE THOUSAND
10A50..10A57;BA   # Po     [8] KHAROSHTHI PUNCTUATION DOT..KHAROSHTHI PUNCTUATION DOUBLE DANDA
10A58;AL          # Po         KHAROSHTHI PUNCTUATION LINES
10A60..10A7C;AL   # Lo    [29] OLD SOUTH ARABIAN LETTER HE..OLD SOUTH ARABIAN LETTER THETH
10A7D..10A7E;AL   # No     [2] OLD SOUTH ARABIAN NUMBER ONE..OLD SOUTH ARABIAN NUMBER FIFTY
10A7F;AL          # Po         OLD SOUTH ARABIAN NUMERIC INDICATOR
10A80..10A9C;AL   # Lo    [29] OLD NORTH ARABIAN LETTER HEH..OLD NORTH ARABIAN LETTER ZAH
10A9D..10A9F;AL   # No     [3] OLD NORTH ARABIAN NUMBER ONE..OLD NORTH ARABIAN NUMBER TWENTY
10AC0..10AC7;AL   # Lo     [8] MANICHAEAN LETTER ALEPH..MANICHAEAN LETTER WAW
10AC8;AL          # So         MANICHAEAN SIGN UD
10AC9..10AE4;AL   # Lo    [28] MANICHAEAN LETTER ZAYIN..MANICHAEAN LETTER TAW
10AE5..10AE6;CM   # Mn     [2] MANICHAEAN ABBREVIATION MARK ABOVE..MANICHAEAN ABBREVIATION MARK BELOW
10AEB..10AEF;AL   # No     [5] MANICHAEAN NUMBER ONE..MANICHAEAN NUMBER ONE HUNDRED
10AF0..10AF5;BA   # Po     [6] MANICHAEAN PUNCTUATION STAR..MANICHAEAN PUNCTUATION TWO DOTS
10AF6;IN          # Po         MANICHAEAN PUNCTUATION LINE FILLER
10B00..10B35;AL   # Lo    [54] AVESTAN LETTER A..AVESTAN LETTER HE
10B39..10B3F;BA   # Po     [7] AVESTAN ABBREVIATION MARK..LARGE ONE RING OVER TWO RINGS PUNCTUATION
10B40..10B55;AL   # Lo    [22] INSCRIPTIONAL PARTHIAN LETTER ALEPH..INSCRIPTIONAL PARTHIAN LETTER TAW
10B58..10B5F;AL   # No     [8] INSCRIPTIONAL PARTHIAN NUMBER ONE..INSCRIPTIONAL PARTHIAN NUMBER ONE THOUSAND
10B60..10B72;AL   # Lo    [19] INSCRIPTIONAL PAHLAVI LETTER ALEPH..INSCRIPTIONAL PAHLAVI LETTER TAW
10B78..10B7F;AL   # No     [8] INSCRIPTIONAL PAHLAVI NUMBER ONE..INSCRIPTIONAL PAHLAVI NUMBER ONE THOUSAND
10B80..10B91;AL   # Lo    [18] PSALTER PAHLAVI LETTER ALEPH..PSALTER PAHLAVI LETTER TAW
10B99..10B9C;AL   # Po     [4] PSALTER PAHLAVI SECTION MARK..PSALTER PAHLAVI FOUR DOTS WITH DOT
10BA9..10BAF;AL   # No     [7] PSALTER PAHLAVI NUMBER ONE..PSALTER PAHLAVI NUMBER ONE HUNDRED
10C00..10C48;AL   # Lo    [73] OLD TURKIC LETTER ORKHON A..OLD TURKIC LETTER ORKHON BASH
10E60..10E7E;AL   # No    [31] RUMI DIGIT ONE..RUMI FRACTION TWO THIRDS
11000;CM          # Mc         BRAHMI SIGN CANDRABINDU
11001;CM          # Mn         BRAHMI SIGN ANUSVARA
11002;CM          # Mc         BRAHMI SIGN VISARGA
11003..11037;AL   # Lo    [53] BRAHMI SIGN JIHVAMULIYA..BRAHMI LETTER OLD TAMIL NNNA
11038..11046;CM   # Mn    [15] BRAHMI VOWEL SIGN AA..BRAHMI VIRAMA
11047..11048;BA   # Po     [2] BRAHMI DANDA..BRAHMI DOUBLE DANDA
11049..1104D;AL   # Po     [5] BRAHMI PUNCTUATION DOT..BRAHMI PUNCTUATION LOTUS
11052..11065;AL   # No    [20] BRAHMI NUMBER ONE..BRAHMI NUMBER ONE THOUSAND
11066..1106F;NU   # Nd    [10] BRAHMI DIGIT ZERO..BRAHMI DIGIT NINE
1107F;CM          # Mn         BRAHMI NUMBER JOINER
11080..11081;CM   # Mn     [2] KAITHI SIGN CANDRABINDU..KAITHI SIGN ANUSVARA
11082;CM          # Mc         KAITHI SIGN VISARGA
11083..110AF;AL   # Lo    [45] KAITHI LETTER A..KAITHI LETTER HA
110B0..110B2;CM   # Mc     [3] KAITHI VOWEL SIGN AA..KAITHI VOWEL SIGN II
110B3..110B6;CM   # Mn     [4] KAITHI VOWEL SIGN U..KAITHI VOWEL SIGN AI
110B7..110B8;CM   # Mc     [2] KAITHI VOWEL SIGN O..KAITHI VOWEL SIGN AU
110B9..110BA;CM   # Mn     [2] KAITHI SIGN VIRAMA..KAITHI SIGN NUKTA
110BB..110BC;AL   # Po     [2] KAITHI ABBREVIATION SIGN..KAITHI ENUMERATION SIGN
110BD;AL          # Cf         KAITHI NUMBER SIGN
110BE..110C1;BA   # Po     [4] KAITHI SECTION MARK..KAITHI DOUBLE DANDA
110D0..110E8;AL   # Lo    [25] SORA SOMPENG LETTER SAH..SORA SOMPENG LETTER MAE
110F0..110F9;NU   # Nd    [10] SORA SOMPENG DIGIT ZERO..SORA SOMPENG DIGIT NINE
11100..11102;CM   # Mn     [3] CHAKMA SIGN CANDRABINDU..CHAKMA SIGN VISARGA
11103..11126;AL   # Lo    [36] CHAKMA LETTER AA..CHAKMA LETTER HAA
11127..1112B;CM   # Mn     [5] CHAKMA VOWEL SIGN A..CHAKMA VOWEL SIGN UU
1112C;CM          # Mc         CHAKMA VOWEL SIGN E
1112D..11134;CM   # Mn     [8] CHAKMA VOWEL SIGN AI..CHAKMA MAAYYAA
11136..1113F;NU   # Nd    [10] CHAKMA DIGIT ZERO..CHAKMA DIGIT NINE
11140..11143;BA   # Po     [4] CHAKMA SECTION MARK..CHAKMA QUESTION MARK
11150..11172;AL   # Lo    [35] MAHAJANI LETTER A..MAHAJANI LETTER RRA
11173;CM          # Mn         MAHAJANI SIGN NUKTA
11174;AL          # Po         MAHAJANI ABBREVIATION SIGN
11175;BB          # Po         MAHAJANI SECTION MARK
11176;AL          # Lo         MAHAJANI LIGATURE SHRI
11180..11181;CM   # Mn     [2] SHARADA SIGN CANDRABINDU..SHARADA SIGN ANUSVARA
11182;CM          # Mc         SHARADA SIGN VISARGA
11183..111B2;AL   # Lo    [48] SHARADA LETTER A..SHARADA LETTER HA
111B3..111B5;CM   # Mc     [3] SHARADA VOWEL SIGN AA..SHARADA VOWEL SIGN II
111B6..111BE;CM   # Mn     [9] SHARADA VOWEL SIGN U..SHARADA VOWEL SIGN O
111BF..111C0;CM   # Mc     [2] SHARADA VOWEL SIGN AU..SHARADA SIGN VIRAMA
111C1..111C4;AL   # Lo     [4] SHARADA SIGN AVAGRAHA..SHARADA OM
111C5..111C6;BA   # Po     [2] SHARADA DANDA..SHARADA DOUBLE DANDA
111C7;AL          # Po         SHARADA ABBREVIATION SIGN
111C8;BA          # Po         SHARADA SEPARATOR
111CD;AL          # Po         SHARADA SUTRA MARK
111D0..111D9;NU   # Nd    [10] SHARADA DIGIT ZERO..SHARADA DIGIT NINE
111DA;AL          # Lo         SHARADA EKAM
111E1..111F4;AL   # No    [20] SINHALA ARCHAIC DIGIT ONE..SINHALA ARCHAIC NUMBER ONE THOUSAND
11200..11211;AL   # Lo    [18] KHOJKI LETTER A..KHOJKI LETTER JJA
11213..1122B;AL   # Lo    [25] KHOJKI LETTER NYA..KHOJKI LETTER LLA
1122C..1122E;CM   # Mc     [3] KHOJKI VOWEL SIGN AA..KHOJKI VOWEL SIGN II
1122F..11231;CM   # Mn     [3] KHOJKI VOWEL SIGN U..KHOJKI VOWEL SIGN AI
11232..11233;CM   # Mc     [2] KHOJKI VOWEL SIGN O..KHOJKI VOWEL SIGN AU
11234;CM          # Mn         KHOJKI SIGN ANUSVARA
11235;CM          # Mc         KHOJKI SIGN VIRAMA
11236..11237;CM   # Mn     [2] KHOJKI SIGN NUKTA..KHOJKI SIGN SHADDA
11238..11239;BA   # Po     [2] KHOJKI DANDA..KHOJKI DOUBLE DANDA
1123A;AL          # Po         KHOJKI WORD SEPARATOR
1123B..1123C;BA   # Po     [2] KHOJKI SECTION MARK..KHOJKI DOUBLE SECTION MARK
1123D;AL          # Po         KHOJKI ABBREVIATION SIGN
112B0..112DE;AL   # Lo    [47] KHUDAWADI LETTER A..KHUDAWADI LETTER HA
112DF;CM          # Mn         KHUDAWADI SIGN ANUSVARA
112E0..112E2;CM   # Mc     [3] KHUDAWADI VOWEL SIGN AA..KHUDAWADI VOWEL SIGN II
112E3..112EA;CM   # Mn     [8] KHUDAWADI VOWEL SIGN U..KHUDAWADI SIGN VIRAMA
112F0..112F9;NU   # Nd    [10] KHUDAWADI DIGIT ZERO..KHUDAWADI DIGIT NINE
11301;CM          # Mn         GRANTHA SIGN CANDRABINDU
11302..11303;CM   # Mc     [2] GRANTHA SIGN ANUSVARA..GRANTHA SIGN VISARGA
11305..1130C;AL   # Lo     [8] GRANTHA LETTER A..GRANTHA LETTER VOCALIC L
1130F..11310;AL   # Lo     [2] GRANTHA LETTER EE..GRANTHA LETTER AI
11313..11328;AL   # Lo    [22] GRANTHA LETTER OO..GRANTHA LETTER NA
1132A..11330;AL   # Lo     [7] GRANTHA LETTER PA..GRANTHA LETTER RA
11332..11333;AL   # Lo     [2] GRANTHA LETTER LA..GRANTHA LETTER LLA
11335..11339;AL   # Lo     [5] GRANTHA LETTER VA..GRANTHA LETTER HA
1133C;CM          # Mn         GRANTHA SIGN NUKTA
1133D;AL          # Lo         GRANTHA SIGN AVAGRAHA
1133E..1133F;CM   # Mc     [2] GRANTHA VOWEL SIGN AA..GRANTHA VOWEL SIGN I
11340;CM          # Mn         GRANTHA VOWEL SIGN II
11341..11344;CM   # Mc     [4] GRANTHA VOWEL SIGN U..GRANTHA VOWEL SIGN VOCALIC RR
11347..11348;CM   # Mc     [2] GRANTHA VOWEL SIGN EE..GRANTHA VOWEL SIGN AI
1134B..1134D;CM   # Mc     [3] GRANTHA VOWEL SIGN OO..GRANTHA SIGN VIRAMA
11357;CM          # Mc         GRANTHA AU LENGTH MARK
1135D..11361;AL   # Lo     [5] GRANTHA SIGN PLUTA..GRANTHA LETTER VOCALIC LL
11362..11363;CM   # Mc     [2] GRANTHA VOWEL SIGN VOCALIC L..GRANTHA VOWEL SIGN VOCALIC LL
11366..1136C;CM   # Mn     [7] COMBINING GRANTHA DIGIT ZERO..COMBINING GRANTHA DIGIT SIX
11370..11374;CM   # Mn     [5] COMBINING GRANTHA LETTER A..COMBINING GRANTHA LETTER PA
11480..114AF;AL   # Lo    [48] TIRHUTA ANJI..TIRHUTA LETTER HA
114B0..114B2;CM   # Mc     [3] TIRHUTA VOWEL SIGN AA..TIRHUTA VOWEL SIGN II
114B3..114B8;CM   # Mn     [6] TIRHUTA VOWEL SIGN U..TIRHUTA VOWEL SIGN VOCALIC LL
114B9;CM          # Mc         TIRHUTA VOWEL SIGN E
114BA;CM          # Mn         TIRHUTA VOWEL SIGN SHORT E
114BB..114BE;CM   # Mc     [4] TIRHUTA VOWEL SIGN AI..TIRHUTA VOWEL SIGN AU
114BF..114C0;CM   # Mn     [2] TIRHUTA SIGN CANDRABINDU..TIRHUTA SIGN ANUSVARA
114C1;CM          # Mc         TIRHUTA SIGN VISARGA
114C2..114C3;CM   # Mn     [2] TIRHUTA SIGN VIRAMA..TIRHUTA SIGN NUKTA
114C4..114C5;AL   # Lo     [2] TIRHUTA SIGN AVAGRAHA..TIRHUTA GVANG
114C6;AL          # Po         TIRHUTA ABBREVIATION SIGN
114C7;AL          # Lo         TIRHUTA OM
114D0..114D9;NU   # Nd    [10] TIRHUTA DIGIT ZERO..TIRHUTA DIGIT NINE
11580..115AE;AL   # Lo    [47] SIDDHAM LETTER A..SIDDHAM LETTER HA
115AF..115B1;CM   # Mc     [3] SIDDHAM VOWEL SIGN AA..SIDDHAM VOWEL SIGN II
115B2..115B5;CM   # Mn     [4] SIDDHAM VOWEL SIGN U..SIDDHAM VOWEL SIGN VOCALIC RR
115B8..115BB;CM   # Mc     [4] SIDDHAM VOWEL SIGN E..SIDDHAM VOWEL SIGN AU
115BC..115BD;CM   # Mn     [2] SIDDHAM SIGN CANDRABINDU..SIDDHAM SIGN ANUSVARA
115BE;CM          # Mc         SIDDHAM SIGN VISARGA
115BF..115C0;CM   # Mn     [2] SIDDHAM SIGN VIRAMA..SIDDHAM SIGN NUKTA
115C1;BB          # Po         SIDDHAM SIGN SIDDHAM
115C2..115C3;BA   # Po     [2] SIDDHAM DANDA..SIDDHAM DOUBLE DANDA
115C4..115C5;EX   # Po     [2] SIDDHAM SEPARATOR DOT..SIDDHAM SEPARATOR BAR
115C6..115C8;AL   # Po     [3] SIDDHAM REPETITION MARK-1..SIDDHAM REPETITION MARK-3
115C9;BA          # Po         SIDDHAM END OF TEXT MARK
11600..1162F;AL   # Lo    [48] MODI LETTER A..MODI LETTER LLA
11630..11632;CM   # Mc     [3] MODI VOWEL SIGN AA..MODI VOWEL SIGN II
11633..1163A;CM   # Mn     [8] MODI VOWEL SIGN U..MODI VOWEL SIGN AI
1163B..1163C;CM   # Mc     [2] MODI VOWEL SIGN O..MODI VOWEL SIGN AU
1163D;CM          # Mn         MODI SIGN ANUSVARA
1163E;CM          # Mc         MODI SIGN VISARGA
1163F..11640;CM   # Mn     [2] MODI SIGN VIRAMA..MODI SIGN ARDHACANDRA
11641..11642;BA   # Po     [2] MODI DANDA..MODI DOUBLE DANDA
11643;AL          # Po         MODI ABBREVIATION SIGN
11644;AL          # Lo         MODI SIGN HUVA
11650..11659;NU   # Nd    [10] MODI DIGIT ZERO..MODI DIGIT NINE
11680..116AA;AL   # Lo    [43] TAKRI LETTER A..TAKRI LETTER RRA
116AB;CM          # Mn         TAKRI SIGN ANUSVARA
116AC;CM          # Mc         TAKRI SIGN VISARGA
116AD;CM          # Mn         TAKRI VOWEL SIGN AA
116AE..116AF;CM   # Mc     [2] TAKRI VOWEL SIGN I..TAKRI VOWEL SIGN II
116B0..116B5;CM   # Mn     [6] TAKRI VOWEL SIGN U..TAKRI VOWEL SIGN AU
116B6;CM          # Mc         TAKRI SIGN VIRAMA
116B7;CM          # Mn         TAKRI SIGN NUKTA
116C0..116C9;NU   # Nd    [10] TAKRI DIGIT ZERO..TAKRI DIGIT NINE
118A0..118DF;AL   # L&    [64] WARANG CITI CAPITAL LETTER NGAA..WARANG CITI SMALL LETTER VIYO
118E0..118E9;NU   # Nd    [10] WARANG CITI DIGIT ZERO..WARANG CITI DIGIT NINE
118EA..118F2;AL   # No     [9] WARANG CITI NUMBER TEN..WARANG CITI NUMBER NINETY
118FF;AL          # Lo         WARANG CITI OM
11AC0..11AF8;AL   # Lo    [57] PAU CIN HAU LETTER PA..PAU CIN HAU GLOTTAL STOP FINAL
12000..12398;AL   # Lo   [921] CUNEIFORM SIGN A..CUNEIFORM SIGN UM TIMES ME
12400..1246E;AL   # Nl   [111] CUNEIFORM NUMERIC SIGN TWO ASH..CUNEIFORM NUMERIC SIGN NINE U VARIANT FORM
12470..12474;BA   # Po     [5] CUNEIFORM PUNCTUATION SIGN OLD ASSYRIAN WORD DIVIDER..CUNEIFORM PUNCTUATION SIGN DIAGONAL QUADCOLON
13000..13257;AL   # Lo   [600] EGYPTIAN HIEROGLYPH A001..EGYPTIAN HIEROGLYPH O006
13258..1325A;OP   # Lo     [3] EGYPTIAN HIEROGLYPH O006A..EGYPTIAN HIEROGLYPH O006C
1325B..1325D;CL   # Lo     [3] EGYPTIAN HIEROGLYPH O006D..EGYPTIAN HIEROGLYPH O006F
1325E..13281;AL   # Lo    [36] EGYPTIAN HIEROGLYPH O007..EGYPTIAN HIEROGLYPH O033
13282;CL          # Lo         EGYPTIAN HIEROGLYPH O033A
13283..13285;AL   # Lo     [3] EGYPTIAN HIEROGLYPH O034..EGYPTIAN HIEROGLYPH O036
13286;OP          # Lo         EGYPTIAN HIEROGLYPH O036A
13287;CL          # Lo         EGYPTIAN HIEROGLYPH O036B
13288;OP          # Lo         EGYPTIAN HIEROGLYPH O036C
13289;CL          # Lo         EGYPTIAN HIEROGLYPH O036D
1328A..13378;AL   # Lo   [239] EGYPTIAN HIEROGLYPH O037..EGYPTIAN HIEROGLYPH V011
13379;OP          # Lo         EGYPTIAN HIEROGLYPH V011A
1337A..1337B;CL   # Lo     [2] EGYPTIAN HIEROGLYPH V011B..EGYPTIAN HIEROGLYPH V011C
1337C..1342E;AL   # Lo   [179] EGYPTIAN HIEROGLYPH V012..EGYPTIAN HIEROGLYPH AA032
16800..16A38;AL   # Lo   [569] BAMUM LETTER PHASE-A NGKUE MFON..BAMUM LETTER PHASE-F VUEQ
16A40..16A5E;AL   # Lo    [31] MRO LETTER TA..MRO LETTER TEK
16A60..16A69;NU   # Nd    [10] MRO DIGIT ZERO..MRO DIGIT NINE
16A6E..16A6F;BA   # Po     [2] MRO DANDA..MRO DOUBLE DANDA
16AD0..16AED;AL   # Lo    [30] BASSA VAH LETTER ENNI..BASSA VAH LETTER I
16AF0..16AF4;CM   # Mn     [5] BASSA VAH COMBINING HIGH TONE..BASSA VAH COMBINING HIGH-LOW TONE
16AF5;BA          # Po         BASSA VAH FULL STOP
16B00..16B2F;AL   # Lo    [48] PAHAWH HMONG VOWEL KEEB..PAHAWH HMONG CONSONANT CAU
16B30..16B36;CM   # Mn     [7] PAHAWH HMONG MARK CIM TUB..PAHAWH HMONG MARK CIM TAUM
16B37..16B39;BA   # Po     [3] PAHAWH HMONG SIGN VOS THOM..PAHAWH HMONG SIGN CIM CHEEM
16B3A..16B3B;AL   # Po     [2] PAHAWH HMONG SIGN VOS THIAB..PAHAWH HMONG SIGN VOS FEEM
16B3C..16B3F;AL   # So     [4] PAHAWH HMONG SIGN XYEEM NTXIV..PAHAWH HMONG SIGN XYEEM FAIB
16B40..16B43;AL   # Lm     [4] PAHAWH HMONG SIGN VOS SEEV..PAHAWH HMONG SIGN IB YAM
16B44;BA          # Po         PAHAWH HMONG SIGN XAUS
16B45;AL          # So         PAHAWH HMONG SIGN CIM TSOV ROG
16B50..16B59;NU   # Nd    [10] PAHAWH HMONG DIGIT ZERO..PAHAWH HMONG DIGIT NINE
16B5B..16B61;AL   # No     [7] PAHAWH HMONG NUMBER TENS..PAHAWH HMONG NUMBER TRILLIONS
16B63..16B77;AL   # Lo    [21] PAHAWH HMONG SIGN VOS LUB..PAHAWH HMONG SIGN CIM NRES TOS
16B7D..16B8F;AL   # Lo    [19] PAHAWH HMONG CLAN SIGN TSHEEJ..PAHAWH HMONG CLAN SIGN VWJ
16F00..16F44;AL   # Lo    [69] MIAO LETTER PA..MIAO LETTER HHA
16F50;AL          # Lo         MIAO LETTER NASALIZATION
16F51..16F7E;CM   # Mc    [46] MIAO SIGN ASPIRATION..MIAO VOWEL SIGN NG
16F8F..16F92;CM   # Mn     [4] MIAO TONE RIGHT..MIAO TONE BELOW
16F93..16F9F;AL   # Lm    [13] MIAO LETTER TONE-2..MIAO LETTER REFORMED TONE-8
1B000..1B001;ID   # Lo     [2] KATAKANA LETTER ARCHAIC E..HIRAGANA LETTER ARCHAIC YE
1BC00..1BC6A;AL   # Lo   [107] DUPLOYAN LETTER H..DUPLOYAN LETTER VOCALIC M
1BC70..1BC7C;AL   # Lo    [13] DUPLOYAN AFFIX LEFT HORIZONTAL SECANT..DUPLOYAN AFFIX ATTACHED TANGENT HOOK
1BC80..1BC88;AL   # Lo     [9] DUPLOYAN AFFIX HIGH ACUTE..DUPLOYAN AFFIX HIGH VERTICAL
1BC90..1BC99;AL   # Lo    [10] DUPLOYAN AFFIX LOW ACUTE..DUPLOYAN AFFIX LOW ARROW
1BC9C;AL          # So         DUPLOYAN SIGN O WITH CROSS
1BC9D..1BC9E;CM   # Mn     [2] DUPLOYAN THICK LETTER SELECTOR..DUPLOYAN DOUBLE MARK
1BC9F;BA          # Po         DUPLOYAN PUNCTUATION CHINOOK FULL STOP
1BCA0..1BCA3;CM   # Cf     [4] SHORTHAND FORMAT LETTER OVERLAP..SHORTHAND FORMAT UP STEP
1D000..1D0F5;AL   # So   [246] BYZANTINE MUSICAL SYMBOL PSILI..BYZANTINE MUSICAL SYMBOL GORGON NEO KATO
1D100..1D126;AL   # So    [39] MUSICAL SYMBOL SINGLE BARLINE..MUSICAL SYMBOL DRUM CLEF-2
1D129..1D164;AL   # So    [60] MUSICAL SYMBOL MULTIPLE MEASURE REST..MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH NOTE
1D165..1D166;CM   # Mc     [2] MUSICAL SYMBOL COMBINING STEM..MUSICAL SYMBOL COMBINING SPRECHGESANG STEM
1D167..1D169;CM   # Mn     [3] MUSICAL SYMBOL COMBINING TREMOLO-1..MUSICAL SYMBOL COMBINING TREMOLO-3
1D16A..1D16C;AL   # So     [3] MUSICAL SYMBOL FINGERED TREMOLO-1..MUSICAL SYMBOL FINGERED TREMOLO-3
1D16D..1D172;CM   # Mc     [6] MUSICAL SYMBOL COMBINING AUGMENTATION DOT..MUSICAL SYMBOL COMBINING FLAG-5
1D173..1D17A;CM   # Cf     [8] MUSICAL SYMBOL BEGIN BEAM..MUSICAL SYMBOL END PHRASE
1D17B..1D182;CM   # Mn     [8] MUSICAL SYMBOL COMBINING ACCENT..MUSICAL SYMBOL COMBINING LOURE
1D183..1D184;AL   # So     [2] MUSICAL SYMBOL ARPEGGIATO UP..MUSICAL SYMBOL ARPEGGIATO DOWN
1D185..1D18B;CM   # Mn     [7] MUSICAL SYMBOL COMBINING DOIT..MUSICAL SYMBOL COMBINING TRIPLE TONGUE
1D18C..1D1A9;AL   # So    [30] MUSICAL SYMBOL RINFORZANDO..MUSICAL SYMBOL DEGREE SLASH
1D1AA..1D1AD;CM   # Mn     [4] MUSICAL SYMBOL COMBINING DOWN BOW..MUSICAL SYMBOL COMBINING SNAP PIZZICATO
1D1AE..1D1DD;AL   # So    [48] MUSICAL SYMBOL PEDAL MARK..MUSICAL SYMBOL PES SUBPUNCTIS
1D200..1D241;AL   # So    [66] GREEK VOCAL NOTATION SYMBOL-1..GREEK INSTRUMENTAL NOTATION SYMBOL-54
1D242..1D244;CM   # Mn     [3] COMBINING GREEK MUSICAL TRISEME..COMBINING GREEK MUSICAL PENTASEME
1D245;AL          # So         GREEK MUSICAL LEIMMA
1D300..1D356;AL   # So    [87] MONOGRAM FOR EARTH..TETRAGRAM FOR FOSTERING
1D360..1D371;AL   # No    [18] COUNTING ROD UNIT DIGIT ONE..COUNTING ROD TENS DIGIT NINE
1D400..1D454;AL   # L&    [85] MATHEMATICAL BOLD CAPITAL A..MATHEMATICAL ITALIC SMALL G
1D456..1D49C;AL   # L&    [71] MATHEMATICAL ITALIC SMALL I..MATHEMATICAL SCRIPT CAPITAL A
1D49E..1D49F;AL   # Lu     [2] MATHEMATICAL SCRIPT CAPITAL C..MATHEMATICAL SCRIPT CAPITAL D
1D4A2;AL          # Lu         MATHEMATICAL SCRIPT CAPITAL G
1D4A5..1D4A6;AL   # Lu     [2] MATHEMATICAL SCRIPT CAPITAL J..MATHEMATICAL SCRIPT CAPITAL K
1D4A9..1D4AC;AL   # Lu     [4] MATHEMATICAL SCRIPT CAPITAL N..MATHEMATICAL SCRIPT CAPITAL Q
1D4AE..1D4B9;AL   # L&    [12] MATHEMATICAL SCRIPT CAPITAL S..MATHEMATICAL SCRIPT SMALL D
1D4BB;AL          # Ll         MATHEMATICAL SCRIPT SMALL F
1D4BD..1D4C3;AL   # Ll     [7] MATHEMATICAL SCRIPT SMALL H..MATHEMATICAL SCRIPT SMALL N
1D4C5..1D505;AL   # L&    [65] MATHEMATICAL SCRIPT SMALL P..MATHEMATICAL FRAKTUR CAPITAL B
1D507..1D50A;AL   # Lu     [4] MATHEMATICAL FRAKTUR CAPITAL D..MATHEMATICAL FRAKTUR CAPITAL G
1D50D..1D514;AL   # Lu     [8] MATHEMATICAL FRAKTUR CAPITAL J..MATHEMATICAL FRAKTUR CAPITAL Q
1D516..1D51C;AL   # Lu     [7] MATHEMATICAL FRAKTUR CAPITAL S..MATHEMATICAL FRAKTUR CAPITAL Y
1D51E..1D539;AL   # L&    [28] MATHEMATICAL FRAKTUR SMALL A..MATHEMATICAL DOUBLE-STRUCK CAPITAL B
1D53B..1D53E;AL   # Lu     [4] MATHEMATICAL DOUBLE-STRUCK CAPITAL D..MATHEMATICAL DOUBLE-STRUCK CAPITAL G
1D540..1D544;AL   # Lu     [5] MATHEMATICAL DOUBLE-STRUCK CAPITAL I..MATHEMATICAL DOUBLE-STRUCK CAPITAL M
1D546;AL          # Lu         MATHEMATICAL DOUBLE-STRUCK CAPITAL O
1D54A..1D550;AL   # Lu     [7] MATHEMATICAL DOUBLE-STRUCK CAPITAL S..MATHEMATICAL DOUBLE-STRUCK CAPITAL Y
1D552..1D6A5;AL   # L&   [340] MATHEMATICAL DOUBLE-STRUCK SMALL A..MATHEMATICAL ITALIC SMALL DOTLESS J
1D6A8..1D6C0;AL   # Lu    [25] MATHEMATICAL BOLD CAPITAL ALPHA..MATHEMATICAL BOLD CAPITAL OMEGA
1D6C1;AL          # Sm         MATHEMATICAL BOLD NABLA
1D6C2..1D6DA;AL   # Ll    [25] MATHEMATICAL BOLD SMALL ALPHA..MATHEMATICAL BOLD SMALL OMEGA
1D6DB;AL          # Sm         MATHEMATICAL BOLD PARTIAL DIFFERENTIAL
1D6DC..1D6FA;AL   # L&    [31] MATHEMATICAL BOLD EPSILON SYMBOL..MATHEMATICAL ITALIC CAPITAL OMEGA
1D6FB;AL          # Sm         MATHEMATICAL ITALIC NABLA
1D6FC..1D714;AL   # Ll    [25] MATHEMATICAL ITALIC SMALL ALPHA..MATHEMATICAL ITALIC SMALL OMEGA
1D715;AL          # Sm         MATHEMATICAL ITALIC PARTIAL DIFFERENTIAL
1D716..1D734;AL   # L&    [31] MATHEMATICAL ITALIC EPSILON SYMBOL..MATHEMATICAL BOLD ITALIC CAPITAL OMEGA
1D735;AL          # Sm         MATHEMATICAL BOLD ITALIC NABLA
1D736..1D74E;AL   # Ll    [25] MATHEMATICAL BOLD ITALIC SMALL ALPHA..MATHEMATICAL BOLD ITALIC SMALL OMEGA
1D74F;AL          # Sm         MATHEMATICAL BOLD ITALIC PARTIAL DIFFERENTIAL
1D750..1D76E;AL   # L&    [31] MATHEMATICAL BOLD ITALIC EPSILON SYMBOL..MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA
1D76F;AL          # Sm         MATHEMATICAL SANS-SERIF BOLD NABLA
1D770..1D788;AL   # Ll    [25] MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA..MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA
1D789;AL          # Sm         MATHEMATICAL SANS-SERIF BOLD PARTIAL DIFFERENTIAL
1D78A..1D7A8;AL   # L&    [31] MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL..MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA
1D7A9;AL          # Sm         MATHEMATICAL SANS-SERIF BOLD ITALIC NABLA
1D7AA..1D7C2;AL   # Ll    [25] MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA..MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA
1D7C3;AL          # Sm         MATHEMATICAL SANS-SERIF BOLD ITALIC PARTIAL DIFFERENTIAL
1D7C4..1D7CB;AL   # L&     [8] MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL..MATHEMATICAL BOLD SMALL DIGAMMA
1D7CE..1D7FF;NU   # Nd    [50] MATHEMATICAL BOLD DIGIT ZERO..MATHEMATICAL MONOSPACE DIGIT NINE
1E800..1E8C4;AL   # Lo   [197] MENDE KIKAKUI SYLLABLE M001 KI..MENDE KIKAKUI SYLLABLE M060 NYON
1E8C7..1E8CF;AL   # No     [9] MENDE KIKAKUI DIGIT ONE..MENDE KIKAKUI DIGIT NINE
1E8D0..1E8D6;CM   # Mn     [7] MENDE KIKAKUI COMBINING NUMBER TEENS..MENDE KIKAKUI COMBINING NUMBER MILLIONS
1EE00..1EE03;AL   # Lo     [4] ARABIC MATHEMATICAL ALEF..ARABIC MATHEMATICAL DAL
1EE05..1EE1F;AL   # Lo    [27] ARABIC MATHEMATICAL WAW..ARABIC MATHEMATICAL DOTLESS QAF
1EE21..1EE22;AL   # Lo     [2] ARABIC MATHEMATICAL INITIAL BEH..ARABIC MATHEMATICAL INITIAL JEEM
1EE24;AL          # Lo         ARABIC MATHEMATICAL INITIAL HEH
1EE27;AL          # Lo         ARABIC MATHEMATICAL INITIAL HAH
1EE29..1EE32;AL   # Lo    [10] ARABIC MATHEMATICAL INITIAL YEH..ARABIC MATHEMATICAL INITIAL QAF
1EE34..1EE37;AL   # Lo     [4] ARABIC MATHEMATICAL INITIAL SHEEN..ARABIC MATHEMATICAL INITIAL KHAH
1EE39;AL          # Lo         ARABIC MATHEMATICAL INITIAL DAD
1EE3B;AL          # Lo         ARABIC MATHEMATICAL INITIAL GHAIN
1EE42;AL          # Lo         ARABIC MATHEMATICAL TAILED JEEM
1EE47;AL          # Lo         ARABIC MATHEMATICAL TAILED HAH
1EE49;AL          # Lo         ARABIC MATHEMATICAL TAILED YEH
1EE4B;AL          # Lo         ARABIC MATHEMATICAL TAILED LAM
1EE4D..1EE4F;AL   # Lo     [3] ARABIC MATHEMATICAL TAILED NOON..ARABIC MATHEMATICAL TAILED AIN
1EE51..1EE52;AL   # Lo     [2] ARABIC MATHEMATICAL TAILED SAD..ARABIC MATHEMATICAL TAILED QAF
1EE54;AL          # Lo         ARABIC MATHEMATICAL TAILED SHEEN
1EE57;AL          # Lo         ARABIC MATHEMATICAL TAILED KHAH
1EE59;AL          # Lo         ARABIC MATHEMATICAL TAILED DAD
1EE5B;AL          # Lo         ARABIC MATHEMATICAL TAILED GHAIN
1EE5D;AL          # Lo         ARABIC MATHEMATICAL TAILED DOTLESS NOON
1EE5F;AL          # Lo         ARABIC MATHEMATICAL TAILED DOTLESS QAF
1EE61..1EE62;AL   # Lo     [2] ARABIC MATHEMATICAL STRETCHED BEH..ARABIC MATHEMATICAL STRETCHED JEEM
1EE64;AL          # Lo         ARABIC MATHEMATICAL STRETCHED HEH
1EE67..1EE6A;AL   # Lo     [4] ARABIC MATHEMATICAL STRETCHED HAH..ARABIC MATHEMATICAL STRETCHED KAF
1EE6C..1EE72;AL   # Lo     [7] ARABIC MATHEMATICAL STRETCHED MEEM..ARABIC MATHEMATICAL STRETCHED QAF
1EE74..1EE77;AL   # Lo     [4] ARABIC MATHEMATICAL STRETCHED SHEEN..ARABIC MATHEMATICAL STRETCHED KHAH
1EE79..1EE7C;AL   # Lo     [4] ARABIC MATHEMATICAL STRETCHED DAD..ARABIC MATHEMATICAL STRETCHED DOTLESS BEH
1EE7E;AL          # Lo         ARABIC MATHEMATICAL STRETCHED DOTLESS FEH
1EE80..1EE89;AL   # Lo    [10] ARABIC MATHEMATICAL LOOPED ALEF..ARABIC MATHEMATICAL LOOPED YEH
1EE8B..1EE9B;AL   # Lo    [17] ARABIC MATHEMATICAL LOOPED LAM..ARABIC MATHEMATICAL LOOPED GHAIN
1EEA1..1EEA3;AL   # Lo     [3] ARABIC MATHEMATICAL DOUBLE-STRUCK BEH..ARABIC MATHEMATICAL DOUBLE-STRUCK DAL
1EEA5..1EEA9;AL   # Lo     [5] ARABIC MATHEMATICAL DOUBLE-STRUCK WAW..ARABIC MATHEMATICAL DOUBLE-STRUCK YEH
1EEAB..1EEBB;AL   # Lo    [17] ARABIC MATHEMATICAL DOUBLE-STRUCK LAM..ARABIC MATHEMATICAL DOUBLE-STRUCK GHAIN
1EEF0..1EEF1;AL   # Sm     [2] ARABIC MATHEMATICAL OPERATOR MEEM WITH HAH WITH TATWEEL..ARABIC MATHEMATICAL OPERATOR HAH WITH DAL
1F000..1F02B;ID   # So    [44] MAHJONG TILE EAST WIND..MAHJONG TILE BACK
1F030..1F093;ID   # So   [100] DOMINO TILE HORIZONTAL BACK..DOMINO TILE VERTICAL-06-06
1F0A0..1F0AE;ID   # So    [15] PLAYING CARD BACK..PLAYING CARD KING OF SPADES
1F0B1..1F0BF;ID   # So    [15] PLAYING CARD ACE OF HEARTS..PLAYING CARD RED JOKER
1F0C1..1F0CF;ID   # So    [15] PLAYING CARD ACE OF DIAMONDS..PLAYING CARD BLACK JOKER
1F0D1..1F0F5;ID   # So    [37] PLAYING CARD ACE OF CLUBS..PLAYING CARD TRUMP-21
1F100..1F10C;AI   # No    [13] DIGIT ZERO FULL STOP..DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ZERO
1F110..1F12D;AI   # So    [30] PARENTHESIZED LATIN CAPITAL LETTER A..CIRCLED CD
1F12E;AL          # So         CIRCLED WZ
1F130..1F169;AI   # So    [58] SQUARED LATIN CAPITAL LETTER A..NEGATIVE CIRCLED LATIN CAPITAL LETTER Z
1F16A..1F16B;AL   # So     [2] RAISED MC SIGN..RAISED MD SIGN
1F170..1F19A;AI   # So    [43] NEGATIVE SQUARED LATIN CAPITAL LETTER A..SQUARED VS
1F1E6..1F1FF;RI   # So    [26] REGIONAL INDICATOR SYMBOL LETTER A..REGIONAL INDICATOR SYMBOL LETTER Z
1F200..1F202;ID   # So     [3] SQUARE HIRAGANA HOKA..SQUARED KATAKANA SA
1F210..1F23A;ID   # So    [43] SQUARED CJK UNIFIED IDEOGRAPH-624B..SQUARED CJK UNIFIED IDEOGRAPH-55B6
1F240..1F248;ID   # So     [9] TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-672C..TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-6557
1F250..1F251;ID   # So     [2] CIRCLED IDEOGRAPH ADVANTAGE..CIRCLED IDEOGRAPH ACCEPT
1F300..1F32C;ID   # So    [45] CYCLONE..WIND BLOWING FACE
1F330..1F37D;ID   # So    [78] CHESTNUT..FORK AND KNIFE WITH PLATE
1F380..1F39B;ID   # So    [28] RIBBON..CONTROL KNOBS
1F39C..1F39D;AL   # So     [2] BEAMED ASCENDING MUSICAL NOTES..BEAMED DESCENDING MUSICAL NOTES
1F39E..1F3B4;ID   # So    [23] FILM FRAMES..FLOWER PLAYING CARDS
1F3B5..1F3B6;AL   # So     [2] MUSICAL NOTE..MULTIPLE MUSICAL NOTES
1F3B7..1F3BB;ID   # So     [5] SAXOPHONE..VIOLIN
1F3BC;AL          # So         MUSICAL SCORE
1F3BD..1F3CE;ID   # So    [18] RUNNING SHIRT WITH SASH..RACING CAR
1F3D4..1F3F7;ID   # So    [36] SNOW CAPPED MOUNTAIN..LABEL
1F400..1F49F;ID   # So   [160] RAT..HEART DECORATION
1F4A0;AL          # So         DIAMOND SHAPE WITH A DOT INSIDE
1F4A1;ID          # So         ELECTRIC LIGHT BULB
1F4A2;AL          # So         ANGER SYMBOL
1F4A3;ID          # So         BOMB
1F4A4;AL          # So         SLEEPING SYMBOL
1F4A5..1F4AE;ID   # So    [10] COLLISION SYMBOL..WHITE FLOWER
1F4AF;AL          # So         HUNDRED POINTS SYMBOL
1F4B0;ID          # So         MONEY BAG
1F4B1..1F4B2;AL   # So     [2] CURRENCY EXCHANGE..HEAVY DOLLAR SIGN
1F4B3..1F4FE;ID   # So    [76] CREDIT CARD..PORTABLE STEREO
1F500..1F506;AL   # So     [7] TWISTED RIGHTWARDS ARROWS..HIGH BRIGHTNESS SYMBOL
1F507..1F516;ID   # So    [16] SPEAKER WITH CANCELLATION STROKE..BOOKMARK
1F517..1F524;AL   # So    [14] LINK SYMBOL..INPUT SYMBOL FOR LATIN LETTERS
1F525..1F531;ID   # So    [13] FIRE..TRIDENT EMBLEM
1F532..1F549;AL   # So    [24] BLACK SQUARE BUTTON..OM SYMBOL
1F54A;ID          # So         DOVE OF PEACE
1F550..1F579;ID   # So    [42] CLOCK FACE ONE OCLOCK..JOYSTICK
1F57B..1F5A3;ID   # So    [41] LEFT HAND TELEPHONE RECEIVER..BLACK DOWN POINTING BACKHAND INDEX
1F5A5..1F5D3;ID   # So    [47] DESKTOP COMPUTER..SPIRAL CALENDAR PAD
1F5D4..1F5DB;AL   # So     [8] DESKTOP WINDOW..DECREASE FONT SIZE SYMBOL
1F5DC..1F5F3;ID   # So    [24] COMPRESSION..BALLOT BOX WITH BALLOT
1F5F4..1F5F9;AL   # So     [6] BALLOT SCRIPT X..BALLOT BOX WITH BOLD CHECK
1F5FA..1F5FF;ID   # So     [6] WORLD MAP..MOYAI
1F600..1F642;ID   # So    [67] GRINNING FACE..SLIGHTLY SMILING FACE
1F645..1F64F;ID   # So    [11] FACE WITH NO GOOD GESTURE..PERSON WITH FOLDED HANDS
1F650..1F675;AL   # So    [38] NORTH WEST POINTING LEAF..SWASH AMPERSAND ORNAMENT
1F676..1F678;QU   # So     [3] SANS-SERIF HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT..SANS-SERIF HEAVY LOW DOUBLE COMMA QUOTATION MARK ORNAMENT
1F679..1F67B;NS   # So     [3] HEAVY INTERROBANG ORNAMENT..HEAVY SANS-SERIF INTERROBANG ORNAMENT
1F67C..1F67F;AL   # So     [4] VERY HEAVY SOLIDUS..REVERSE CHECKER BOARD
1F680..1F6CF;ID   # So    [80] ROCKET..BED
1F6E0..1F6EC;ID   # So    [13] HAMMER AND WRENCH..AIRPLANE ARRIVING
1F6F0..1F6F3;ID   # So     [4] SATELLITE..PASSENGER SHIP
1F700..1F773;AL   # So   [116] ALCHEMICAL SYMBOL FOR QUINTESSENCE..ALCHEMICAL SYMBOL FOR HALF OUNCE
1F780..1F7D4;AL   # So    [85] BLACK LEFT-POINTING ISOSCELES RIGHT TRIANGLE..HEAVY TWELVE POINTED PINWHEEL STAR
1F800..1F80B;AL   # So    [12] LEFTWARDS ARROW WITH SMALL TRIANGLE ARROWHEAD..DOWNWARDS ARROW WITH LARGE TRIANGLE ARROWHEAD
1F810..1F847;AL   # So    [56] LEFTWARDS ARROW WITH SMALL EQUILATERAL ARROWHEAD..DOWNWARDS HEAVY ARROW
1F850..1F859;AL   # So    [10] LEFTWARDS SANS-SERIF ARROW..UP DOWN SANS-SERIF ARROW
1F860..1F887;AL   # So    [40] WIDE-HEADED LEFTWARDS LIGHT BARB ARROW..WIDE-HEADED SOUTH WEST VERY HEAVY BARB ARROW
1F890..1F8AD;AL   # So    [30] LEFTWARDS TRIANGLE ARROWHEAD..WHITE ARROW SHAFT WIDTH TWO THIRDS
20000..2A6D6;ID   # Lo [42711] CJK UNIFIED IDEOGRAPH-20000..CJK UNIFIED IDEOGRAPH-2A6D6
2A6D7..2A6FF;ID   # Cn    [41] <reserved-2A6D7>..<reserved-2A6FF>
2A700..2B734;ID   # Lo  [4149] CJK UNIFIED IDEOGRAPH-2A700..CJK UNIFIED IDEOGRAPH-2B734
2B735..2B73F;ID   # Cn    [11] <reserved-2B735>..<reserved-2B73F>
2B740..2B81D;ID   # Lo   [222] CJK UNIFIED IDEOGRAPH-2B740..CJK UNIFIED IDEOGRAPH-2B81D
2B81E..2F7FF;ID   # Cn [16354] <reserved-2B81E>..<reserved-2F7FF>
2F800..2FA1D;ID   # Lo   [542] CJK COMPATIBILITY IDEOGRAPH-2F800..CJK COMPATIBILITY IDEOGRAPH-2FA1D
2FA1E..2FFFD;ID   # Cn  [1504] <reserved-2FA1E>..<reserved-2FFFD>
30000..3FFFD;ID   # Cn [65534] <reserved-30000>..<reserved-3FFFD>
E0001;CM          # Cf         LANGUAGE TAG
E0020..E007F;CM   # Cf    [96] TAG SPACE..CANCEL TAG
E0100..E01EF;CM   # Mn   [240] VARIATION SELECTOR-17..VARIATION SELECTOR-256
F0000..FFFFD;XX   # Co [65534] <private-use-F0000>..<private-use-FFFFD>
100000..10FFFD;XX # Co [65534] <private-use-100000>..<private-use-10FFFD>

# EOF